Package: globaltest
Version: 5.66.0
Date: 2023-03-30
Title: Testing Groups of Covariates/Features for Association with a
        Response Variable, with Applications to Gene Set Testing
Author: Jelle Goeman and Jan Oosting, with contributions by Livio Finos, Aldo Solari, Dominic Edelmann
Maintainer: Jelle Goeman <j.j.goeman@lumc.nl>
Depends: methods, survival
Imports: Biobase, AnnotationDbi, annotate, graphics
Suggests: vsn, golubEsets, KEGGREST, hu6800.db, Rgraphviz, GO.db,
        lungExpression, org.Hs.eg.db, GSEABase, penalized, gss, MASS,
        boot, rpart, mstate
Description: The global test tests groups of covariates (or features) for association with a response variable. This package implements the test with diagnostic plots and multiple testing utilities, along with several functions to facilitate the use of this test for gene set testing of GO and KEGG terms.
License: GPL (>= 2)
biocViews: Microarray, OneChannel, Bioinformatics,
        DifferentialExpression, GO, Pathways
Collate: gt-object.R mlogit.R comparative.R diagnosticplots.R
        focuslevel.R generalizedFdistribution.R genesettesting.R gt.R
        inheritance.R models.R options.R utilities.R goodnessoffit.R
LazyLoad: yes
git_url: https://git.bioconductor.org/packages/globaltest
git_branch: RELEASE_3_23
git_last_commit: 8ca8e77
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:24:00 UTC; biocbuild

##############################################
# Linear model (normal errors)
##############################################
.lineartest <- function(response, Z, X, offset, dir, perms, fromGLM=FALSE) {

  # establish dimensions of the problem
  m <- ncol(Z)
  n <- nrow(Z)

  # fit the null model
  form <- formula(.makeFormula(m>0, !is.null(offset)))
  if (fromGLM)
    Y <- response
  else
    Y <- residuals(lm(form))
  sumYY <- sum(Y*Y)

  # adjust the alternative
  if (m > 0)
    X <- X - Z %*% solve(crossprod(Z), crossprod(Z, X))
  # set columns numerically zero to exactly zero
  csm <- colSums(X*X)
  X[,csm < max(csm)*1e-14] <- 0

  if (perms > 0) {
    # all permutations if possible
    allperms <- npermutations(Y) <= perms
    if (allperms) {
      random <- FALSE
      permY <- allpermutations(Y)
    } else {
      # otherwise random permutations
      random <- TRUE
      permY <- replicate(perms-1, Y[sample(n)])
    }
  }

  # Calculate the test statistic
  # 1: asymptotic version
  if (perms == 0) {
    test <- function(subset, weights, calculateP = TRUE) {
      if (!missing(subset))
        X <- X[,subset,drop=FALSE]
      p <- ncol(X)
      if (p == 0) {
        return(c(p = NA, S = NA, ES = NA, sdS = NA, ncov=0))
      } else {
        if(!missing(weights)) {
          X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
        }
          
        if (p > n) {
          XX <- crossprod(t(X))
          if (dir) XX <- XX + dir * outer(rowSums(X), rowSums(X))
          norm.const <- sum(diag(XX)) / 100
          S <- sum(Y * (XX %*% Y)) / sum(Y*Y)
          if (sumYY == 0) S <- 0
          lams <- eigen(XX, symmetric = TRUE, only.values=TRUE)$values
          lams[1:(n-m)] <- lams[1:(n-m)] - S
  
          # term needed for mean and variance of S for z-score
          var.num <- 2*sum(XX*XX)
  
        } else {
          if (dir && (p > 1)) X <- cbind(X, sqrt(dir) * rowSums(X))
  
          norm.const <- sum(X * X) / 100
          xy <- crossprod(X, Y)
          S <- sum(xy * xy) / sumYY
          if (sumYY == 0) S <- 0
          lams <- eigen(crossprod(X), symmetric = TRUE, only.values=TRUE)$values
          if (length(lams) < n) lams <- c(lams, numeric(n-length(lams)))
          lams[1:(n-m)] <- lams[1:(n-m)] - S
  
          # term needed for mean and variance of S for z-score
          tr.term <- crossprod(X)
          var.num <- 2*sum(tr.term*tr.term)
        }
  
        # mean and variance of S for z-score
        # use series approximation as given in Paolella (2003) 319:
        mu.num <- sum(lams) + (n-m)*S
        mu.den <- n-m
        var.den <- 2*(n-m)
        cov.term <- 2*mu.num
        ES <- (mu.num/mu.den) * (1 - cov.term/(mu.num*mu.den) + var.den/(mu.den^2))
        VarS <- (mu.num^2/mu.den^2) * (var.num/(mu.num^2)  + var.den/(mu.den^2) - 2*cov.term/(mu.num*mu.den))
        
        # repair for case all(X == 0)
        if (norm.const == 0) {
          norm.const <- 1
          ES <- 0
          VarS <- 0
        }
                     
        # calculate the p-value
        if (calculateP)
          p.value <- .getP(lams)
        else
          p.value <- NA
                                        
        # give back
        return(c(p = p.value, S = S/norm.const, ES = ES/norm.const, sdS = sqrt(VarS)/norm.const, ncov=p))
      }
    }
  } else {
  # 2: permutation version
    test <- function(subset, weights, calculateP = TRUE) {          # calculateP not used in permutation testing
      if (!missing(subset))
        X <- X[,subset,drop=FALSE]
      p <- ncol(X)
      if (p == 0) {
        return(c(p = NA, S = NA, ES = NA, sdS = NA, ncov=0))
      } else {
        if(!missing(weights)) {
          X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
        }
        
        if (p > n) {
  
          XX <- crossprod(t(X))
          if (dir) XX <- XX + dir * outer(rowSums(X), rowSums(X))
  
          norm.const <- sum(diag(XX)) * sumYY / 100
  
          S <- sum(Y * (XX %*% Y))
          permS <- colSums(permY * (XX %*% permY))
  
        } else {
          if (dir && (p > 1)) X <- cbind(X, sqrt(dir) * rowSums(X))
  
          norm.const <- sum(X * X) * sumYY / 100
          xy <- crossprod(X, Y)
          S <- sum(xy * xy)
  
          permxy <- crossprod(X, permY)
          permS <- colSums(permxy * permxy)
  
        }
  
        # mean and variance of S for z-score
        ES <- mean(permS)
        VarS <- var(permS)

        # repair for case all(X == 0)
        if (norm.const == 0) 
          norm.const <- 1
  
        # calculate the p-value
        if (allperms)
          p.value <- mean(S*(1-1e-14) <= permS)
        else
          p.value <- mean(S*(1-1e-14) <= c(Inf,permS))
  
        # give back
        return(c(p = p.value, S = S/norm.const, ES = ES/norm.const, sdS = sqrt(VarS)/norm.const, ncov = p))
      }
    }
  }

  # Get the adjusted X matrix
  getX <- function(subset, weights) {
    if (!missing(subset))
      X <- X[,subset,drop=FALSE]
    p <- ncol(X)
    if(!missing(weights)) 
      X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
    X
  }

  # Subjectsplot function
  subjectplot <- function(subset, weights, mirror) {
    if (!missing(subset))
      X <- X[,subset,drop=FALSE]
    p <- ncol(X)
    if(!missing(weights))
      X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
    
    XX <- crossprod(t(X))
    if (dir) XX <- XX + dir * outer(rowSums(X), rowSums(X))
    if (mirror) {
      R <- XX %*% Y * sign(Y)
      ER <- diag(XX) * Y * sign(Y)
    } else {
      R <- XX %*% Y
      ER <- diag(XX) * Y
    }

    norm.const <- mean(abs(ER))

    XXmd <- XX
    diag(XXmd) <- 0
    if (m > 0) XXmd <- XXmd - (XXmd %*% Z) %*% solve(crossprod(Z), t(Z))
    varR <- colSums(XXmd * XXmd) * sumYY / (n-m)

    cbind(R=R/norm.const, ER=ER/norm.const, sdR=sqrt(varR)/norm.const, Y=Y)
  }

  # permutations for permutations histogram
  permutations <- function(subset, weights) {
      if (!perms)
        stop("histogram only for permutation version of the test")

      if (!missing(subset))
        X <- X[,subset,drop=FALSE]
      p <- ncol(X)
      if(!missing(weights))
        X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
      
      if (p > n) {

        XX <- crossprod(t(X))
        if (dir) XX <- XX + dir * outer(rowSums(X), rowSums(X))

        norm.const <- sum(diag(XX)) * sumYY / 100

        S <- sum(Y * (XX %*% Y))
        permS <- colSums(permY * (XX %*% permY))

      } else {
        if (dir && (p > 1)) X <- cbind(X, sqrt(dir) * rowSums(X))

        xy <- crossprod(X, Y)
        S <- sum(xy * xy)
        norm.const <- sum(X * X) * sumYY / 100

        permxy <- crossprod(X, permY)
        permS <- colSums(permxy * permxy)

      }

      return(list(S = S/norm.const, permS = permS/norm.const))
  }

  df <- function() {
    c(n,m,ncol(X))
  }

  nperms <- function() {
    if (perms)
      c(n = ncol(permY), random = random)
    else
      c(0, FALSE)
  }

  cov.names <- function(subset)
    if (missing(subset))
      colnames(X)
    else
      colnames(X[,subset,drop=FALSE])

  dist.cor <- function(subset, weights, transpose = FALSE) {
    if (!missing(subset))
      X <- X[,subset,drop=FALSE]
    p <- ncol(X)
    if(!missing(weights))
      X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
    if (transpose) 
      X <- t(X)
    sds <- sqrt(colSums(X*X))
    sds[sds < max(sds)*1e-14] <- Inf
    crossprod(X) / outer(sds,sds)
  }
  
  getY <- function() Y

  positive <- function(subset) {
    if (!missing(subset))
      X <- X[,subset,drop=FALSE] 
    xy <- crossprod(X, Y)
    drop(xy >= 0)+0
  }

  out <- sys.frame(sys.nframe())

  return(out)
}


##############################################
# Generalized linear model (canonical link functions only)
##############################################
.glmtest <- function(response, Z, X, offset, family, dir, perms) {

  # establish dimensions of the problem
  m <- ncol(Z)
  n <- nrow(Z)

  # fit the null model
  form <- formula(.makeFormula(m>0, !is.null(offset)))
  null.fit <- glm(form, family = family)

  Y <- null.fit$y - fitted.values(null.fit)
  W <- null.fit$weights          

  if (max(abs(W-W[1]))<1e-15)
    out <- .lineartest(Y, Z, X, offset, dir, perms, fromGLM=TRUE)
  else {
    if ((perms > 0) && (!(max(abs(W-W[1]))<1e-15)))
      stop("Generalized linear model with covariates:\n\tPermutation testing is not possible.", call.=FALSE)
  
    if (perms == 0) {
      sqrtW <- sqrt(W)
      # adjust the alternative
      if (m > 0) {
        ZWhf <- Z * matrix(sqrtW, n, m)
        ZW <- Z * matrix(W, n, m)
        X <- X - Z %*% solve(crossprod(ZWhf), t(ZW)) %*% X
        csm <- colSums(X*X)
        X[,csm < max(csm)*1e-14] <- 0
        ZWZinvZW <- solve(crossprod(ZWhf), t(ZWhf))
      }
    } else {
      equal.size.groups <- all(abs(Y) == abs(Y[1])) && (sum(Y) == 0)
      if (equal.size.groups)
        nperms <- npermutations(Y[-1])
      else
        nperms <- npermutations(Y)
      # all permutations if possible
      if (nperms <= perms) {
        random <- FALSE
        if (equal.size.groups)
          permY <- rbind(Y[1], allpermutations(Y[-1]))
        else
          permY <- allpermutations(Y)
      } else {
        # otherwise random permutations
        random <- TRUE
        permY <- replicate(perms-1, Y[sample(n)])
      }
      # adjust the alternative
      if (m > 0)
        X <- X - matrix(colMeans(X), n, ncol(X), byrow=TRUE)
    }
  
    norm.const <- (n-m) / 100
  
    # calculate the test statistic
    # 1: asymptotic version
    if (perms == 0) {
      test <- function(subset, weights, calculateP = TRUE) {
        if (!missing(subset))
          X <- X[,subset,drop=FALSE]
        p <- ncol(X)
        if (p == 0) {
          return(c(p = NA, S = NA, ES = NA, sdS = NA, ncov=0))
        } else {
          if(!missing(weights))
            X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
          
          XX <- crossprod(t(X))
          if (dir) XX <- XX + dir * outer(rowSums(X), rowSums(X))
                         
          S <- sum(Y * (XX %*% Y)) / sum(Y*Y*diag(XX))
    
          # get lambdas
          XX <- XX * outer(sqrtW, sqrtW)
          dXX <- diag(diag(XX))
          if (m > 0) {
            dXX <- dXX - (dXX %*% ZWhf) %*% ZWZinvZW
            dXX <- dXX - crossprod(ZWZinvZW, crossprod(ZWhf, dXX))
          }
    
          if (is.nan(S))
            lams <- 0
          else
            lams <- eigen(XX - S*dXX, symmetric = TRUE, only.values=TRUE)$values
  
          # calculate the p-value
          if (calculateP)
            p.value <- .getP(lams)
          else
            p.value <- NA
    
          # mean and variance of S for z-score                                                           
          # use series approximation as given in Paolella (2003) 319:
          mu.num <- sum(diag(XX))
          mu.den <- sum(diag(dXX))
          var.num <- 2*sum(XX*XX)
          var.den <- 2*sum(dXX*dXX)
          cov.term <- 2*sum(XX*dXX)
    
          ES <- (mu.num/mu.den) * (1 - cov.term/(mu.num*mu.den) + var.den/(mu.den^2))
          VarS <- (mu.num^2/mu.den^2) * (var.num/(mu.num^2)  + var.den/(mu.den^2) - 2*cov.term/(mu.num*mu.den))
    
          # repair for case all(X == 0)
          if (is.na(S)) {
            S <- 0
            ES <- 0
            VarS <- 0
            p.value <- 1
          }
    
          # give back
          return(c(p = p.value, S = S/norm.const, ES = ES/norm.const, sdS = sqrt(VarS)/norm.const, ncov=p))
        }
      }
    } else {
    # 2: permutation version
      test <- function(subset, weights, calculateP=TRUE) {  # calculateP not used in permutation testing
        if (!missing(subset))
          X <- X[,subset,drop=FALSE]
        p <- ncol(X)
        if (p == 0) {
          return(c(p = NA, S = NA, ES = NA, sdS = NA, ncov=0))
        } else {
          if(!missing(weights))
            X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
          
          if (p > n) {
            XX <- crossprod(t(X))
            if (dir) XX <- XX + dir * outer(rowSums(X), rowSums(X))
    
            S <- sum(Y * (XX %*% Y)) / sum(Y*Y*diag(XX))
            permS <- colSums(permY * (XX %*% permY)) / drop(diag(XX) %*% (permY * permY))
    
          } else {
            if (dir) X <- X + dir * matrix(rowSums(X), nrow(X), ncol(X))
    
            diagXX <- rowSums(X * X)
            xy <- crossprod(X, Y)
            S <- sum(xy * xy) / sum(Y*Y*diagXX)
    
            permxy <- crossprod(X, permY)
            permS <- colSums(permxy * permxy) / drop(diagXX %*% (permY * permY))
    
          }
    
          # mean and variance of S for z-score
          ES <- mean(permS)
          VarS <- var(permS)
    
          # calculate the p-value
          p.value <- mean(S <= c(Inf,permS))
    
          # give back
          return(c(p = p.value, S = S/norm.const, ES = ES/norm.const, sdS = sqrt(VarS)/norm.const, ncov=p))
        }
      }
    }
  
    # Get the adjusted X matrix
    getX <- function(subset, weights) {
      if (!missing(subset))
        X <- X[,subset,drop=FALSE]
      p <- ncol(X)
      if(!missing(weights))
        X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
      X
    }
  
    # Subjectsplot function
    subjectplot <- function(subset, weights, mirror) {
      if (!missing(subset))
        X <- X[,subset,drop=FALSE]
      p <- ncol(X)
      if(!missing(weights))
        X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
      
      XX <- crossprod(t(X))
      if (dir) XX <- XX + dir * outer(rowSums(X), rowSums(X))
      if (mirror) {
        R <- XX %*% Y * sign(Y)
        ER <- diag(XX) * Y * sign(Y)
      } else {
        R <- XX %*% Y
        ER <- diag(XX) * Y
      }
  
      norm.const <- mean(abs(ER))
  
      XXmd <- XX
      diag(XXmd) <- 0
      if (m > 0) XXmd <- XXmd - (XXmd %*% ZW %*% solve(crossprod(ZWhf), t(Z)))
      varR <- drop((XXmd * XXmd) %*% W)
  
      cbind(R=R/norm.const, ER=ER/norm.const, sdR=sqrt(varR)/norm.const, Y=Y)
    }
  
    # permutations for permutations histogram
    permutations <- function(subset, weights) {
        if (!perms)
          stop("histogram only for permutation version of the test")
  
        if (!missing(subset))
          X <- X[,subset,drop=FALSE]
        p <- ncol(X)
        if(!missing(weights))
          X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
        
        if (p > n) {
          XX <- crossprod(t(X))
          if (dir) XX <- XX + dir * outer(rowSums(X), rowSums(X))
  
          S <- sum(Y * (XX %*% Y)) / sum(Y*Y*diag(XX))
          permS <- colSums(permY * (XX %*% permY)) / drop(diag(XX) %*% (permY * permY))
  
        } else {
          if (dir) X <- X + dir * matrix(rowSums(X), nrow(X), ncol(X))
  
          diagXX <- rowSums(X * X)
          xy <- crossprod(X, Y)
          S <- sum(xy * xy) / sum(Y*Y*diagXX)
  
          permxy <- crossprod(X, permY)
          permS <- colSums(permxy * permxy) / drop(diagXX %*% (permY * permY))
        }
  
        return(list(S = S/norm.const, permS = permS/norm.const))
    }
  
    df <- function() {
      c(n,m,ncol(X))
    }
  
    nperms <- function() {
      if (perms)
        c(n = ncol(permY), random = random)
      else
        c(0, FALSE)
    }
  
    cov.names <- function(subset)
      if (missing(subset))
        colnames(X)
      else
        colnames(X[,subset,drop=FALSE])
  
    dist.cor <- function(subset, weights, transpose = FALSE) {
      if (!missing(subset))
        X <- X[,subset,drop=FALSE]
      p <- ncol(X)
      if(!missing(weights))
        X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
      if (transpose) 
        X <- t(X)
      sds <- sqrt(colSums(X*X))
      sds[sds < max(sds)*1e-14] <- Inf
      crossprod(X) / outer(sds,sds)
    }
    
    getY <- function() Y
  
    positive <- function(subset, weights) {
      if (!missing(subset))
        X <- X[,subset,drop=FALSE] 
      xy <- crossprod(X, Y)
      drop(xy >= 0)+0
    }
  
    out <- sys.frame(sys.nframe())
  }
  
  return(out)
}


##############################################
# Cox proportional hazards model
##############################################
.coxtest <- function (response, Z, X, offset, dir, perms, strat) {
                                 
  # fit the model
  m <- ncol(Z)
  form <- formula(.makeFormula(m>0, !is.null(offset)))
  fit <- coxph(form, method = "breslow")
  expci <- exp(fit$linear.predictors)
  n <- length(expci)

  # check possibility of permutations
  if ((perms > 0) && (m > 0) | (perms > 0) && !is.null(strat))
    stop("Cox model with covariates and/or strata:\n\tPermutation testing is not possible.", call.=FALSE)

  # extract survival times, strata and risksets
  if (ncol(response) == 2) {
    times <- as.vector(fit$y)[1:n]
    d <- as.vector(fit$y)[(n + 1):(2 * n)]
    if (!is.null(strat)) {
      dtimes <- times[d == 1]
      dstrat <- strat[d == 1]
      unq <- which(!duplicated(cbind(dtimes,dstrat)))
      dtimes <- dtimes[unq]
      dstrat <- dstrat[unq]
      atrisk <- outer(times, dtimes, ">=") * outer(strat, dstrat, "==")
    } else {
      dtimes <- unique(times[d == 1])
      atrisk <- outer(times, dtimes, ">=")
    }
  } else {
    times <- as.vector(fit$y)[(n + 1):(2 * n)]
    start <- as.vector(fit$y)[1:n]
    d <- as.vector(fit$y)[(2*n + 1):(3 * n)]
    if (!is.null(strat)) {
      dtimes <- times[d == 1]
      dstrat <- strat[d == 1]
      unq <- which(!duplicated(cbind(dtimes,dstrat)))
      dtimes <- dtimes[unq]
      dstrat <- dstrat[unq]
      atrisk <- outer(times, dtimes, ">=") * outer(start, dtimes, "<") * outer(strat, dstrat, "==")
    } else {
      dtimes <- unique(times[d == 1])
      atrisk <- outer(times, dtimes, ">=") * outer(start, dtimes, "<") 
    }
  }
  
  ## Construct matrixO
  nd <- length(dtimes)
  if (!is.null(strat)) {
    matrixO <- outer(times, dtimes, "==") * outer(strat, dstrat, "==") * matrix(d, n, nd)
  } else {
    matrixO <- outer(times, dtimes, "==") * matrix(d, n, nd)
  }

  # any ties present?
  ties <- any(colSums(matrixO) > 1)

  # construct relevant matrices
  hazinc <- as.vector(1 / (expci %*% atrisk))
  matrixP <- outer(expci, hazinc, "*") * atrisk
  matrixPO <- matrixP %*% t(matrixO)
  matrixM <- matrix(d, n, nd, byrow=FALSE) * (!atrisk) - matrixPO %*% (!atrisk)
  matrixW <- -crossprod(t(matrixPO))
  diag(matrixW) <- diag(matrixW) + rowSums(matrixPO)
  if (m > 0) {
    ZW <- crossprod(Z, matrixW)
    ZWZ <- ZW %*% Z
    ZWZinvZ <- solve(ZWZ, t(Z))
    X <- X - Z %*% solve(ZWZ, ZW) %*% X
    csm <- colSums(X*X)
    X[,csm < max(csm)*1e-14] <- 0
  }

  # martingale residuals
  Y <- rowSums(matrixPO) - d
                           
  if (perms > 0) {
    # unlike the glm and lm models, we make permutations of the index vector rather than Y itself
    # This is for also being able to permute tr(XXW)
    piy <- seq_along(Y)
    # all permutations if possible
    if (npermutations(piy) <= perms) {
      random <- FALSE
      permIY <- allpermutations(piy)
    } else {
      # otherwise random permutations
      random <- TRUE
      permIY <- replicate(perms-1, piy[sample(n)])
    }
    permY <- matrix(Y[permIY], nrow=length(Y))
  }

  # The test statistic
  if (perms == 0) {
    test <- function(subset, weights, calculateP = TRUE) {   # calculateP not used in survival models
      if (!missing(subset))
        X <- X[,subset,drop=FALSE]
      p <- ncol(X)
      if (p == 0) {
        return(c(p = NA, S = NA, ES = NA, sdS = NA, ncov=0))
      } else {
        if(!missing(weights))
          X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
        
        XX <- crossprod(t(X))
        if (dir) XX <- XX + dir * outer(rowSums(X), rowSums(X))
        Q <- crossprod(Y, XX) %*% Y

        # adjust Q in case of tied survival times
        if (ties) {
          tiecorrect <- sum( sapply(1:length(dtimes), function(i) {
            if (sum(matrixO[,i]) == 1)
              0
            else {
              matrixtie <- outer(matrixO[,i], matrixO[,i])
              diag(matrixtie) <- 0
              sum(XX[as.logical(matrixtie)]) - 2 * sum(matrixP[,i] %*% XX %*% matrixtie) + sum(matrixtie) * (matrixP[,i] %*% XX %*% matrixP[,i])
            }
          }))
          Q <- Q - tiecorrect
        }
  
        # calculate mean and variance of Q
        EQ <- sum(XX * matrixW)
        tussen <- matrix(diag(XX), n, nd) + 2 * XX %*% (matrixM - matrixP)
        matrixT <- tussen - matrix(colSums(matrixP * tussen), n, nd, byrow = TRUE)
        varQ <- sum(matrixPO * ((matrixT * matrixT) %*% t(matrixO)))
  
        # calculate p-value
        Z <- (Q - EQ) / sqrt(varQ)
        p.value <- pnorm(Z, lower.tail = FALSE)
        norm.const <- (n-m) * EQ / 100
  
        # positive = negative association with occurence of the event
  
        # give back
        return(c(p = p.value, S = Q/norm.const, ES = EQ/norm.const, sdS=sqrt(varQ)/norm.const, ncov=p))
      }
    }
  } else {
    test <- function(subset, weights, calculateP = TRUE) {     # calculateP not used in permutation testing
      if (!missing(subset))
        X <- X[,subset,drop=FALSE]
      p <- ncol(X)
      if (p == 0) {
        return(c(p = NA, S = NA, ES = NA, sdS = NA, ncov=0))
      } else {
        if(!missing(weights))
          X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
        
        XX <- crossprod(t(X))
        if (dir) XX <- XX + dir * outer(rowSums(X), rowSums(X))
        Q <- drop(crossprod(Y, XX) %*% Y)
        EQ <- sum(XX * matrixW)
  
        permQ <- colSums(permY * (XX %*% permY))
        permEQ <- apply(permIY, 2, function(prm) {
          pW <- matrixW[prm,prm]
          sum(XX * pW)
        })
  
        norm.const <- (n-m) * EQ / 100
  
        # calculate the p-value
        p.value <- mean(Q - EQ <= c(Inf, permQ - permEQ))
  
        # mean and variance of S for z-score
        ES <- EQ + mean(permQ - permEQ)
        VarS <- var(permQ - permEQ)
        
        # give back
        return(c(p = p.value, S = Q/norm.const, ES = ES/norm.const, sdS = sqrt(VarS)/norm.const, ncov = p))
      }
    }
  }

  # Get the adjusted X matrix
  getX <- function(subset, weights) {
    if (!missing(subset))
      X <- X[,subset,drop=FALSE]
    p <- ncol(X)
    if(!missing(weights))
      X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
    X
  }


  # Subjectsplot function
  subjectplot <- function(subset, weights, mirror) {
    if (!missing(subset))
      X <- X[,subset,drop=FALSE]
    p <- ncol(X)
    if(!missing(weights))
      X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
    
    XX <- crossprod(t(X))
    if (dir) XX <- XX + dir * outer(rowSums(X), rowSums(X))
    if (mirror) {
      R <- drop(XX %*% Y * sign(Y))
      ER <- diag(XX) * Y * sign(Y)
    } else {
      R <- XX %*% Y
      ER <- diag(XX) * Y
    }

    norm.const <- mean(abs(ER))

    XXmd <- XX
    diag(XXmd) <- 0
    if (m > 0) XXmd <- XXmd - XXmd %*% matrixW %*% Z %*% ZWZinvZ
    varR <- diag(XXmd %*% matrixW %*% t(XXmd))

    cbind(R=R/norm.const, ER=ER/norm.const, sdR=sqrt(varR)/norm.const, Y=Y)
  }

  # permutations for permutations histogram
  permutations <- function(subset, weights) {
      if (!perms)
        stop("histogram only for permutation version of the test")

      if (!missing(subset))
        X <- X[,subset,drop=FALSE]
      p <- ncol(X)
      if(!missing(weights))
        X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
      
      XX <- crossprod(t(X))
      if (dir) XX <- XX + dir * outer(rowSums(X), rowSums(X))
      Q <- drop(crossprod(Y, XX) %*% Y)
      EQ <- sum(XX * matrixW)

      permQ <- colSums(permY * (XX %*% permY))
      permEQ <- apply(permIY, 2, function(prm) {
        pW <- matrixW[prm,prm]
        sum(XX * pW)
      })

      norm.const <- (n-m) * EQ / 100

      # calculate the p-value
      permS <- EQ + permQ - permEQ

      return(list(S = Q/norm.const, permS = permS/norm.const))
  }

  df <- function() {
    c(n,m,ncol(X))
  }

  nperms <- function() {
    if (perms)
      c(n = ncol(permY), random = random)
    else
      c(0, FALSE)
  }

  cov.names <- function(subset)
    if (missing(subset))
      colnames(X)
    else
      colnames(X[,subset,drop=FALSE])

  dist.cor <- function(subset, weights, transpose = FALSE) {
    if (!missing(subset))
      X <- X[,subset,drop=FALSE]
    p <- ncol(X)
    if(!missing(weights))
      X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
    if (transpose) 
      X <- t(X)
    sds <- sqrt(colSums(X*X))
    sds[sds < max(sds)*1e-14] <- Inf
    crossprod(X) / outer(sds,sds)
  }
  
  positive <- function(subset, weights) {
    if (!missing(subset))
      X <- X[,subset,drop=FALSE] 
    xy <- crossprod(X, Y)
    drop(xy >= 0)+0
  }
  
  getY <- function() Y

  out <- sys.frame(sys.nframe())

  return(out)
}


##############################################
# Multinomial logistic model
##############################################
.multinomialtest <- function(response, Z, X, dir, perms) {

  # establish dimensions of the problem
  m <- ncol(Z)
  n <- nrow(Z)

  # fit the null model
  form <- formula(.makeFormula(m>0, FALSE))
  null.fit <- mlogit(form)
  fitted <- fitted.values(null.fit)
  G <- ncol(fitted)
  if ((perms > 0) && (!all(sapply(1:G, function(i) all(fitted[,G] == fitted[1,G])))))
    stop("Multinomial model with covariates:\n\tPermutation testing is not possible.", call.=FALSE)
  bY <- as.vector(null.fit@y - fitted)
  cY <- apply(null.fit@y==1, 1, which)
  bX <- diag(G) %x% X
  W <- matrix(0,n*G,n*G)
  for (i in 1:G) 
    for (j in 1:G)
      diag(W[(i-1)*n + 1:n, (j-1)*n + 1:n]) <- if (i==j) fitted[,i]*(1-fitted[,i]) else -fitted[,i]*fitted[,j]

  if (perms == 0) {
    eW <- eigen(W,symmetric=TRUE)
    eW$vectors <- eW$vectors[,1:(n*(G-1)),drop=FALSE]
    eW$values <- eW$values[1:(n*(G-1))]
    halfW <- eW$vectors %*% diag(eW$values^(1/2)) %*% t(eW$vectors)   
    # adjust the alternative
    if (m > 0) {
      bZ <- diag(G) %x% Z       
      bZW <- crossprod(bZ, W)
      eZWZ <- eigen(bZW %*% bZ, symmetric=TRUE)    
      eZWZ$vectors <- eZWZ$vectors[,1:(m*(G-1)),drop=FALSE]
      eZWZ$values <- eZWZ$values[1:(m*(G-1))]
      ZWZinvZW <- eZWZ$vectors %*% diag(1/eZWZ$values, nrow=m*(G-1)) %*% crossprod(eZWZ$vectors, bZW) 
      bX <- bX - bZ %*% (ZWZinvZW %*% bX) 
      csm <- colSums(bX*bX)
      bX[,csm < max(csm)*1e-14] <- 0
    }
  } else {
    equal.size.groups <- all(table(cY)==table(cY)[1])
    if (equal.size.groups)
      nperms <- npermutations(cY[-1])
    else
      nperms <- npermutations(cY)
    # all permutations if possible
    if (nperms <= perms) {
      random <- FALSE
      if (equal.size.groups)
        permY <- rbind(cY[1], allpermutations(cY[-1]))
      else
        permY <- allpermutations(cY)
    } else {         
      # otherwise random permutations
      random <- TRUE
      permY <- replicate(perms-1, cY[sample(n)])
    }
    permY <- apply(permY, 2, function(prm) {
      as.vector(sapply(1:G, function(i) { prm == i }) - fitted)
    }) 
    # adjust the alternative
    if (m > 0) {
      bZ <- diag(G) %x% Z       
      bZW <- crossprod(bZ, W)
      eZWZ <- eigen(bZW %*% bZ, symmetric=TRUE)    
      eZWZ$vectors <- eZWZ$vectors[,1:(m*(G-1)),drop=FALSE]
      eZWZ$values <- eZWZ$values[1:(m*(G-1))]
      ZWZinvZW <- eZWZ$vectors %*% diag(1/eZWZ$values,nrow=m*(G-1)) %*% crossprod(eZWZ$vectors, bZW) 
      bX <- bX - bZ %*% (ZWZinvZW %*% bX) 
      csm <- colSums(bX*bX)
      bX[,csm < max(csm)*1e-14] <- 0
    }
  }

  # utility to select columns of bX
  select.help <- 1:ncol(X)
  names(select.help) <- colnames(X)
  selector <- function(set) outer(ncol(X)*(1:G-1), select.help[set], "+")

  norm.const <- (n-m) / 100

  # calculate the test statistic
  # 1: asymptotic version
  if (perms == 0) {
    test <- function(subset, weights, calculateP = TRUE) {
      if (!missing(subset))
        bX <- bX[,selector(subset),drop=FALSE]
      p <- ncol(bX)/G
      if (p == 0) {
        return(c(p = NA, S = NA, ES = NA, sdS = NA, ncov=0))
      } else {
        if(!missing(weights))
          bX <- bX * matrix(rep(sign(weights)*sqrt(abs(weights)),G), n*G, p*G, byrow = TRUE)
  
        XX <- crossprod(t(bX))
        if (dir) 
          for (i in 1:G) { 
            rs <- rowSums(bX[,p*(i-1)+1:p])
            XX <- XX + dir * outer(rs, rs)
          }
        dXX <- XX
        dXX[(row(XX) - col(XX)) %% n != 0] <- 0
                     
        S <- sum(bY * (XX %*% bY)) / sum(bY * (dXX %*% bY))
  
        # get lambdas
        if (m > 0) {
          dXX <- dXX - bZ %*% (ZWZinvZW %*% dXX)
          dXX <- dXX - dXX %*% t(ZWZinvZW) %*% t(bZ)
        }
        XX <- halfW %*% XX %*% halfW
        dXX <- halfW %*% dXX %*% halfW
        if (is.nan(S))
          lams <- 0
        else
          lams <- eigen(XX - S*dXX, symmetric=TRUE, only.values=TRUE)$values
  
        # calculate the p-value
        if (calculateP)
          p.value <- .getP(lams)
        else
          p.value <- NA
  
        # mean and variance of S for z-score
        # use series approximation as given in Paolella (2003) 319:
        mu.num <- sum(diag(XX))
        mu.den <- sum(diag(dXX))
        var.num <- 2*sum(XX*XX)
        var.den <- 2*sum(dXX*dXX)
        cov.term <- 2*sum(XX*dXX)
  
        ES <- (mu.num/mu.den) * (1 - cov.term/(mu.num*mu.den) + var.den/(mu.den^2))
        VarS <- (mu.num^2/mu.den^2) * (var.num/(mu.num^2)  + var.den/(mu.den^2) - 2*cov.term/(mu.num*mu.den))
  
        # give back
        return(c(p = p.value, S = S/norm.const, ES = ES/norm.const, sdS = sqrt(VarS)/norm.const, ncov=p))
      }
    }
  } else {
  # 2: permutation version
    test <- function(subset, weights, calculateP=TRUE) {  # calculateP not used in permutation testing
      if (!missing(subset))
        bX <- bX[,selector(subset),drop=FALSE]
      p <- ncol(bX)/G
      if (p == 0) {
        return(c(p = NA, S = NA, ES = NA, sdS = NA, ncov=0))
      } else {
        if(!missing(weights))
          bX <- bX * matrix(rep(sign(weights)*sqrt(abs(weights)),G), n*G, p*G, byrow = TRUE)
          
        XX <- crossprod(t(bX))
        if (dir) 
          for (i in 1:G) { 
            rs <- rowSums(bX[,p*(i-1)+1:p])
            XX <- XX + dir * outer(rs, rs)
          }
        dXX <- XX
        dXX[(row(XX) - col(XX)) %% n != 0] <- 0
      
        S <- sum(bY * (XX %*% bY)) / sum(bY * (dXX %*% bY))
        permS <- colSums(permY * (XX %*% permY)) / colSums(permY * (dXX %*% permY))
  
        # mean and variance of S for z-score
        ES <- mean(permS)
        VarS <- var(permS)
  
        # calculate the p-value
        p.value <- mean(S <= c(Inf,permS))
  
        # give back
        return(c(p = p.value, S = S/norm.const, ES = ES/norm.const, sdS = sqrt(VarS)/norm.const, ncov=p))
      }
    }
  }

  # Get the adjusted X matrix
  getX <- function(subset, weights) {
    if (!missing(subset))
      bX <- bX[,selector(subset),drop=FALSE]
    p <- ncol(bX)/G
    if(!missing(weights))
      bX <- bX * matrix(rep(sign(weights)*sqrt(abs(weights)),G), n*G, p*G, byrow = TRUE)
    bX
  }

  # Subjectsplot function
  subjectplot <- function(subset, weights, mirror) {
    if (!missing(subset))
      bX <- bX[,selector(subset),drop=FALSE]
    p <- ncol(bX)/G
    if(!missing(weights))
      bX <- bX * matrix(rep(sign(weights)*sqrt(abs(weights)),G), n*G, p*G, byrow = TRUE)

    XX <- crossprod(t(bX))
    if (dir) 
      for (i in 1:G) { 
        rs <- rowSums(bX[,p*(i-1)+1:p])
        XX <- XX + dir * outer(rs, rs)
      }    
    dXX <- XX
    dXX[(row(XX) - col(XX)) %% n != 0] <- 0

    mY <- matrix(bY, n*G, n)
    mY[(row(mY) - col(mY)) %% n != 0] <- 0
    if (mirror) {
      R <- drop(crossprod(mY, XX %*% bY))
      ER <- drop(crossprod(mY, dXX %*% bY))
    } else 
      stop("mirror=FALSE not appropriate for the multinomial model")

    norm.const <- mean(abs(ER))

    XXmd <- XX - dXX
    if (m > 0) 
      XXmd <- XXmd - XXmd %*% t(ZWZinvZW) %*% t(bZ)
    XXmdW <- crossprod(mY, XXmd) %*% halfW 
    varR <- drop(rowSums(XXmdW * XXmdW))

    cbind(R=R/norm.const, ER=ER/norm.const, sdR=sqrt(varR)/norm.const, Y=cY)
  }

  # permutations for permutations histogram
  permutations <- function(subset, weights) {
      if (!perms)
        stop("histogram only for permutation version of the test")

      if (!missing(subset))
        bX <- bX[,selector(subset),drop=FALSE]
      p <- ncol(bX)/G
      if(!missing(weights))
        bX <- bX * matrix(rep(sign(weights)*sqrt(abs(weights)),G), n*G, p*G, byrow = TRUE)
        
      XX <- crossprod(t(bX))
      if (dir) 
        for (i in 1:G) { 
          rs <- rowSums(bX[,p*(i-1)+1:p])
          XX <- XX + dir * outer(rs, rs)
        }
      dXX <- XX
      dXX[(row(XX) - col(XX)) %% n != 0] <- 0
    
      S <- sum(bY * (XX %*% bY)) / sum(bY * (dXX %*% bY))
      permS <- colSums(permY * (XX %*% permY)) / colSums(permY * (dXX %*% permY))

      return(list(S = S/norm.const, permS = permS/norm.const))
  }

  df <- function() {
    c(n,m,ncol(X))
  }

  nperms <- function() {
    if (perms)
      c(n = ncol(permY), random = random)
    else
      c(0, FALSE)
  }

  cov.names <- function(subset)
    if (missing(subset))
      colnames(X)
    else
      colnames(X[,subset,drop=FALSE])

  dist.cor <- function(subset, weights, transpose=FALSE) {
    if (!missing(subset))
      X <- X[,subset,drop=FALSE]
    p <- ncol(X)
    if(!missing(weights))
      X <- X * matrix(sign(weights)*sqrt(abs(weights)), n, p, byrow = TRUE)
    if (transpose)
      uit <- matrix(0,n,n)
    else
      uit <- matrix(0,p,p)
    for (i in 1:G) {
      rngN <- 1:n + (i-1)*n
      if (m > 0) {
        ZW <- Z * matrix(diag(W[rngN,rngN]), nrow(Z), ncol(Z))
        adjX <- X - Z %*% solve(crossprod(ZW, Z), crossprod(ZW, X))
      } else
        adjX <- X
      if (transpose)
        adjX <- t(adjX)
      sds <- sqrt(colSums(adjX*adjX))
      sds[sds < max(sds)*1e-14] <- Inf
      uit <- uit + crossprod(adjX) / outer(sds,sds)
    }
    uit/G
  }

  
  positive <- function(subset) {
    if (!missing(subset))
      X <- X[,subset,drop=FALSE] 
    drop(apply(cor(X, null.fit@y - fitted), 1, which.max))
  }  
          
  getY <- function() bY

  out <- sys.frame(sys.nframe())
  
  return(out)
}

################################
# setting, storing and viewing options
################################
gt.opt.env <- new.env()
gt.opt.env$trace <- interactive()
gt.opt.env$trim <- FALSE
gt.opt.env$transpose <- FALSE
gt.opt.env$max.print <- Inf
gt.opt.env$warn.deprecated <- TRUE


gt.options <- function(trace, trim, transpose, max.print, warn.deprecated) {
  change <- FALSE
  if (!missing(trace)) {
    gt.opt.env$trace <- trace
    change <- TRUE
  }
  if (!missing(trim)) {
    gt.opt.env$trim <- trim
    change <- TRUE
  }
  if (!missing(transpose)) {
    gt.opt.env$transpose <- transpose
    change <- TRUE
  }
  if (!missing(max.print)) {
    gt.opt.env$max.print <- max.print
    change <- TRUE
  }
  if (!missing(warn.deprecated)) {
    gt.opt.env$warn.deprecated <- warn.deprecated
    change <- TRUE
  }
  if (change)
    invisible(as.list(gt.opt.env))
  else
    as.list(gt.opt.env)
}

gtPS <- function(response, null, data, model = c("linear", "logistic", "cox", "poisson", "multinomial"), ..., 
  	          covs, bdeg = 3, nint= 10, pord = 2, interact = FALSE, robust = FALSE, 
				      termlabels = FALSE, returnZ = FALSE) {
  
  # store the call               
  call <- match.call()                	   
                  	            	
  # missing data
  if (missing(data)) data<-NULL
  if (is.matrix(data)) data <- as.data.frame(data)
  
  # evaluate response, which may be one of the colnames of data
  response <- eval(call$response, data, parent.frame())

  # response model
  if (is(response,"lm") || is(response,"glm") || is(response,"coxph")) {
    data <- eval(response$call$data)
    if (is.null(data)) stop("argument \"data\" in the null model is missing") 
    else data<-as.data.frame(data)
    response<-as.formula(response$call$formula)
  }	

  # settle formula null and vector response if response is a formula
  if (missing(null))
    if (is(response, "formula")) 
      null <- response
    else
      stop("argument \"null\" is missing, with no default") 
      
  if (is(response, "formula")) {
    name.response <-  as.character(eval(response)[[2]])
    response <- eval(attr(terms(response, data=data), "variables"), data, environment(response))[[attr(terms(response, data=data), "response")]]
  } else {
    name.response <- deparse(call$response)
  }

  # covs default
  if (missing(covs)) {
  	if (is(null,"formula"))  {
      if (termlabels || (null[[length(null)]]==".")) covs<-attr(terms(null, data=data), "term.labels") 
      else {
        covs<-all.vars(null, functions = FALSE, unique=TRUE)
	      covs<-covs[!(covs%in%name.response)] 
	    }
  	}
	if (is.data.frame(null) || is.vector(null) || is.matrix(null)) {
	  null <- data.frame(null)
    intercept <- apply(null,2,function(x){all(x==1)})
      if (all(intercept == FALSE)) covs <- colnames(null)  
      else covs <- colnames(null)[-intercept]
    }
  }

  # get the model
  if (missing(model)) {
    if(is(response, "Surv")) 
      model <- "cox"
    else if ((is.factor(response) && length(levels(response)) <= 2) || is.logical(response)) 
      model <- "logistic"
    else if (is.factor(response) && length(levels(response)) > 2)
      model <- "multinomial"
  }
  model <- match.arg(tolower(model), c("linear", "logistic", "cox", "poisson", "multinomial"))

  # null design X0
  if (is(null, "formula")) X0<-model.matrix(null, data) else X0<-null
  m <- ncol(X0)
  n <- nrow(X0)
  form <- formula("response ~ 0 + X0")
  if (model=="cox"){
    intercept <- apply(X0,2,function(x){all(x==1)})
    X0<- X0[,-intercept, drop=F]
  }
  
  # make the hat matrix H
  if (model=="linear") 
    H <- X0 %*% solve(crossprod(X0), t(X0))
  else {
    null.fit <- switch(model,
      logistic = glm(form,  family = "binomial", data=data),
      poisson = glm(form, family = "poisson", data=data),
      cox = coxph(form, method = "breslow", data=data),
      multinomial = mlogit(form, data=data)
    )
    if (model=="logistic" || model=="poisson") {
      W <- null.fit$weights
      sqrtW <- sqrt(W)
      X0Whf <- X0 * matrix(sqrtW, n, m)
      X0W <- X0 * matrix(W, n, m)
      H <- X0 %*% solve(crossprod(X0Whf), t(X0W))
     }
    else if (model == "cox") {
      expci <- exp(null.fit$linear.predictors)
      times <- as.vector(null.fit$y)[1:n]
      d <- as.vector(null.fit$y)[(n+1):(2*n)]
      dtimes <- unique(times[d == 1])
      nd <- length(dtimes)
      matrixO <- outer(times, dtimes, "==") * matrix(d, n, nd)
      ties <- any(colSums(matrixO) > 1)
      atrisk <- outer(times, dtimes, ">=")
      hazinc <- as.vector(1 / (expci %*% atrisk))
      matrixP <- outer(expci, hazinc, "*") * atrisk
      matrixPO <- matrixP %*% t(matrixO)
      matrixM <- matrix(d, n, nd, byrow=FALSE) * (!atrisk) - matrixPO %*% (!atrisk)
      matrixW <- -crossprod(t(matrixPO))
      diag(matrixW) <- diag(matrixW) + rowSums(matrixPO)
      X0W <- crossprod(X0, matrixW)
      X0WX0 <- X0W %*% X0
      X0WX0invX0 <- solve(X0WX0, t(X0))
      H <- X0 %*% solve(X0WX0, X0W)
    }
    else if (model == "multinomial") { #temporary
      H <- X0 %*% solve(crossprod(X0), t(X0))
    }
  }
  
  # smooth terms
  if (interact) sterms<-paste(paste("s(",paste(covs,collapse=","),")", sep=""), covs)
  else sterms<-paste("s(",covs,")", sep="")
  
  # build datacovs
  if (is(null,"formula")) {
    if (is.null(data)) datacovs<-cbind(model.frame(null,data=data),model.matrix(null,data=data))[,covs,drop=F]
    else datacovs<-cbind(data,model.frame(null,data=data),model.matrix(null,data=data))[,covs,drop=F]
  }
  else datacovs<-null[,covs]
  datacovs<-as.data.frame(as.matrix(datacovs))
  covs<-colnames(datacovs)
  p<-ncol(datacovs)

  # arguments: list
  l <- max(length(bdeg)*is.list(bdeg),length(nint)*is.list(nint),length(pord)*is.list(pord))
  if ((is.list(bdeg)|is.list(nint)|is.list(pord)) && l>1) {
    lnames<-c(names(nint),names(pord),names(bdeg))[1:l]
    lvector<-vector("list",l); names(lvector)<-lnames
	if (!is.list(bdeg))	bdeg<-lapply(lvector,function(x){x<-bdeg})
	if (!is.list(nint))	nint<-lapply(lvector,function(x){x<-nint})
	if (!is.list(pord))	pord<-lapply(lvector,function(x){x<-pord})
	
	# check the list of covs
	stopifnot(all(sort(names(bdeg))==sort(names(nint))) && all(sort(names(nint))==sort(names(pord)))) 
	bdeg<-lapply(bdeg,function(x){ if (length(x)==1) rep(x,p) else x})
	nint<-lapply(nint,function(x){ if (length(x)==1) rep(x,p) else x})
	pord<-lapply(pord,function(x){ if (length(x)==1) rep(x,p) else x})
	if (interact) lvector<-lapply(lnames,function(x){prod(unlist(nint[x])+unlist(bdeg[x])) - prod(unlist(pord[x])) }) else 
	lvector<-lapply(lnames,function(x){sum( unlist(nint[x])+unlist(bdeg[x])-unlist(pord[x]) ) } ) 
	names(lvector)<-lnames
	cvector<-c(0,cumsum(lvector))
	crange<-lapply(1:l,function(x){(cvector[x]+1):(cvector[x+1])}) 
	names(crange)<-lnames
	
	# built Z matrix
	if (interact){
	Z<-do.call(cbind, lapply(lapply(lapply(lnames, function(x){ 
		(diag(nrow(H))-H) %*%  btensor(datacovs, unlist(bdeg[x]), unlist(nint[x]), unlist(pord[x])) 
		}), function(z){
	  		z*(1/sqrt(sum(diag(crossprod(z)))))
      		}),unlist))
      	colnames(Z)<-1:ncol(Z)
    }
	else {
	Z<-do.call(cbind, lapply(
	lapply(lnames, function(x){
	do.call(cbind, lapply( lapply( lapply(1:p, function(y){
     (diag(nrow(H))-H) %*% bbase(datacovs[,y],unlist(bdeg[x])[y],unlist(nint[x])[y]) %*% 
     t(ndiff(unlist(nint[x])[y]+unlist(bdeg[x])[y],unlist(pord[x])[y])) %*% 
     solve(crossprod(t( ndiff(unlist(nint[x])[y]+unlist(bdeg[x])[y],unlist(pord[x])[y])))) 
     }), function(z){
	 	z*(1/sqrt(sum(diag(crossprod(z)))))
      	}),unlist))
	}), unlist))
	colnames(Z)<-unlist(lapply(lnames, function(y){
		sapply(1:p,function(x){rep(colnames(datacovs)[x],(unlist(nint[y])[x]+unlist(bdeg[y])[x]-unlist(pord[y])[x])) })
	}))
	}
  
  # result
	if (!robust) res<-gt(response=response, alternative=Z, null=null, data=data, model=model,..., subsets=crange )
	else res<-gt(response=response, alternative=Z, null=null, data=data, model=model, ... )
	res@structure <- lapply(lnames,function(x){data.frame(s.term=sterms,bdeg=unlist(bdeg[x]),nint=unlist(nint[x]),pord=unlist(pord[x]))})
  }	
  
  # arguments: vector
  else {
    if (is.list(bdeg)|is.list(nint)|is.list(pord)) {bdeg<-unlist(bdeg);nint<-unlist(nint);pord<-unlist(pord)}
	  if (length(bdeg)==1) bdeg<-rep(bdeg,p) 
	  if (length(nint)==1) nint<-rep(nint,p) 
	  if (length(pord)==1) pord<-rep(pord,p) 
	  stopifnot(length(c(bdeg,nint,pord))==3*p)
	
  # build Z
	  if (interact) {
		  Z<-btensor(datacovs, bdeg, nint, pord)
	    colnames(Z)<-1:ncol(Z)
	  }
	  else {
	    Z<-do.call(cbind, lapply( lapply( lapply(1:p, function(x){
             (diag(nrow(H))-H) %*% bbase(datacovs[,x],bdeg[x],nint[x]) %*% t(ndiff(nint[x]+bdeg[x],pord[x])) %*% solve(crossprod(t( ndiff(nint[x]+bdeg[x],pord[x])))) 
              }),
      	 function(y){
	  		y*(1/sqrt(sum(diag(crossprod(y)))))
      	}),unlist))
      colnames(Z)<-unlist(sapply(1:p,function(x){paste(colnames(datacovs)[x],1:(nint[x]+bdeg[x]-pord[x]), sep="") }))
	  }
  
  # result
  res<-gt(response=response, alternative=Z, null=null, data=data, model=model,... )
  res@structure <- list(data.frame(s.term=sterms,bdeg,nint,pord))    
  }

  if (!returnZ) return(res)
  else return(list(result=res, Z=Z))
}

###################################################
# External functions for gtPS
###################################################

  ### Extract smooth terms from a gt.object object
setGeneric("sterms", function(object, ...) standardGeneric("sterms"))
setMethod("sterms", "gt.object",
  function(object) {
  if (length(object@structure)==1) as.data.frame(object@structure)
  else object@structure
  }
)


  ### Construct difference matrix of order pord
ndiff <- function(n, pord = 2) {
  if (pord == 0) D <-diag(n)
  else {
  if (pord == 1) { D <- diff(diag(n)) }
  else { D <- diff(ndiff(n, pord - 1)) }
  }
  return(D) 
}
  
  
  ### Truncated p-th power function
tpower <- function(x, t, p)
  (x - t) ^ p * (x > t)


  ### Construct B-spline basis
bbase <- function(x, bdeg, nint){ 
  xl <- min(x) - 0.001*(max(x)-min(x)) 
  xr <- max(x) + 0.001*(max(x)-min(x)) 
  dx <- (xr - xl) / nint
  knots <- seq(xl - bdeg * dx, xr + bdeg * dx, by = dx)
  P <- outer(x, knots, tpower, bdeg)
  n <- dim(P)[2]
  D <- ndiff(n, bdeg + 1) / (gamma(bdeg + 1) * dx ^ bdeg)
  B <- (-1) ^ (bdeg + 1) * P %*% t(D)
  B 
}


  ### Construct tensor product of B-spline bases (reparameterized by Kroneker sum of penalties)
btensor <- function(xs, bdeg, nint, pord, returnU=FALSE){
	p <- ncol(xs)
	stopifnot( p > 1 )
  	qq <- nint + bdeg
  	stopifnot( prod(qq) < 5000 )	
	bigB<-do.call(cbind, lapply(lapply(1:p,function(x){
		bbase(xs[,x], bdeg[x], nint[x])
		}), unlist))
	tpB<-bigB[,( cumsum(qq)[1]-qq[1]+1 ):( cumsum(qq)[1] )]
	ksP<-t(ndiff(ncol(tpB),pord[1])) %*% ndiff(ncol(tpB),pord[1])
	for (j in 2:p) {
      crange<-( cumsum(qq)[j]-qq[j]+1 ):(cumsum(qq)[j])
      qj<-length(crange)
      tpB<-kronecker(tpB, t(rep(1,qj)) ) * kronecker( t(rep(1,ncol(tpB))), bigB[,crange] )
      Pj<-t(ndiff(qj,pord[j])) %*% ndiff(qj,pord[j])
      ksP<-kronecker(diag(qj),ksP) + kronecker( Pj ,diag(ncol(ksP)) )
    }
    P <- reparamZ(Z=tpB, K=ksP)
    if (!returnU) return(P)
    else  {
    U <- reparamZ(Z=tpB, K=ksP, returnU=TRUE)$U
    return(list(P=P, U=U)) }
}


  ### Reparameterize Z
reparamZ <-function (Z, pord, K=NULL, tol = 1e-10, returnU=FALSE) {
  if (is.null(K)) K = t(ndiff(ncol(Z), pord)) %*% ndiff(ncol(Z), pord)
  ek <- eigen(K, symmetric = TRUE)
  nullvals <- ek$values < tol
  if (any(nullvals)) {
    nullK <- ek$vectors[, nullvals]
    U <- Z %*% nullK
    colnames(U)<-1:ncol(U)
    L <- t(sqrt(ek$values[!nullvals]) * t(ek$vectors[, !nullvals]))
    P <- Z %*% L %*% solve(t(L) %*% L)
    colnames(P)<-1:ncol(P)
  }
  else {
    U <- matrix(0, nrow = nrow(Z), ncol = 0)
    P <- Z
  }
  if (!returnU) return(P)
  else return(list(P=P, U=U))
}

  ### Standardize Z
reweighZ <- function(Z, null.fit){
  X0 <- model.matrix(null.fit)
  m <- ncol(X0)
  n <- nrow(X0)
  # make the hat matrix H
  if (attr(null.fit,"class")[1]=="lm") 
    H <- X0 %*% solve(crossprod(X0), t(X0))
  else if ( (attr(null.fit,"class")[1]=="glm")  && (null.fit$family[1]=="binomial" || null.fit$family[1]=="poisson") ) {
    W <- null.fit$weights
    sqrtW <- sqrt(W)
    X0Whf <- X0 * matrix(sqrtW, n, m)
    X0W <- X0 * matrix(W, n, m)
    H <- X0 %*% solve(crossprod(X0Whf), t(X0W))
  }
  else if (attr(null.fit,"class")[1]=="coxph") {
    expci <- exp(null.fit$linear.predictors)
    times <- as.vector(null.fit$y)[1:n]
    d <- as.vector(null.fit$y)[(n+1):(2*n)]
    dtimes <- unique(times[d == 1])
    nd <- length(dtimes)
    matrixO <- outer(times, dtimes, "==") * matrix(d, n, nd)
    ties <- any(colSums(matrixO) > 1)
    atrisk <- outer(times, dtimes, ">=")
    hazinc <- as.vector(1 / (expci %*% atrisk))
    matrixP <- outer(expci, hazinc, "*") * atrisk
    matrixPO <- matrixP %*% t(matrixO)
    matrixM <- matrix(d, n, nd, byrow=FALSE) * (!atrisk) - matrixPO %*% (!atrisk)
    matrixW <- -crossprod(t(matrixPO))
    diag(matrixW) <- diag(matrixW) + rowSums(matrixPO)
    X0W <- crossprod(X0, matrixW)
    X0WX0 <- X0W %*% X0
    X0WX0invX0 <- solve(X0WX0, t(X0))
    H <- X0 %*% solve(X0WX0, X0W)
    }    
  Zadj<-(diag(nrow(H))-H) %*% Z
  Zstar <- Zadj*(1/sqrt(sum(diag(crossprod(Zadj)))))
  return(Zstar)
}


gtLI <- function(response, null, data, ..., covs, iorder=2,
                termlabels = FALSE, standardize = FALSE) {
  
  # store the call               
  call <- match.call()                     
                  	            	
  # missing data
  if (missing(data)) data<-NULL
  if (is.matrix(data)) data <- as.data.frame(data)
  
  # evaluate response, which may be one of the colnames of data
  response <- eval(call$response, data, parent.frame())

  # response model
  if (is(response,"lm") | is(response,"glm") | is(response,"coxph")) {
    data <- eval(response$call$data)
     if (is.null(data)) stop("argument \"data\" in the response model is missing") else data<-as.data.frame(data)
    response<-as.formula(response$call$formula)
  }	

  # settle formula null and vector response if response is a formula
  if (missing(null))
    if (is(response, "formula")) 
      null <- response
    else
      stop("argument \"null\" is missing, with no default") 
      
  if (is(response, "formula")) {
    name.response <-  as.character(eval(response)[[2]])
    response <- eval(attr(terms(response, data=data), "variables"), data, environment(response))[[attr(terms(response, data=data), "response")]]
  } else {
    name.response <- deparse(call$response)
  }

  # covs default
  if (missing(covs)) {
  	if (is(null,"formula"))  {
      if (termlabels || (null[[length(null)]]==".")) covs<-attr(terms(null, data=data), "term.labels") 
      else {
        covs<-all.vars(null, functions = FALSE, unique=TRUE)
	    covs<-covs[!(covs%in%name.response)] 
	  }
  	}
	if (is.data.frame(null) || is.vector(null) || is.matrix(null)) {
	  null <- data.frame(null)
    intercept <- apply(null,2,function(x){all(x==1)})
      if (all(intercept == FALSE)) covs <- colnames(null)  
      else covs <- colnames(null)[-intercept]
    }
  }
  
  covsformula<- as.formula( paste("~ ", paste(covs, collapse= "+")) ) 
  
  # construct alternative formula
  interactions <-as.formula(paste("~(", paste(attr( terms(covsformula) , "term.labels"), collapse= "+") , ")^",iorder) )
  
  # remove terms from alternative that are also in null 
  dup <- attr(terms(interactions, data=data), "term.labels") %in% attr(terms(covsformula, data=data), "term.labels")
  if (all(dup)) stop("all covariates in alternative also in null")  
  if (any(dup)) interactions <- formula(terms(interactions,data=data)[!dup])
  if (is(null,"formula"))  {
  dup2 <- attr(terms(interactions, data=data), "term.labels") %in% attr(terms(null, data=data), "term.labels")
  if (all(dup2)) stop("all covariates in the alternative are also in the null")  
  if (any(dup2)) interactions <- formula(terms(interactions,data=data)[!dup])
  }
  
  # result
  res<-gt(response=response, alternative=interactions, null=null, data=data, standardize=standardize, ...)
  res@structure<-list(interactions=attr(terms.formula(interactions),"term.labels"))
  return(res)
}


gtKS <- function(response, null, data, model = c("linear", "logistic", "cox", "poisson", "multinomial"), ..., 
                covs, quant = .25, metric = c("euclidean", "pearson"), 
                kernel=c("uniform", "exponential", "triangular","neighbours","gauss"),
                robust = FALSE, scale=TRUE, termlabels = FALSE, returnZ = FALSE) {

  # store the call               
  call <- match.call()
  metric <- match.arg(metric)
  kernel <- match.arg(kernel)                	   
   	
  # missing data
  if (missing(data)) data<-NULL
  if (is.matrix(data)) data <- as.data.frame(data)
  
  # evaluate response, which may be one of the colnames of data
  response <- eval(call$response, data, parent.frame())

  # response model
  if (is(response,"lm") | is(response,"glm") | is(response,"coxph")) {
    data <- eval(response$call$data)
     if (is.null(data)) stop("argument \"data\" in the response model is missing") else data<-as.data.frame(data)
    response<-as.formula(response$call$formula)
  }	

  # settle half formula null and vector response if response is a formula
  if (missing(null))
    if (is(response, "formula"))
      null <- response
    else
      stop("argument \"null\" is missing, with no default") 

  if (is(response, "formula")) {
    name.response <-  as.character(eval(response)[[2]])
    response <- eval(attr(terms(response, data=data), "variables"), data, environment(response))[[attr(terms(response, data=data), "response")]]
  } else {
    name.response <- deparse(call$response)
  }

  # covs default
  if (missing(covs)) {
  	if (is(null,"formula"))  {
	  if (termlabels || (null[[length(null)]]==".") ) covs<-attr(terms(null, data=data), "term.labels") 
      else {
        covs<-all.vars(null, functions = FALSE, unique=TRUE)
	    covs<-covs[!(covs%in%name.response)] 
      }
  	}
	if (is.data.frame(null) || is.vector(null) || is.matrix(null)) {
	  null <- data.frame(null)
      intercept <- apply(null,2,function(x){all(x==1)})
        if (all(intercept == FALSE)) covs <- colnames(null)  
        else covs <- colnames(null)[-intercept]
    }
  }

  # build the matrix of selected covs
  if (is(null,"formula")) {
    if (is.null(data)) datacovs<-cbind(model.frame(null,data=data),model.matrix(null,data=data))[,covs,drop=F]
    else datacovs<-cbind(data,model.frame(null,data=data),model.matrix(null,data=data))[,covs,drop=F]
  }
  else datacovs<-null[,covs]
  datacovs<-as.data.frame(as.matrix(datacovs))
  covs<-colnames(datacovs)
  p<-ncol(datacovs)

 # get the model
  if (missing(model)) {
    if(is(response, "Surv")) 
      model <- "cox"
    else if ((is.factor(response) && length(levels(response)) <= 2) || is.logical(response)) 
      model <- "logistic"
    else if (is.factor(response) && length(levels(response)) > 2)
      model <- "multinomial"
  }
  model <- match.arg(tolower(model), c("linear", "logistic", "cox", "poisson", "multinomial"))

  # null design X0
  if (is(null, "formula")) X0<-model.matrix(null, data) else X0<-null
  m <- ncol(X0)
  n <- nrow(X0)
  form <- formula("response ~ 0 + X0")
    
  # make the hat matrix H
  if (model=="linear") 
    H <- X0 %*% solve(crossprod(X0), t(X0))
  else {
    null.fit <- switch(model,
      logistic = glm(form, family = "binomial", data=data),
      poisson = glm(form, family = "poisson", data=data),
      cox = coxph(form, method = "breslow", data=data),
      multinomial = mlogit(form, data=data)
    )
    if (model=="logistic" || model=="poisson") {
      W <- null.fit$weights
      sqrtW <- sqrt(W)
      X0Whf <- X0 * matrix(sqrtW, n, m)
      X0W <- X0 * matrix(W, n, m)
      H <- X0 %*% solve(crossprod(X0Whf), t(X0W))
     }
    else if (model == "cox") {
      expci <- exp(null.fit$linear.predictors)
      times <- as.vector(null.fit$y)[1:n]
      d <- as.vector(null.fit$y)[(n+1):(2*n)]
      dtimes <- unique(times[d == 1])
      nd <- length(dtimes)
      matrixO <- outer(times, dtimes, "==") * matrix(d, n, nd)
      ties <- any(colSums(matrixO) > 1)
      atrisk <- outer(times, dtimes, ">=")
      hazinc <- as.vector(1 / (expci %*% atrisk))
      matrixP <- outer(expci, hazinc, "*") * atrisk
      matrixPO <- matrixP %*% t(matrixO)
      matrixM <- matrix(d, n, nd, byrow=FALSE) * (!atrisk) - matrixPO %*% (!atrisk)
      matrixW <- -crossprod(t(matrixPO))
      diag(matrixW) <- diag(matrixW) + rowSums(matrixPO)
      X0W <- crossprod(X0, matrixW)
      X0WX0 <- X0W %*% X0
      X0WX0invX0 <- solve(X0WX0, t(X0))
      H <- X0 %*% solve(X0WX0, X0W)
    }
    else if (model == "multinomial") {
      H <- X0 %*% solve(crossprod(X0), t(X0))
    }
  }

  # smooths label 
  smooths<-paste("s(",paste(covs,collapse=","),")", sep="")

  # result
  l<-length(quant)
	Z<- do.call(cbind,lapply(lapply( lapply(1:l, function(x){ 
	  	(diag(ncol(H))-H) %*% getK(datacovs, covs, quant[x], metric, kernel, scale)
	  	} ), function(x){ x * (1/sqrt(sum(diag(t(x) %*% x)))) }) ,unlist))
	colnames(Z)<-1:(l*n)
  lvector<-lapply(1:l,function(x){(((x-1)*n)+1):(x*n)})
  names(lvector)<-paste("quant",quant)
  if (!robust) res<-gt(response=response, alternative=Z, null=null, data=data, ... ,subsets=lvector)
  else res<-gt(response=response, alternative=Z, null=null, data=data, ... )
	res@structure <- list(data.frame(smooths,quant, metric, kernel))
  if (!returnZ) return(res)
  else return(list(result=res, Z=Z))
}

###################################################
# External functions for gtKS
###################################################

getK <- function(data, covs, quant=.25, 
			    metric = c("euclidean", "pearson"), 
				kernel=c("uniform", "exponential", "triangular","neighbours","gauss"), 
				scale=TRUE ) {
  if (!is.data.frame(data)) stop("data should be a data.frame")
  if (missing(covs)) covs <- names(data)
  if (length(metric)>1) metric <- "euclidean"
  if (!all(covs %in% names(data))) stop("incorrect covariate names")
  metric <- match.arg(metric)
  kernel <- match.arg(kernel)
  
  # metrics (to add: categorical, mixed)
  if ( metric == "euclidean" ) {
  	if (scale) { DD <- as.matrix(dist(scale(data[,covs]))) } 
  	else {  DD <- as.matrix(dist(data[,covs]))  } 
  }
  if ( metric == "pearson" ) {
	DD <- as.matrix(as.dist(1-abs(cor(t(data[,covs])))))
  }
  
  # kernels (to add: Epanechnikov, Biweight, Gauss)
  if ( kernel == "uniform" ) {
    dDD <- DD[diag(nrow(DD)) == 0]
    h <- quantile(dDD, quant)
    U <- apply(DD, c(1,2), function(x) { as.numeric(abs(x) <= h) } )
  }
  if ( kernel == "exponential" ) {
  	dDD <- DD[diag(nrow(DD)) == 0]
    h <- quantile(dDD, quant)
    U <- apply(DD, c(1,2), function(x) { as.numeric(exp((-x)/h)) } )
  }
    if ( kernel == "triangular" ) {
  	dDD <- DD[diag(nrow(DD)) == 0]
    h <- quantile(dDD, quant)
    U <- apply(DD, c(1,2), function(x) { as.numeric( (h-abs(x))*(abs(x)<=h) ) } )
  }
  if ( kernel == "neighbours" ) {
    U <- apply(DD, 1, function(x) { as.numeric(x <= quantile(x, quant)) } )
  }
  if ( kernel == "gauss" ) {
  	dDD <- DD[diag(nrow(DD)) == 0]
    h <- quantile(dDD, quant)
    U <- apply(DD, c(1,2), function(x) { as.numeric( dnorm(x/h) ) } )
  }
  U <- sweep(U, 2, colSums(U), "/")
  U
}

setClass("mlogit", representation(
    coefficients = "matrix",
    standard.err = "matrix",
    fitted.values = "matrix",
    x = "matrix",
    y = "matrix",
    formula = "formula",
    call = "call",
    df.null = "numeric",
    df.residual = "numeric",
    null.deviance = "numeric",
    deviance = "numeric",
    iter = "numeric",
    converged = "logical"
  )
)

setMethod("show", "mlogit", function(object) {
  cat("\n")
  cat(paste("Call:", deparse(object@call), "\n"))
  cat("\n")
  cat("Coefficients:\n")
  print(t(object@coefficients))
  cat("\n")
  cat(paste("Degrees of Freedom:", object@df.null, "Total (i.e. Null); ", object@df.residual, "Residual\n"))
  cat(paste("Null deviance:    ", round(object@null.deviance,2), "\n"))
  cat(paste("Residual deviance:", round(object@deviance,2), "\t"))
  g <- ncol(object@y)
  nullnulldf <- object@df.null + (g-1)
  AIC <- object@deviance + 2 * (nullnulldf - object@df.residual)
  cat(paste("AIC:", round(AIC,2) , "\n"))
})


setMethod("summary", "mlogit", function(object,...) {
  cat("\n")
  cat("Call:\n")
  cat(paste(deparse(object@call), "\n"))
  cat("\n")
  devres <- sqrt(-2 * (log(object@fitted.values)))
  devres[object@y==0] <- sqrt(-2 * (log(1-object@fitted.values)))[object@y==0]
  devres <- sign(object@y - object@fitted.values) * devres
  sumdevres <- t(round(apply(devres,2,quantile),4))
  colnames(sumdevres) <- c("Min", "1Q", "Median", "3Q", "Max")
  cat("Deviance Residuals:\n")
  show(sumdevres)
  cat("\n")
  cat("Coefficients:\n")
  g <- ncol(object@y)
  p <- ncol(object@x)
  for (ix in 1:g) {
    cat(paste("\nOutcome category ",colnames(object@coefficients)[ix], ":\n", sep = ""))
    coef <- object@coefficients[,ix]
    sterr <- object@standard.err[,ix]
    z <- coef / sterr
    p <- 2*pnorm(-abs(z))
    sumcoef <- cbind(coef, sterr, z, p)
    colnames(sumcoef) <- c("Estimate", "Std.Error", "z-value", "Pr(>|z|)")
    print(round(sumcoef, 4))
  }
  cat("\n")
  cat(paste("Null deviance:    ", round(object@null.deviance,3), "on", object@df.null, "degrees of freedom\n"))
  cat(paste("Residual deviance:", round(object@deviance,3), "on", object@df.residual, "degrees of freedom\n"))
  nullnulldf <- object@df.null + (g-1)
  AIC <- object@deviance + 2 * (nullnulldf - object@df.residual)
  cat(paste("AIC:", round(AIC,3) , "\n"))
  cat("\n")
  cat(paste("Number of Fisher Scoring iterations:", object@iter, "\n"))
})

setMethod("coefficients", "mlogit", function(object,...) {
  object@coefficients
})

setMethod("fitted.values", "mlogit", function(object,...) {
  object@fitted.values
})

setMethod("residuals", "mlogit", function(object,...) {
  object@y - object@fitted.values
})


mlogit <- function(formula, data, control = glm.control()) 
{
  # extract X from formula and data
  if (!is(formula, "formula")) stop("formula should be a formula object")
  if (!missing(data) && !is.data.frame(data)) stop("data should be a data.frame")

  # extract Y from formula and data  
  if (missing(data))
    data <- NULL
  Y <- factor(eval(formula[[2]], data, environment(formula)))
  n <- length(Y)
  outs <- levels(Y)
  g <- length(outs)
  matrixY <- sapply(outs, function(out) { Y == out }) + 0
                                            
  X <- model.matrix(formula, data=data)
  p <- ncol(X)
  
  # fit parameters
  # 1: starting values:
  gamma <- matrix(0,p,g)
  iter <- 0
  olddev <- -Inf
  finished <- FALSE
  
  # 2: Newton-Rhaphson algorithm
  while (!finished) {
    numerator <- sapply(1:g, function(out) exp(X %*% gamma[,out]))
    denominator <- rowSums(numerator)
    mu <- numerator / (denominator %o% rep(1,g))
    weightedX <- lapply(as.list(1:g), function(out) X * (mu[,out] %o% rep(1,p)))
    XWX <- matrix(0,p*g,p*g)
    for (ix in 1:g) {
      for (iy in 1:g) {
        if (ix == iy) {
          XWX[((ix-1)*p+1):(ix*p), ((ix-1)*p+1):(ix*p)] <- crossprod(weightedX[[ix]], X) - crossprod(weightedX[[ix]])
        } else {
          XWX[((ix-1)*p+1):(ix*p), ((iy-1)*p+1):(iy*p)] <- - crossprod(weightedX[[ix]], weightedX[[iy]])
        }
      }
    }
    eigs <- eigen(XWX, symmetric = TRUE)
    weightedEigens <- eigs$vectors[,1:(p*(g-1))] * (rep(1,p*g) %o% sqrt(1/eigs$values[1:(p*(g-1))]))
    XWX.MP <- crossprod(t(weightedEigens))
    gamma <- gamma + matrix(XWX.MP %*% as.vector(crossprod(X, matrixY - mu)), p, g)
    iter <- iter + 1
    dev <- -2 * sum(log(mu)[matrixY==1])
    finished <- ( abs(dev - olddev) / (abs(dev) + 0.1) < control$epsilon ) | (iter >= control$maxit)
    olddev <- dev
  }
  if (iter == control$maxit) { warning("algorithm had not converged after ", control$maxit, " iterations") }    
  
  # 3: Calculate mu based on final estimates
  numerator <- sapply(1:g, function(out) exp(X %*% gamma[,out]))
  denominator <- rowSums(numerator)
  mu <- numerator / (denominator %o% rep(1,g))

  # Prepare output
  probs <- mu
  rownames(probs) <- names(Y)
  colnames(probs) <- outs
  coefs <- gamma
  rownames(coefs) <- colnames(X)
  colnames(coefs) <- outs
  call <- sys.call(0)
  nullmu <- rep(1,n) %o% colMeans(matrixY) 
  nulldev <- -2 * sum(log(nullmu) * matrixY)
  
  fit <- new("mlogit",
    coefficients = coefs,
    standard.err = matrix(sqrt(diag(XWX.MP)),p,g),
    x = X,
    y = matrixY,
    fitted.values = probs,
    call = call,
    formula = formula,
    df.null = (n-1) * (g-1),
    df.residual = (n-p) * (g-1),
    null.deviance = nulldev,
    deviance = dev,
    iter = iter,
    converged = (iter < control$maxit)
  )
  
  fit
}

.EQall <- function(X, IminH, fit) {
  mu <- fitted.values(fit)
  n <- nrow(mu)
  g <- ncol(mu)
  m <- nrow(X)
  range <- lapply(as.list(1:g), function(ix) ((ix-1)*n+1):(ix*n))
  matrixW <- matrix(0,g,n*g)
  for (ix in 1:g) 
    matrixW[,range[[ix]]] <- -t(mu)
  matrixW <- matrixW * (rep(1,g) %o% as.vector(mu))
  for (ix in 1:g) 
    matrixW[ix,range[[ix]]] <- matrixW[ix,range[[ix]]] + mu[,ix]
  XX <- crossprod(X) / m
  R <- matrix(0,n*g,n*g)
  for (ix in 1:g) {
    for(iy in 1:g) {
      R[range[[ix]],range[[iy]]] <- crossprod(IminH[range[[ix]],range[[iy]]], XX) %*% 
        IminH[range[[ix]],range[[iy]]]
    }
  }
  RW <- matrix(0,n*g,n*g)
  for (ix in 1:g) {
    for (iy in 1:g) {
      M <- matrix(0, n, n)
      for (iz in 1:g) {
        M <- M + R[range[[ix]], range[[iz]]] * (matrixW[iz, range[[iy]]] %o% rep(1,n))
      }
      RW[range[[ix]], range[[iy]]] <- M
    }
  }
  sum(diag(RW))
}
  

inheritance <- function(test, sets, weights, ancestors, offspring, Shaffer, homogeneous=TRUE, trace) {
                                              
  # input checking 1: sets
  if (missing(sets) && is(test, "gt.object") && !is.null(test@subsets)) 
    sets <- test@subsets
  if (missing(sets)) stop("argument \"sets\" is missing with no default")
  if (is.character(sets))
    if (is(test, "gt.object") && !is.null(test@subsets)) {
      test <- test[sets]
      sets <- test@subsets
    }
  if(is(sets,"hclust")) 
    sets=as.dendrogram(sets)
  if(is(sets,"dendrogram")) {
    sets <- dendro2sets(sets)
    ancestors <- sets$ancestors
    sets <- sets$sets
  }
  if (is.null(names(sets)))
    stop("sets input has no names attribute.")
  if (any(duplicated(sets))) {
    sets <- sets[!duplicated(sets)]
    warning('duplicated sets removed')
  }
                                        
  # input checking 2: ancestors and offspring
  if (missing(ancestors) && is(test, "gt.object") && !is.null(test@structure$ancestors))
    ancestors <- test@structure$ancestors
  if (missing(offspring) && is(test, "gt.object") && !is.null(test@structure$offspring))
    offspring <- test@structure$offspring
  if (missing(ancestors) && missing(offspring)) {     # Infer from sets
    ancestors <- new.env(hash=TRUE)
    offspring <- new.env(hash=TRUE)
    for (i in 1:length(sets)) {
      truenamei <- names(sets)[i]
      namei <- as.character(i)      # workaround: variable names in environments may not be over 256 characters
      for (j in 1:length(sets)) {
        truenamej <- names(sets)[j]
        namej <- as.character(j)
        if (i != j && length(sets[[i]]) <= length(sets[[j]]) && all(sets[[i]] %in% sets[[j]])) {
          ancestors[[namei]] <- c(ancestors[[namei]], truenamej)
          offspring[[namej]] <- c(offspring[[namej]], truenamei)
        }
      }
    }
    ancestors <- as.list(ancestors)
    names(ancestors) <- names(sets)[as.numeric(names(ancestors))]
    offspring <- as.list(offspring)
    names(offspring) <- names(sets)[as.numeric(names(offspring))]
  }      
  if ((!missing(ancestors)) && is.environment(ancestors))
    ancestors <- as.list(ancestors)
  if ((!missing(offspring)) && is.environment(offspring))
    offspring <- as.list(offspring)
  if (missing(ancestors))
    ancestors <- turnListAround(offspring)
  if (missing(offspring))
    offspring <- turnListAround(ancestors) 
                               
  # get parents and children from ancestors and offspring
  parents <- ancestors2parents(ancestors)
  children <- ancestors2parents(offspring)
  leaves <- names(sets)[sapply(offspring[names(sets)], length) == 0]
                                        
  # prevent confusion between "weights" method and argument
  if (missing(weights)) weights <- NULL               
  if (is(weights, "gt.object") && is.list(test@weights) && length(test@weights) > 1)
    stop("The inheritance method is not applicable with individually weighted sets")
                              
  # Check whether Shaffer may be used
  if (is(test,"gt.object") && missing(Shaffer)) {
    shaffer.node <- names(sets)[sapply(names(sets), function(st) (!(st %in% leaves)) && all(children[[st]] %in% leaves))]
    Shaffer <- (length( setdiff(unlist(sets[shaffer.node]), unlist(sets[leaves])) ) == 0)
  }  
                                            
  # Check default trace
  if (missing(trace))    
    trace <- gt.options()$trace
                                   
  # Perform test for sets
  K <- length(sets)
  digitsK <- trunc(log10(K))+1
  if (is(test, "gt.object")) {
    # find out which tests have already been performed
    # sort subsets for quicker checking
    # for some reason a double for-loop is much quicker than a double sapply here!
    which.sort <- which(sapply(sets, length) %in% size(test))
    sets[which.sort] <- lapply(sets[which.sort], sort)
    test@subsets <- lapply(test@subsets, sort)
    found <- rep(NA, length(test))
    for (i in seq_along(test@subsets)) {
      subs <- test@subsets[[i]]
      for (j in seq_along(which.sort)) {
        jj <- which.sort[j]
        set <- sets[[which.sort[j]]]
        if ((length(subs) == length(set)) && all(subs == set)) {
          found[i] <- jj
          which.sort <- which.sort[-j]
          break
        } 
      }
    }
    # get test weights if available
    # NOTE: if inheritance was called from covariates(), test@weights is a list of length 1 
    # regardless of length(gt.object). We retrieve these test weigths and repair the object
    # TODO: program this in a more elegant way
    test.weights <- test@weights[[1]]
    # update object
    newgt <- test
    where.found <- match(1:K, found)
    progress <- sum(!is.na(where.found))
    newgt@result <- matrix(0,K,5)
    for (i in 1:K) {
      if (is.na(where.found[i])) {
        if (trace) {
          if (progress > 1)
            cat(rep("\b", digitsK+trunc(log10(progress))+4), sep="")
          progress <- progress +1
          cat(progress, "/", K)
          flush.console()
        }
        if (is.null(test.weights))
          newgt@result[i,] <- test@functions$test(sets[[i]])
        else
          newgt@result[i,] <- test@functions$test(sets[[i]], test.weights[sets[[i]]])
      } else {
        newgt@result[i,] <- test@result[where.found[i],]  
      }
    }
    rownames(newgt@result)<- names(sets)
    colnames(newgt@result) <- c("p-value", "Statistic", "Expected", "Std.dev", "#Cov")
    newgt@subsets <- sets
    newgt@extra <- NULL
    if (is.null(alias(test)) && (!all(names(newgt)[!is.na(where.found)] == names(test)[where.found[!is.na(where.found)]])))
      alias(test) <- names(test)
    if (!is.null(alias(test))) {
      alias(newgt) <- rep("", length(newgt))
      alias(newgt)[!is.na(where.found)] <- alias(test)[where.found[!is.na(where.found)]]
    }
    if (!is.null(test.weights))
      newgt@weights <- sapply(sets, function(st) test.weights[st])
    rawp <- p.value(newgt)
  } else {
    newgt <- NULL
    rawp <- sapply(1:K, function(i) {
      if (trace) {
        if (i > 1) cat(rep("\b", digitsK+trunc(log10(i-1))+4), sep="")
        cat(i, "/", K)
        flush.console()
      }
      test(sets[[i]])
    })
    names(rawp) <- names(sets)
  }

  # Get weights for inheritance: 1) get leaf weights if missing
  if (is.null(weights) && is(test, "gt.object")) {
    # most likely case: single top: first check
    tops <- which(sapply(ancestors[names(sets)], length) == 0)
    if (length(tops) == 1)
      weights <- weights(newgt[tops])
    else {
      temp <- test
      temp@subsets <- list(unique(unlist(sets[tops])))
      weights <- weights(temp)
    }
  } 
                                    
  # Get weights for inheritance: 2) get set weights
  if (is.null(weights)) {
    set.weights <- sapply(sets, length)
  } else {
    set.weights <- sapply(sets, function(st) sum(weights[st]))
  }

  #now call core function:
  adjustedP <- .inherit(ps=rawp, parents=parents, children=children, offspring=offspring, weights=set.weights, Shaffer=Shaffer, homogeneous =homogeneous)             # named vector

  if (trace==1) cat("\n")
  if (!is.null(newgt)) {
    extra <- newgt@extra
    extra[["inheritance"]] <- adjustedP
    newgt@extra <- as.data.frame(extra) 
    rownames(newgt@extra) <- names(newgt)
    newgt@structure <- list(ancestors=ancestors,offspring=offspring) 
    return(newgt)
  } else {
    return(data.frame(raw.p = rawp, inheritance = adjustedP))
  }

}

#############################################################################################################
################################################# FORMAT CONVERTING FUNCTIONS, SOME OTHER USEFUL FUNCTIONS and the core function


################################################################################
dendro2sets <- function(hc){
  ####################
  #create set names from the dendrogram
  do.sets <- function(x, parent.label, parent.branch, struct) {
    for (i in 1:length(x)) {
      parentnum <- as.character(which(struct$names == parent.label))
      currentnum <- as.character(length(struct$names)+1)
      newset <- labels(x[[i]])
      newname <- paste(parent.label,"[",i,sep="")
      if (is.leaf(x[[i]]))
        newname <- paste(newname, labels(x[[i]]), sep=":")
      newancestors <- c(struct$ancestors[[parentnum]], parent.label)
      newbranch <- c(parent.branch, i)
      struct$sets[[currentnum]] <- newset
      struct$ancestors[[currentnum]] <- newancestors
      struct$branch[[currentnum]] <- newbranch
      struct$names <- c(struct$names, newname)
      if (!is.leaf(x[[i]])) {
        struct <- do.sets(x=x[[i]], parent.label=newname, parent.branch=newbranch, struct)
      }
    }
    return(struct)
  }
  ####################

  struct <- list()
  struct$sets=new.env(hash=TRUE)
  struct$sets$"1" <- labels(hc)
  struct$ancestors <- new.env(hash=TRUE)
  struct$branch <- new.env(hash=TRUE)
  struct$branch$"1" <- numeric(0)
  struct$names <- "O"
  
  if (!is.leaf(hc))
    struct <- do.sets(hc, "O", numeric(0), struct)
  else
    struct$names <- paste(struct$names, labels(hc), sep=":")
  
  #convert to lists
  struct$sets <- as.list(struct$sets)
  names(struct$sets) <- struct$names[as.numeric(names(struct$sets))]
  struct$ancestors <- as.list(struct$ancestors)
  names(struct$ancestors) <- struct$names[as.numeric(names(struct$ancestors))]
  struct$branch <- as.list(struct$branch)
  names(struct$branch) <- struct$names[as.numeric(names(struct$branch))]
  
  return(struct)
}


#################################################
# returns the parent of element id
#get.parent<-function(id){
#  temp=sapply(structure$offspring[structure$ancestor[[id]]],length)
#  structure$ancestor[[id]][temp == min(c(unlist(temp),Inf))]
#  }
#################################################
# outputs the leaves of the structure
leaf.list<-function(structure) setdiff(names(structure$ancestor),names(structure$offspring))

#test if each element of all.list is a leaf node in the structure
is.leaf.list<-function(structure,all.list) {
  ans=rep(FALSE,length(all.list))
  names(ans)=all.list
  ans[intersect(leaf.list(structure) ,names(ans))]=TRUE
  ans
  }
  

######################################################################################################################
## here start the main function
.inherit <- function( ps,             # named vector
                      weights,        # named vector
                      parents,        # named list
                      children,
                      offspring,
                      Shaffer = TRUE,
                      homogeneous = FALSE) {

  # how many tests? 
  m <- length(ps)
  nms <- names(ps)
  weights <- weights[nms]
                                        
  # find top and leaves
  top <- sapply(parents[nms], length) == 0
  names(top) <- nms
  leaf <- sapply(children[nms], length) == 0
  names(leaf) <- nms
                          
  # find parents of leaves
  leaf.parents <- children[sapply(children, function(ch) any(ch %in% nms[leaf]))]
  leaf.siblings <- lapply(leaf.parents, function(lp) {
    nleaves <- sum(leaf[lp])
    if (nleaves > 1) lp else lp[!leaf[lp]]
  })

  # initialize
  basealpha <- rep(0,m)
  names(basealpha) <- nms
  basealpha[top] <- weights[top]/sum(weights[top])   # basealpha should add up to 1. Is multiplied by alpha later
  shaffer <- rep(1, m)
  rejected <- rep(FALSE, m)
  names(rejected) <- nms
  extinct <- weights == 0    # nodes with weight zero are never inherited to
  names(extinct) <- nms
  adjp <- rep(1, m)
  names(adjp) <- nms
  
  # a flag to do plain Meinshausen
  Meinshausen <- FALSE
  
  # start the procedure
  alpha <- 0
  ready <- FALSE
  while (!ready) {
                      
    # phase 1: reject
    testalpha <- basealpha * shaffer
    newly.rejected <- (ps/testalpha <= alpha) & (!rejected)
    newly.rejected[ps == 0 & testalpha == 0] <- FALSE     # do not reject when 0/0

    if (any(newly.rejected)) {
      adjp[newly.rejected] <- alpha
      rejected <- rejected | newly.rejected

      # phase 2: recalculate extinctness
      extinct[(!extinct) & rejected] <- sapply((1:m)[(!extinct) & rejected], function(i) 
        leaf[i] || all(rejected[offspring[[nms[i]]]]) || sum(weights[offspring[[nms[[i]]]]]) == 0)

      # phase 3: recalculate Shaffer
      if (Shaffer) {
        shaffer <- rep(1, m)
        names(shaffer) <- names(ps)
        if (homogeneous) {
          bottom <- setdiff(nms[rejected], unlist(parents[nms[rejected]]))
          bottom <- setdiff(bottom, nms[leaf])
          minweights <- unlist(lapply(bottom, function(bt) {
            min(weights[intersect(offspring[[bt]], nms[leaf])])
          }))
          sumweights <- sum(weights[leaf & !rejected])
          if (sumweights > 0) 
            shaffer[1:m] <- sumweights / (sumweights - sum(minweights))
          else
            shaffer[1:m] <- 1
          for (bt in bottom) {
            if (length(children[[bt]]) > 1) {
              mw <- unlist(lapply(children[[bt]], function(ch) {
                min(weights[intersect(c(ch,offspring[[ch]]), nms[leaf])])
              }))  
              names(mw) <- children[[bt]]
              smallest <- names(which.min(mw))
              second <- min(mw[names(mw) != smallest])
              shaffer[smallest] <- sumweights / (sumweights - sum(minweights) + mw[smallest] - second)
            } else
              shaffer[children[[bt]]] <- Inf
          }
        } else {
          for (lp in names(leaf.parents)[rejected[names(leaf.parents)]]) {
            desc <- leaf.parents[[lp]]
            lsibs <- leaf.siblings[[lp]]
            if (!any(rejected[desc])) {
              lvs <- desc[leaf[desc]]
              if (length(desc) == 1)
                shaffer[desc] <- Inf
              else {             
                smallest <- names(which.min(weights[lvs])) 
                shaffer[lsibs] <- sum(weights[desc]) /  (sum(weights[desc]) - weights[smallest])
                if (smallest %in% lsibs) {
                  second <- min(weights[setdiff(lvs, smallest)])
                  shaffer[smallest] <- sum(weights[desc]) / (sum(weights[desc]) - second)
                }  
              }
            }
          }
        }
      }
                        
      # phase 4: inherit
      while (any(rejected & (basealpha > 0))) {
        for (i in 1:m) {
          if (rejected[i] && basealpha[i] > 0) {
                     
            # find heirs
            if (extinct[i])
              if (top[i])         # whole tree is rejected
                heirs <- nms[top & (!extinct)]
              else                # heirs of leaf nodes or nodes under which all leaves are rejected
                if (Meinshausen)
                  heirs <- character(0)
                else if (homogeneous) {
                  heirs <- nms[(basealpha > 0) & (1:m != i)]
                }  
                else
                  heirs <- parents[[nms[i]]]
            else {                 # heirs of internal nodes
              heirs <- children[[nms[i]]]
              heirs <- heirs[!extinct[heirs]]
            }  
                                         
            # inherit basealpha to heirs
            basealpha[heirs] <- basealpha[heirs] + basealpha[i] * weights[heirs]/sum(weights[heirs])
            basealpha[i] <- 0
          }
        }
      }
    } else {        # no new rejections: increase alpha
      if (all(rejected))
        ready <- TRUE
      else {
        next.rejection <- ps / (basealpha * shaffer)
        next.rejection[ps == 0 & basealpha == 0] <- Inf
        alpha <- min(next.rejection)
        ready <- (alpha >= 1)
        newalpha <- TRUE
      }
    }
  }
  adjp[!rejected] <- 1
  return(adjp)
}

######################################
# Covariates function
# Decomposes the test result into the contributions due to each covariate
######################################
covariates <- function(object, 
            what = c("p-value", "statistic", "z-score", "weighted"), cluster = "average", 
            alpha = 0.05, sort = TRUE, zoom = FALSE, legend = TRUE, plot = TRUE, colors, alias, help.lines = FALSE,
            cex.labels = 0.6, ylim, pdf, trace) {
                                             
  if ((length(object) > 1) && missing(pdf))
    stop("length(object) > 1. Please reduce to a single test result or specify an output file.")
  if (missing(trace)) trace <- gt.options()$trace
  if (missing(alias)) alias <- NULL               # prevents confusion with "alias" method

  if (!missing(pdf)) {
    if (tolower(substr(pdf, nchar(pdf)-3, nchar(pdf))) != ".pdf")
      pdf <- paste(pdf, ".pdf", sep="")
    pdf(pdf)
  }

  # What to plot
  what <- substr(match.arg(tolower(what),  c("p-value", "statistic", "z-score", "weighted")),1,1)
  dendrogram <- plot && (((!is.logical(cluster)) || (cluster)) && (substr(cluster,1,1) != "n"))


  # update legend if asked
  if (is.character(legend)) {
    object@legend$cov <- legend
    legend <- TRUE  
  }
                          
  # prepare alias
  if (!is.null(alias)) {
    if (is.environment(alias) || is(alias, "AnnDbBimap")) alias <- as.list(alias)
    if (is.list(alias)) alias <- unlist(alias)
    if (length(alias) == object@functions$df()[3] && is.null(names(alias))) 
      names(alias) <- object@functions$cov.names()
  }
                                 
  # get the right subsets 
  for (jj in (1:length(object))[size(object)>0]) {
    obj <- object[jj] 
    if (is.null(obj@weights)) 
      weights <- rep(1, size(obj))                                       
    else
      weights <- obj@weights[[1]]
    if (is.null(obj@subsets)) {
      subset <- seq_len(size(obj))
      obj@subsets <- list(subset)
    }
    else
      subset <- obj@subsets[[1]]

    # make a title if necessary
    ttl <- names(obj)
    if (!is.null(alias(obj)))
      ttl <- paste(ttl, "-", alias(obj))

    # get the test function
    test <- function(set) {
      obj@functions$test(subset[set], weights[set])
    }
                                              
    # Test covariates  
    leaves <- matrix(0, size(obj), 5)
    colnames(leaves) <-  c("p", "S", "ES", "sdS", "ncov")
    rownames(leaves) <- obj@functions$cov.names(subset)
    progress <- 1
    if (dendrogram) {
      progress <- 1
      K <- 2*size(obj)-1 
    } else {
      K <- size(obj)
      progress <- 0
    }
    digitsK <- trunc(log10(K)+1)
    for (i in 1:size(obj)) {
      if (trace) {
        if (progress > 0)
          cat(rep("\b", digitsK+trunc(log10(progress))+4), sep="")
        progress <- progress +1
        cat(progress, "/", K)
        flush.console()
      }
      leaves[i,] <- test(i)
    }
                                               
    if (is.null(rownames(leaves)))
      rownames(leaves) <- subset
                                              
    # revert to weighted if asked
    if (what == "w") {
      leaves[,c("S", "ES", "sdS")] <- leaves[,c("S", "ES", "sdS")] * matrix(weights(obj),size(obj),3)
    }
    leaves[leaves[,"sdS"] == 0, "sdS"] <- 1
                                
    # Make bars  
    pps <- -log10(leaves[,"p"] )
    maxlogp <- max(pps[pps!=Inf], 0, na.rm=TRUE)
    pps[pps==Inf] <- maxlogp + 3
    bars <- switch(what, 
      p = pps,
      z = (leaves[,"S"]  - leaves[,"ES"]) / leaves[,"sdS"],
      w=,s= leaves[,"S"]
    )
    names(bars) <- rownames(leaves)
    if (!is.null(alias)) {
      if (length(alias) == length(bars) && (is.null(names(alias)) || is.null(names(bars))))
        names(bars) <- alias
      else {
        names(bars) <- alias[names(bars)]
      }
    }
                             
    if (sort) 
      order.bars <- -pps
    else
      order.bars <- 1:length(bars)
  
    # get default plotting parameters     
    margins <- par("mai")
                                    
    # Make the dendrogram
    if (is.logical(cluster) && dendrogram) cluster <- "average"
    if (dendrogram) {
      if(dim(leaves)[1]==1){
        hc = list(1)
        attr(hc, "label") <- row.names(leaves)[1]
        attr(hc, "members") <- 1
        attr(hc, "leaf") <- TRUE
        attr(hc, "height") <- 0
        attr(hc, "class") <- "dendrogram"
        d2s <- dendro2sets(hc)
        obj@extra <- data.frame(inheritance=p.value(obj))
        if (!is.null(alias)) alias(obj) <- names(bars)
        obj@subsets <- list(row.names(leaves)[1])
        names(obj) <- d2s$names
        sorter <- unlist(hc)
      } else {
        # Get residuals of the alternative regressing out the null
        cors <- obj@functions$dist.cor(subset)
        # Make a distance matrix and a dendrogram
        if (obj@directional)
          dd <- as.dist(1-cors)
        else
          dd <- as.dist(1-abs(cors))   
        hc <- as.dendrogram(hclust(dd, method = cluster))
        # reorder to get the most significant ones to the left
        hc <- reorder(hc, wts=order.bars, agglo.FUN=min)
        sorter <- unlist(hc)
        obj@result =rbind(obj@result,leaves)
        obj@subsets =  c(list(obj@functions$cov.names(obj@subsets[[1]])),  unlist(obj@functions$cov.names(subset)))
        obj@extra <- NULL
        obj@structure <- NULL         
        if (!is.null(alias)) alias(obj) <- c("",names(bars))
        d2s <- dendro2sets(hc)
        obj <- inheritance(obj, sets=d2s$sets, ancestors=d2s$ancestors, trace=trace, Shaffer=TRUE, homogeneous=TRUE)
        obj <- obj[sort.list(names(obj))]
      }

      # sort and select bars
      if (zoom) {
        if (dendrogram) {
          select <- unique(do.call(c, subsets(leafNodes(obj, alpha=alpha))))
          select <- which(rownames(leaves) %in% select)
        } else {
          select <- obj@extra[,"holm"] <= alpha
        }
        sorter <- sorter[sorter %in% select]
      }
      leaves <- leaves[sorter,,drop=FALSE]
      bars <- bars[sorter]

      # Construct a mapping from branch ids to the name of the corresponding set                                 
      branch2name <- names(d2s$branch)
      names(branch2name) <- unlist(lapply(d2s$branch, function(br) paste(".", br, collapse="", sep="")))
                                                       
      # Color the dendrogram
      sigcol <- function(tree, branch, sig, top) {
        branch.name <- branch2name[paste(".", branch, collapse="", sep="")]
      
        # significant node?
        sig <- sig && (obj@extra[branch.name, "inheritance"] <= alpha)
                                                   
        # set colors
        uit <- tree
        attr(uit, "edgePar") <- list(col=ifelse(sig, 1, gray(.8)), lwd= ifelse(sig, 2, 1))
        if (sig && top) 
          attr(uit, "nodePar") <- list(pch=20)

        # continue with the child branches
        if (!is.leaf(tree)) {
          select.branch <- 1:length(tree)
          if (zoom) {
            sigs <- lapply(1:length(tree), function(i) {
              subbranch <- branch2name[paste(".", c(branch, i), collapse="", sep="")]
              obj@extra[subbranch, "inheritance"] <= alpha
            })
            if (do.call(any, sigs) && (!do.call(all, sigs))) {
              select.branch <- which(do.call(c, sigs))
              attrs <- attributes(uit)
              uit <- list()
              attributes(uit) <- attrs
            } 
            attr(uit, "members") <- sum(select %in% unlist(tree))
          }  
          for (i in 1:length(select.branch)) {
            uit[[i]] <- Recall(tree[[select.branch[i]]], c(branch, select.branch[i]), sig, FALSE)
          }
          if (length(uit) == 1)
            attr(uit, "midpoint") <- attr(uit[[1]], "midpoint")
          else {
            leftmid <- attr(uit[[1]], "midpoint")
            rightmid <- attr(uit[[2]], "midpoint") + attr(uit[[1]], "members")
            attr(uit, "midpoint") <- (leftmid + rightmid)/2
          }  
        } else {
          attr(uit, "midpoint") <- 0
        }  
        return(uit)
      }
      hc <- sigcol(hc, numeric(0), sig = TRUE, top=TRUE)
                  
      # draw
      par(mai=c(0, max(1,margins[2]), margins[3:4]))
      layout(as.matrix(1:2), heights=c(1,2))
      ylab <- ifelse(obj@directional, "correlation", "abs. correlation")
      plot(hc, leaflab="none", yaxt = "n", ylab=ylab, mgp=c(4,1,0))
      axis(2, at = seq(0,2,by=.2), labels=1-seq(0,2,by=.2), las=2)
    } else {
      obj@subsets <- as.list(row.names(leaves))
      obj@result <- leaves
      obj@extra <- NULL
      if (!is.null(alias)) alias(obj) <- names(bars)
      obj@weights <- NULL
      colnames(obj@result) <- c("p-value", "Statistic", "Expected", "Std.dev", "#Cov")
      names(obj) <- row.names(leaves)
      sorter <- sort.list(order.bars) 
      if (zoom) obj <- p.adjust(obj, "holm")
      obj <- obj[sorter]
      bars <- bars[sorter]
      if (trace)
        cat("\n")
    }
                         
    # adjust bottom margin to length of labels                 
    labwidth <- max(strwidth(names(bars),"inches", cex.labels)) + .2
    par(mai = c(max(margins[1], labwidth*1.3), max(1,margins[2]), if (dendrogram) 0 else margins[3], margins[4]))
  
    #colors
    positive <- obj@functions$positive(subset)[sorter]
    if (missing(colors)) 
      if (max(positive) <= 2)  # multinomial model
        colors <- 3:2
      else
        colors <- rainbow(length(obj@legend$cov), start=0,end=1/2)
    if (all(positive %in% 0:1))  
      cols <- ifelse(positive, colors[1], colors[2])
    else
      cols <- colors[positive]
                             
    ylab <- switch(what,
      p = "p-value",
      z = "z-score",
      s = "test statistic",
      w = "weighted test statistic"
    )
    if (!missing(ylim)) { 
      ylims <- ylim
    } else {
      ylims <- switch(what, 
        z=,p = range(bars),
        w=,s = range(c(bars, leaves[,"ES"]))
      )
      if (ylims[1] > 0) ylims[1] <- 0
    }
    if (legend) {
      nbars <- length(bars)
      room <- (ylims[2] - max(bars[trunc(nbars*.6):nbars])) / diff(ylims)
      ylims[2] <- ylims[2] + diff(ylims) * max(0,.1*length(colors) - room)
    }
    mids <- drop(barplot(bars, yaxt="n", border=NA, las=2, ylab=ylab, ylim=ylims, mgp=c(4,1,0), col=cols, cex.names=cex.labels, plot=plot))
    
    # help lines
    if (dendrogram && help.lines) {
      mb <- max(bars)
      for (i in 1: length(bars))
        lines(c(mids[i],mids[i]),c(max(0,bars[i])+.01*mb,mb*1.2),col=gray(.8),lty=3 )
    }    
    
    # construct appropriate axes
    if(plot) {
      if (what == "p") {
        labs <- seq(0,ylims[2], by = max(1,ylims[2] %/% 5))
        if (length(labs)==1) {
          minp <- 10^-ylims[2]
          if (minp < 0.5) {
            labs <- log10(c(1,2,10/3,5))
            labs <- labs[labs < ylims[2]]
          } else {
            fc <- 10^-floor(log10(1-minp)) 
            labs <- -log10(c(1,ceiling(minp*fc)/fc))
          }
        } else if (length(labs) <= 2)
          labs <- outer(log10(c(1,2,5)),labs,"+")
        else if (length(labs) <= 4)
          labs <- outer(log10(c(1,10/3)),labs,"+")
        if (max(bars) > ylims[2]) #zero p-values
          axis(2, at = c(labs, max(bars)), labels=c(10^-labs, 0), las=2)
        else
          axis(2, at = labs, labels=10^-labs, las=2)
      } else
        axis(2, las=2)
      if (what %in% c("s","w")) {
        sapply(seq_along(mids), function(i) { 
          lines(c(mids[i]-0.5, mids[i]+0.5), rep(leaves[i,"ES"],2), lwd=3)
           sapply(seq_len(max(0, (bars[i] - leaves[i,"ES"])/leaves[i,"sdS"])), function(k)
            lines(c(mids[i]-0.5, mids[i]+0.5), rep(leaves[i,"ES"]+k*leaves[i,"sdS"],2))
          )
        })
      }
      abline(0,0)
    
      if (legend)               
        legend("topright", obj@legend$cov, fill = colors, bg="white")
  
      #reset defaults 
      layout(1)
      par(mai=margins)
          
      if (!missing(pdf)) {
        title(ttl)
      }
    }
  }

  if (!missing(pdf))
    dev.off()
  
  # return
  if (length(object) == 1) {
    out <- obj
  } else
    out <- NULL

  return(invisible(out))
}

######################################
# features function
# Synonym of "covariates"
######################################
features <- function(...) {
  covariates(...)
}




######################################
# Subjects function
# Decomposes the test result into the contributions due to each subject
######################################
subjects <- function(object,
            what = c("p-value", "statistic", "z-score", "weighted"), cluster = "average",
            sort=TRUE, mirror = TRUE, legend = TRUE, colors, alias, help.lines = FALSE, 
            cex.labels = 0.6, ylim, pdf) {
            
  if ((length(object) > 1) && missing(pdf))
    stop("length(object) > 1. Please reduce to a single test result or specify an output file.")
  if (missing(alias)) alias <- NULL               # prevents confusion with "alias" method
    
  if (!missing(pdf)) {
    if (tolower(substr(pdf, nchar(pdf)-3, nchar(pdf))) != ".pdf")
      pdf <- paste(pdf, ".pdf", sep="")
    pdf(pdf)
  }    

  # update legend if asked
  if (is.character(legend)) {
    object@legend$subj <- legend
    legend <- TRUE  
  }
  
  # What to plot
  what <- substr(match.arg(tolower(what),  c("p-value", "statistic", "z-score", "weighted")),1,1)


  # get the right subsets
  for (jj in 1:length(object)) {
    obj <- object[jj]  
    if (is.null(obj@weights))
      weights <- rep(1, size(obj))
    else
      weights <- obj@weights[[1]]
    if (is.null(obj@subsets))
      subset <- seq_len(size(obj))
    else
      subset <- obj@subsets[[1]]

    # make a title if necessary
    ttl <- names(obj)
    if (!is.null(alias(obj)))
 
      ttl <- paste(ttl, "-", alias(obj))    
  
    # calculate scores
    rr <- obj@functions$subjectplot(subset, weights, mirror)
    if (what == "w") {
      rr[,1:3] <- rr[,1:3] * matrix(abs(rr[,4])/max(abs(rr[,4])),nrow(rr),3)
    }
  
    # Make bars
    zs <- (rr[,1] - rr[,2]) / rr[,3]
    if (mirror) 
      pps <- pnorm(zs, lower.tail=FALSE)
    else
      pps <- pnorm(sign(rr[,4]) * zs, lower.tail=FALSE)
    bars <- switch(what,
      w=,s= rr[,1],
      z = zs,
      p = -log10(pps)
    )
    if (is.null(alias))
      names(bars) <- rownames(obj@functions$getX(subset))
    else
      names(bars) <- alias
    if (is.null(names(bars)))
      names(bars) <- 1:length(bars)
    if (sort)
      order.bars <- -bars #if (mirror || what == "p") -bars * sign(rr[,4]) else -bars 
    else
      order.bars <- 1:length(bars)
                                                          
    # get default plotting parameters
    margins <- par("mai")
  
    # Make the dendrogram
    dendrogram <- ((!is.logical(cluster)) || (cluster)) && (substr(cluster,1,1) != "n")
    if (is.logical(cluster) && dendrogram) cluster <- "average"
    if (dendrogram) {
      # Get residuals of the alternative regressing out the null
      cors <- obj@functions$dist.cor(subset, weights, transpose=TRUE)
                                                       
      # Make a distance matrix and a dendrogram
      dd <- as.dist(1-cors)
      hc <- as.dendrogram(hclust(dd, method = cluster))
  
      # reorder to get the most significant ones to the left
      hc <- reorder(hc, wts=order.bars, agglo.FUN=min)
      sorter <- unlist(hc)
  
      # draw
      par(mai=c(0, max(1,margins[2]), margins[3:4]))
      layout(as.matrix(1:2), heights=c(1,2))
      ylab <- "correlation"
      plot(hc, leaflab="none", yaxt = "n", ylab=ylab, mgp=c(4,1,0))
      axis(2, at = seq(0,2,by=.2), labels=1-seq(0,2,by=.2), las=2)
    } else {
      sorter <- sort.list(order.bars)
    }
  
    bars <- bars[sorter]
    rr <- rr[sorter,]
    pps <- pps[sorter]
  
    labwidth <- max(strwidth(names(bars),"inches", cex.labels)) + .2
    par(mai = c(max(margins[1], labwidth*1.3), max(1,margins[2]), if (dendrogram) 0 else margins[3], margins[4]))
                                     
    #colors
    if (missing(colors)) 
      if (any(rr[,"Y"] < 0))
        colors <- 3:2
      else
        colors <- rainbow(max(rr[,"Y"]), start=0,end=1/2)
    if (any(rr[,"Y"] < 0))  
      cols <- ifelse(rr[,"Y"] > 0, colors[1], colors[2])
    else
      cols <- colors[rr[,"Y"]]
  
    ylab <- switch(what,
      z = "z-score",
      p = "p-value",
      s = "posterior effect",
      w = "weighted posterior effect"
    )
    if (!missing(ylim)) { 
      ylims <- ylim
    } else {
      ylims <- switch(what, 
        z=,p= range(bars),
        s=,w= range(c(bars, rr[,"ER"]))
      )
      if (ylims[1] > 0) ylims[1] <- 0
    }
    if (legend) {
      nbars <- length(bars)
      room <- (ylims[2] - max(bars[trunc(nbars*.6):nbars])) / diff(ylims)
      ylims[2] <- ylims[2] + diff(ylims) * max(0,.125*length(colors) - room)
    }
    mids <- drop(barplot(bars, yaxt="n", border=NA, las=2, ylab=ylab, ylim=ylims, mgp=c(4,1,0), col=cols, cex.names=cex.labels))
    
    # help lines
    if (dendrogram && help.lines) {
      mb <- max(bars)
      for (i in 1: length(bars))
        lines(c(mids[i],mids[i]),c(max(0,bars[i])+.01*mb,mb*1.2),col=gray(.8),lty=3 )
    }    
    
    if (what == "p") {
      labs <- seq(0,ylims[2], by = max(1,ylims[2] %/% 5))
      if (length(labs)==1)
        labs <- log10(c(1,2,10/3,5))
      else if (length(labs) <= 2)
        labs <- outer(log10(c(1,2,5)),labs,"+")
      else if (length(labs) <= 4)
        labs <- outer(log10(c(1,10/3)),labs,"+")
      axis(2, at = labs, labels=10^-labs, las=2)
    } else
      axis(2, las=2)
    if (what %in% c("s","w")) {
      sapply(seq_along(mids), function(i) {
        lines(c(mids[i]-0.5, mids[i]+0.5), rep(rr[i,"ER"],2), lwd=3)
        sapply(seq_len(max(0, (bars[i] - rr[i,"ER"])/rr[i,"sdR"])), function(k)
          lines(c(mids[i]-0.5, mids[i]+0.5), rep(rr[i,"ER"]+k*rr[i,"sdR"],2))
        )
        sapply(-seq_len(max(0, -(bars[i] - rr[i,"ER"])/rr[i,"sdR"])), function(k)
          lines(c(mids[i]-0.5, mids[i]+0.5), rep(rr[i,"ER"]+k*rr[i,"sdR"],2))
        )
      })
    }
    abline(0,0)
  
    if (legend)
      legend("topright", obj@legend$subj, fill = colors, bg="white")
  
    #reset defaults
    layout(1)
    par(mai=margins)
  
    if (!missing(pdf))
      title(ttl)
  
  }
  
  if (!missing(pdf))
    dev.off()

  if (length(object)== 1) {
    out <- cbind("P-value" = pps, Statistic = rr[,1], Expected = rr[,2], Std.dev = rr[,3], Residual = rr[,4])
    rownames(out) <- names(bars)
  } else
    out <- NULL

  invisible(out)
 }


######################################
# Similarity function
# Visualizes the XX' matrix
######################################
similarity <- function(object, cluster = "average", legend = TRUE) {

  # reconstruct XX
  if (length(object) > 1)
    stop("length(object) > 1. Please reduce to a single test result")
  if (is.null(object@weights))
    weights <- rep(1, size(object))
  else
    weights <- object@weights[[1]]
  if (is.null(object@subsets))
    subset <- seq_len(size(object))
  else
    subset <- object@subsets[[1]]

  X <- object@functions$getX(subset, weights)
  if (object@directional) X <- cbind(X, sqrt(object@directional) * rowSums(X))

  sds <- sqrt(rowSums(X*X))
  sds[sds < max(sds)*1e-14] <- Inf
  cors <- crossprod(t(X)) / outer(sds,sds)

  # Make a distance matrix and a dendrogram
  dendrogram <- ((!is.logical(cluster)) || (cluster)) && (substr(cluster,1,1) != "n")
  if (is.logical(cluster) && dendrogram) cluster <- "average"
  if (dendrogram) {
    dd <- as.dist(1-cors)
    dend <- as.dendrogram(hclust(dd, method = cluster))
  } 

  # Reconstruct XX matrix
  XX <- crossprod(t(X))
  diag(XX) <- NA

  # make green and red, making sure black represents zero
  posfraq <- - round(max(XX, na.rm=TRUE) / min(XX, na.rm=TRUE) * 100)
  red <- c(100:1,rep(0,posfraq))/100
  green <- c(rep(0,100),1:posfraq)/posfraq
  color=rgb(red,green,0)

  # Get sidecolors w.r.t Y
  Y <- object@functions$getY()
  scoreY <- 0.5 - 0.5 * round(Y / max(abs(Y)), 2)
  #sidecolor <- gray(scoreY)

  sidecolor <- rgb(1-ifelse(scoreY < 0.5, (1-scoreY)/2, 0), 1-ifelse(scoreY < 0.5, (1-scoreY)/2, 0), 1-ifelse(scoreY < 0.5, 0, scoreY/2))

  if (dendrogram)
    heatmap(XX, Rowv= dend, Colv=rev(dend), col=color, scale= "none",
      RowSideColors = sidecolor, ColSideColors = sidecolor)
  else
    heatmap(XX, Rowv= NA, Colv=NA, col=color, scale= "none", 
      RowSideColors = sidecolor, ColSideColors = sidecolor)
      
  if (legend && dendrogram)
    legend("topleft", c("similar", "neutral", "dissimilar"), fill=c(3,1,2), cex=.6)
    
  invisible(XX)
}

.getP <- function(lams) {

  if (all(lams >= 0))
    p.value <- 1
  else if (all(lams <= 0))
    p.value <- 0
  else {
    lams <- lams[lams != 0]
    if (length(unique(lams)) == 2) {
      p.value <- .genF(1,lams)
    } else {
      # first try Imhof (quick but less accurate)
      try.p <- .pImhof(lams)
      if (is.na(try.p$value) || (try.p$value <= 10*try.p$error))  {
        p.value <- .genF(1,lams)
      } else
        p.value <- try.p$value
    }
  }
  p.value
}


.weed <- function(lam, acc = 50) {
  lam <- sort(lam,decreasing=TRUE)
  mmm <- length(lam)
  target <- lam[1]/acc
  weedM <- function(m) {
    join <- lam[!(1:mmm %in% seq_len(m))]
    rest <- lam[1:mmm %in% seq_len(m)]
    newlength <- min(sum(join) %/% target, length(join))
    if (length(rest) == 0)
      newlength <- 1
    join <- rep(sum(join)/newlength, newlength)
    OK <- (length(rest) == 0) || ((length(join) > 0) && (rest[m] >= join[1]))
    if (OK)
      c(rest, join)
    else
      NA
  }
  weeds <- NA
  i <- mmm-1
  while (is.na(weeds[1])) {
    weeds <- weedM(i)
    i <- i - 1
  }
  weeds
}


.getC <- function(lams, beta, eps = 1e-10) {
                                      
  lams <- sort(lams)
  ix <- 1
  d <- NULL
  c <- prod(sqrt(beta/lams))
  if (c == 0 || c > 1) {
    return(NULL)
  }
  rest.c <- 1-c
  max.c <- c
  d.base <- 1-beta/lams
  m <- length(lams)

  ready <- FALSE
  while (!ready)
  {
    d <- c(d, 0.5*sum(d.base^ix))
    c <- c(c,mean(c[1:ix]*d[ix:1]))
    if (rest.c > 100*.Machine$double.neg.eps)
      rest.c <- rest.c-c[ix+1]
    else
      rest.c <- rest.c*lams[1]/lams[m]
    max.c <- max(max.c, c[ix+1])
    ready <- (rest.c/max.c<eps) || (c[ix+1] < 0)
    ix <- ix+1
  }
  if (rest.c > 0)
    c <- c(c, rest.c)
  if (any(c<0))
    return(NULL)
  else
    return(c)
}

.ruben <- function(lams) {
  mx <- max(lams)
  mn <- min(lams)
  return(2 * mx * mn / (mx + mn))
}

.genF <- function(x, lams, eps = 1e-10, acc = c(50,50)) {

  lams.pos <- .weed(lams[lams>0], acc = acc[1])
  m.pos <- length(lams.pos)
  lams.neg <- .weed(-lams[lams<0], acc = acc[2])
  m.neg <- length(lams.neg)

  if (m.neg == 0)
    p.value <- as.numeric(x>0)
  else if (m.pos == 0)
    p.value <- as.numeric(x<=0)
  else {
    # get the c mixture for the positive lambdas
    beta <- seq(.ruben(lams.pos), min(lams.pos), length = 10)
    c.pos <- NULL
    choice <- 0
    while (is.null(c.pos)) {
      if (choice < length(beta))
        choice <- choice + 1
      else {  # numerical problems: weed sacrifice accuracy for convergence
        acc[1] <- mean(c(acc[1],1))
        lams.pos <- .weed(lams.pos, acc=acc[1])
        m.pos <- length(lams.pos)
        beta <- seq(.ruben(lams.pos), min(lams.pos), length = 10)
        choice <- 1
      }
      c.pos <- .getC(lams.pos, beta[choice], eps)
    }
    beta.pos <- beta[choice]
  
    # get the c mixture for the negative lambdas
    beta <- seq(.ruben(lams.neg), min(lams.neg), length = 10)
    c.neg <- NULL
    choice <- 0
    while (is.null(c.neg)) {
      if (choice < length(beta))
        choice <- choice + 1
      else {  # numerical problems: weed sacrifice accuracy for convergence
        acc[2] <- mean(c(acc[2],1))
        lams.neg <- .weed(lams.neg, acc=acc[2])
        m.neg <- length(lams.neg)
        beta <- seq(.ruben(lams.neg), min(lams.neg), length = 10)
        choice <- 1
      }
      c.neg <- .getC(lams.neg, beta[choice], eps)
    }
    beta.neg <- beta[choice]

    # find the p-value
    i <- 1:length(c.pos)
    df.1 <- m.pos+2*(i-1)
    pfs <- sapply(1:length(c.neg), function(j) {
      df.2 <- m.neg+2*(j-1)
      qq <- (x*beta.neg/beta.pos)*(df.2/df.1)
      pf(q=qq, df1=df.1, df2=df.2, lower.tail=FALSE)
    })

    p.value <- drop(crossprod(c.pos, pfs) %*% c.neg) 
  }

  return(p.value)           
}


####################################
# The Imhof method for x=0 and central variables only.
####################################
.pImhof <- function(lams, eps = 1e-10) {
  lams <- lams[lams != 0]
  integrand <- function(u) {          # the Imhof integrand. Domain: 0...Inf
    theta <- 0.5 * colSums(atan(outer(lams,u))) # - 0.5 * x * u
    rho <- exp(colSums(0.25 * log(1 + outer(lams^2,u^2))))
    out <- ifelse(u==0, sum(lams)/2, sin(theta)/(u*rho))
    out
  }
  tr.integrand <- function(v) {       # Transformation of the integrand. Domain: 0...1
    K <- sum(abs(lams))/20            # Scaling constant of the transformation (to make it invariant to the scale of lams)
    0.5 + integrand(-log(1-v)/K) / (pi*K*(1-v))
  }
  rt <- max(sqrt(.Machine$double.eps), eps)
  res <- try(integrate(tr.integrand, 0, 1, rel.tol = rt), silent=TRUE)
  if (is(res, "try-error")) {
    out <- list(value = NA, error = NA)
  } else {
    out <- list(value = res$value, error = res$abs)
  }
  out
}

############################
# Get the alternative design matrix
############################
.getAlternative <- function(alternative, data, n) {

  # coerce alternative into a matrix
  if (is.data.frame(alternative)) {
    if (all(sapply(alternative, is.numeric))) {
      alternative <- as.matrix(alternative)
    } else {
      stop("argument \"alternative\" could not be coerced into a matrix")
    }
  }
  if (is.vector(alternative)) {
    if (is.numeric(alternative)) {
      alternative <- as.matrix(alternative)
      colnames(alternative) <- "x"
    } else {
      stop("argument \"alternative\" could not be coerced into a matrix")
    }
  }
  # transpose if desired
  if (gt.options()$transpose && is.matrix(alternative))
    alternative <- t(alternative)
  if (is(alternative, "ExpressionSet")) {
    alternative <- t(exprs(alternative))
  }
  if (is(alternative, "formula")) {

    # keep NAs
    old.na.action <- options()$na.action  
    options(na.action="na.pass")

    # make appropriate contrasts
    mframe <- model.frame(alternative, data=data)
    factors <- names(mframe)[sapply(mframe, is.factor)]
    contrs <- lapply(factors, function(fac) {
      levs <- levels(mframe[[fac]])
      k <- length(levs)
      if (is.ordered(mframe[[fac]])) {
        contr <- matrix(0,k,k)
        contr[lower.tri(contr,diag=TRUE)] <- 1
      } else {
        contr <- diag(k)
      }
      rownames(contr) <- colnames(contr) <- levs                     
      contr 
    })
    names(contrs) <- factors
                             
    # make the design matrix
    alternative <- terms(alternative, data=data)
    if (length(attr(alternative, "term.labels")) == 0)
      stop("empty alternative")
    attr(alternative, "intercept") <- 1
    alternative <- model.matrix(alternative, contrasts.arg=contrs, data=data)
    alternative <- alternative[,colnames(alternative) != "(Intercept)",drop=FALSE]    # ugly, but I've found no other way
    
    # restore default
    options(na.action = old.na.action)
  }

  #check dimensions and names
  if (nrow(alternative) != n) {
    stop("the length of \"response\" (",n, ") does not match the row count of \"alternative\" (", nrow(alternative), ")")
  }
  if (is.null(colnames(alternative)))
    stop("colnames missing in alternative design matrix")

  alternative
}

############################
# Get the null design matrix
############################
.getNull <- function(null, data, n, model) {

  # coerce null into a matrix and find the offset term
  offset <- NULL
  if (is.data.frame(null) || is.vector(null)) {
    if (all(sapply(null, is.numeric))) {
      null <- as.matrix(null)
    } else {
      stop("argument \"null\" could not be coerced into a matrix")
    }
  }
  if (is(null, "formula")) {
    if (is.null(data)) {
      tnull <- terms(null)
      # prevent problems for input ~1 or ~0:
      if ((attr(tnull, "response") == 0) && (length(attr(tnull, "term.labels")) == 0)
          && (length(attr(tnull, "offset")) == 0)) {
        if (attr(tnull, "intercept") == 1)
          tnull <- terms(numeric(n) ~ 1)
        else
          tnull <- terms(numeric(n) ~ 0)
      }
      offset <- model.offset(model.frame(tnull))
    } else {
      offset <- model.offset(model.frame(null, data=data))
      tnull <- terms(null, data=data)
    }
    data <- model.frame(tnull, data, drop.unused.levels = TRUE)
    null <- model.matrix(tnull, data)
 
    # suppress intercept if necessary (can this be done more elegantly?)
    if (model == "cox") null <- null[,colnames(null) != "(Intercept)",drop=FALSE]
  }

  # check dimensions
  if (nrow(null) != n) {
    stop("the length of \"response\" (",n, ") does not match the row count of \"null\" (", nrow(null), ")")
  }

  list(null = null, offset = offset)
}


############################
# Iterative function calculates all permutations of a vector
# values: vector of all unique values
# multiplicity: multiplicity of each value
############################
.allpermutations <- function(values, multiplicity) {

  if (length(values)==1) {
    out <- values
  } else {
    n <- sum(multiplicity)
    out <- matrix(0 , n, .npermutations(multiplicity))
    where <- 0
    for (i in 1:length(values)) {
      if (multiplicity[i] == 1) {
        newmult <- multiplicity[-i]
        newvals <- values[-i]
      } else {
        newmult <- multiplicity
        newmult[i] <- newmult[i] - 1
        newvals <- values
      }
      range <- where + seq_len(.npermutations(newmult))
      where <- range[length(range)]
      out[1,range] <- values[i]
      out[2:n, range] <- .allpermutations(newvals, newmult)
    }
  }
  out
}

############################
# Iterative function counts all permutations of a vector
# values: vector of all unique values
# multiplicity: multiplicity of each value
############################
.npermutations <- function(multiplicity) {
  round(exp(lfactorial(sum(multiplicity)) - sum(lfactorial(multiplicity))))
}

############################
# Counts all permutations of a vector y
# user-friendly version of .npermutations()
############################
npermutations <- function(y) {
  .npermutations(table(y))
}

############################
# Calculates all permutations of a vector y
# user-friendly version of .allpermutations()
############################
allpermutations <- function(y) {
  values <- unique(y)
  multiplicity <- colSums(outer(y, values, "=="))
  .allpermutations(values, multiplicity)
}


############################
# Makes the right formula
############################
.makeFormula <- function(has.null, has.offset) {
  form <- "response ~ 0"
  if (has.null) form <- paste(form, "+Z")
  if (has.offset) form <- paste(form, "+offset(offset)")
  form
}

gtGO <- function(response, exprs, ..., id, annotation, probe2entrez, ontology = c("BP", "CC", "MF"),
                  minsize=1, maxsize=Inf,
                  multtest = c("Holm", "focuslevel", "BH", "BY"), focuslevel = 10,
                  sort = TRUE) {

  # some input checking on response (unavoidable?)
  call <- match.call()
  if (is(exprs, "ExpressionSet")) {
    data <- pData(exprs)
  } else {
    data <- eval(call$data)
  }
  if (is.matrix(data))  
    data <- data.frame(data)
  formula.response <- (length(call$response) > 1) && (call$response[[1]] == "~")
  if (!formula.response) {
    name.response <- deparse(call$response)
    response <- eval(call$response, data, parent.frame())
  }  

  # get the right annotation package
  if (missing(annotation)) {
    if (is(exprs, "eSet")) {
      annotation <- NULL
      annotation <- annotation(exprs)
    } else
      stop("argument \"annotation\" is missing with no default.")
  }
  if (substr(annotation, nchar(annotation)-2, nchar(annotation)) == ".db")
    annotation <- substr(annotation, 1, nchar(annotation)-3)
  package <- paste(annotation, ".db", sep="")
  require(package, character.only=TRUE) || stop("package ", package, " is not available")

  # check whether "org" package is given
  if (substr(annotation,1,4) == "org.")
    extension <- "GO2ALLEGS"
  else
    extension <- "GO2ALLPROBES"
  GOOBJECT <- eval(as.name(paste(annotation, extension, sep="")))

  # reduce the terms
  if (missing(id))
    id <- mappedkeys(GOOBJECT)
  myGOTERM <- lookUp(id, "GO", "TERM", load=TRUE)

  # get the right ontology/ies
  if (!missing(ontology)) {
    choose <- sapply(myGOTERM, Ontology) %in% ontology
    id <- id[choose]
    myGOTERM <- myGOTERM[choose]
  }

  # retrieve sets
  sets <- lookUp(id, annotation, extension)
  sets <- lapply(sets, function(st) if (all(is.na(st))) character(0) else st)
                                                         
  # map back
  if (!missing(probe2entrez)) {
    if (is.environment(probe2entrez) || is(probe2entrez, "AnnDbBimap")) probe2entrez <- as.list(probe2entrez)
    if (is.list(probe2entrez)) probe2entrez <- unlist(probe2entrez)
    sets <- lapply(sets, function(set) {
      names(probe2entrez)[probe2entrez %in% set]
    })
  }

  # reduce to covariates available in exprs
  if (is(exprs, "eSet"))
    probes <- featureNames(exprs)
  else
    if (gt.options()$transpose)
      probes <- rownames(exprs)
    else
      probes <- colnames(exprs)
  sets <- lapply(sets, function(set) intersect(set, probes))

  # size restrictions
  size <- sapply(sets, length)
  choose <- size >= minsize & size <= maxsize
  sets <- sets[choose]
  myGOTERM <- myGOTERM[choose]
  if (length(sets) == 0) stop("No GO terms wih size between \"minsize\" and \"maxsize\"")
                   
  # perform tests and do multiple testing
  if (length(sets) > 1) {
    multtest <- match.arg(multtest)
    if (multtest == "focuslevel") { 
      ancestors <- lapply(as.list(ontology), function(ont) {
        ext <- paste(ont, "ANCESTOR", sep="")
        GOOBJ <- eval(as.name(paste("GO", ont, "ANCESTOR", sep="")))
        ontid <- intersect(keys(GOOBJ), id)
        if (length(ontid) > 0) lookUp(ontid, "GO", ext) else list()
      })
      ancestors <- do.call(c, ancestors)
      offspring <- lapply(as.list(ontology), function(ont) {
        ext <- paste(ont, "OFFSPRING", sep="")
        GOOBJ <- eval(as.name(paste("GO", ont, "OFFSPRING", sep="")))
        ontid <- intersect(keys(GOOBJ), id)
        if (length(ontid) > 0) lookUp(ontid, "GO", ext) else list()
      })
      offspring <- do.call(c, offspring)      
      offspring <- sapply(offspring, function(os) if (all(is.na(os))) character(0) else os)
      if (is.numeric(focuslevel))
        focuslevel <- findFocus(sets, ancestors = ancestors, offspring = offspring, maxsize = focuslevel)
      res <- gt(response, exprs, ...)
      res <- focusLevel(res, sets=sets, focus=focuslevel, ancestors = ancestors, offspring = offspring)
    } else {
      res <- p.adjust(gt(response, exprs, ..., subsets = sets), method = multtest)
    }
  } else 
    res <- gt(response, exprs, ..., subsets = sets) 
                                          
  # add names
  alias(res) <- sapply(myGOTERM, function(mgt) if (is(mgt, "GOTerms")) Term(mgt) else "")
  alias(res)[is.na(alias(res))] <- ""

  if (sort)
    res <- sort(res)
  
  res
}


gtKEGG <- function(response, exprs, ..., id, annotation, probe2entrez, 
                  multtest = c("Holm", "BH", "BY"), sort = TRUE) {

  # some input checking on response (unavoidable?)
  call <- match.call()
  if (is(exprs, "ExpressionSet")) {
    data <- pData(exprs)
  } else {
    data <- eval(call$data)
  }
  if (is.matrix(data))  
    data <- data.frame(data)
  formula.response <- (length(call$response) > 1) && (call$response[[1]] == "~")
  if (!formula.response) {
    name.response <- deparse(call$response)
    response <- eval(call$response, data, parent.frame())
  }  

  # get the right annotation package
  if (missing(annotation)) {
    if (is(exprs, "eSet")) {
      annotation <- NULL
      annotation <- annotation(exprs)
    } else
      stop("argument \"annotation\" is missing with no default.")
  }
  if (substr(annotation, nchar(annotation)-2, nchar(annotation)) == ".db")
    annotation <- substr(annotation, 1, nchar(annotation)-3)
  package <- paste(annotation, ".db", sep="")
  require(package, character.only=TRUE) || stop("package ", package, " is not available")

  # check whether "org" package is given
  if (substr(annotation,1,4) == "org.")
    extension <- "PATH2EG"
  else
    extension <- "PATH2PROBE"
  KEGGOBJECT <- eval(as.name(paste(annotation, extension, sep="")))
                                   
  # default terms
  if (missing(id))   
    id <- mappedkeys(KEGGOBJECT)

  # retrieve sets
  sets <- lookUp(id, annotation, extension)

  # map back
  if (!missing(probe2entrez)) {
    if (is.environment(probe2entrez) || is(probe2entrez, "AnnDbBimap")) probe2entrez <- as.list(probe2entrez)
    if (is.list(probe2entrez)) probe2entrez <- unlist(probe2entrez)
    sets <- lapply(sets, function(set) {
      names(probe2entrez)[probe2entrez %in% set]
    })
  }

  # reduce to covariates available in exprs
  if (is(exprs, "eSet"))
    probes <- featureNames(exprs)
  else
    if (gt.options()$transpose)
      probes <- rownames(exprs)
    else
      probes <- colnames(exprs)
  sets <- lapply(sets, function(set) intersect(set, probes))

  # perform tests and do multiple testing
  if (length(sets) > 1) {
    multtest <- match.arg(multtest)
    res <- p.adjust(gt(response, exprs, ..., subsets = sets), method = multtest)
  } else 
    res <- gt(response, exprs, ..., subsets = sets) 
  
  # add names
  KEGGNAMES <- KEGGREST::keggList("pathway")
  names(KEGGNAMES) <- gsub("map", "", names(KEGGNAMES))
  
  alias(res) <- KEGGNAMES[names(res)]
  alias(res)[is.na(alias(res))] <- ""

  if (sort)
    res <- sort(res)
  
  res
}


gtBroad <- function(response, exprs, ..., id, annotation, probe2entrez, collection,
                  category = c("c1", "c2", "c3", "c4", "c5"), 
                  multtest = c("Holm", "BH", "BY"), sort = TRUE) {

  # some input checking on response (unavoidable?)
  call <- match.call()
  if (is(exprs, "ExpressionSet")) {
    data <- pData(exprs)
  } else {
    data <- eval(call$data)
  }
  if (is.matrix(data))  
    data <- data.frame(data)
  formula.response <- (length(call$response) > 1) && (call$response[[1]] == "~")
  if (!formula.response) {
    name.response <- deparse(call$response)
    response <- eval(call$response, data, parent.frame())
  }  

  # get the right annotation package
  if (missing(annotation)) {
    if (is(exprs, "eSet")) {
      annotation <- NULL
      annotation <- annotation(exprs)
    } else
      stop("argument \"annotation\" is missing with no default.")
  }
  if (substr(annotation, nchar(annotation)-2, nchar(annotation)) == ".db")
    annotation <- substr(annotation, 1, nchar(annotation)-3)
  package <- paste(annotation, ".db", sep="")
  require(package, character.only=TRUE) || stop("package ", package, " is not available")

  # read the file
  if (missing(collection) || !is(collection, "GeneSetCollection"))
    stop("Please specify a \"collection\", created with the getBroadSets function")
  
  # Get the right categories
  if (!missing(category)) {
    pw.cat <- sapply(sapply(collection, GSEABase::collectionType), GSEABase::bcCategory)
    collection <- collection[pw.cat %in% category]
  }
  
  # Get the right sets
  if (!missing(id)) {
    collection <- collection[id]
  }

  # Map symbol identifiers to anotation-specific identifiers
  collection <- GSEABase::mapIdentifiers(collection, GSEABase::AnnotationIdentifier(annotation))
  sets <- lapply(collection, GSEABase::geneIds)
  names(sets) <- names(collection)

  # map to probe identifiers
  if (!missing(probe2entrez)) {
    if (is.environment(probe2entrez) || is(probe2entrez, "AnnDbBimap")) probe2entrez <- as.list(probe2entrez)
    if (is.list(probe2entrez)) probe2entrez <- unlist(probe2entrez)
    sets <- lapply(sets, function(st) {
      names(probe2entrez)[probe2entrez %in% st]
    })
  }

  # reduce to covariates available in exprs
  if (is(exprs, "eSet"))
    probes <- featureNames(exprs)
  else
    if (gt.options()$transpose)
      probes <- rownames(exprs)
    else
      probes <- colnames(exprs)
  sets <- lapply(sets, function(set) intersect(set, probes))

  # perform tests and do multiple testing
  if (length(sets) > 1) {
    multtest <- match.arg(multtest)
    res <- p.adjust(gt(response, exprs, ..., subsets = sets), method = multtest)
  } else 
    res <- gt(response, exprs, ..., subsets = sets) 
  
  if (sort)
    res <- sort(res)
  
  res
}


###################################################
# Function for using Anni concept profiles
###################################################
gtConcept <- function(response, exprs, ..., annotation, probe2entrez,
                  conceptmatrix, concept2name = "conceptID2name.txt",
                  entrez2concept = "entrezGeneToConceptID.txt", threshold = 1e-4,
                  share = TRUE, multtest = c("Holm", "BH", "BY"),
                  sort = TRUE) {

  # some input checking on response (unavoidable?)
  call <- match.call()
  if (is(exprs, "eSet")) {
    data <- pData(exprs)
  } else {
    data <- eval(call$data)
  }
  if (is.matrix(data))
    data <- data.frame(data)
  formula.response <- (length(call$response) > 1) && (call$response[[1]] == "~")
  if (!formula.response) {
    name.response <- deparse(call$response)
    response <- eval(call$response, data, parent.frame())
  }

  # get the right annotation package
  if (missing(annotation)) {
    if (is(exprs, "eSet")) {
      annotation <- NULL
      annotation <- annotation(exprs)
    } else
      stop("argument \"annotation\" is missing with no default.")
  }
  if (substr(annotation, nchar(annotation)-2, nchar(annotation)) == ".db")
    annotation <- substr(annotation, 1, nchar(annotation)-3)
  package <- paste(annotation, ".db", sep="")
  require(package, character.only=TRUE) || stop("package ", package, " is not available")

  # read the big concept profiles matrix
  nconcepts <- length(scan(conceptmatrix, what="", sep="\t", nlines=1, quiet=TRUE))
  conceptmatrix <- scan(conceptmatrix, what="", sep="\t", quiet=TRUE)
  conceptmatrix <- matrix(conceptmatrix, length(conceptmatrix)/nconcepts, nconcepts, byrow=TRUE)
  rnames <- conceptmatrix[-1,1]
  cnames <- conceptmatrix[1,-1]
  conceptmatrix <- apply(conceptmatrix[-1,-1],2,as.numeric)
  rownames(conceptmatrix) <- rnames
  colnames(conceptmatrix) <- cnames

  # use the threshold
  conceptmatrix[conceptmatrix < threshold] <- 0

  # prepare entrez2concept
  entrez2concept <- matrix(scan(entrez2concept, what="", sep="\t", skip=1, quiet=TRUE), ncol=2, byrow=TRUE)
  nms <- entrez2concept[,1]
  entrez2concept <- as.list(entrez2concept[,2])
  names(entrez2concept) <- nms
                    
  # prepare concept2probe mapping
  if (is(exprs, "eSet"))
    probes <- featureNames(exprs)
  else
    probes <- rownames(exprs)
  if (missing(probe2entrez)) {
    if (substr(annotation,1,3) == "org") {
      probe2entrez <- as.list(probes)    # assuming probe ids are entrez ids
      names(probe2entrez) <- probes
    } else
      probe2entrez <- lookUp(probes, annotation, "ENTREZID")
  } else
    if (is.environment(probe2entrez) || is(probe2entrez, "AnnDbBimap"))
      probe2entrez <- as.list(probe2entrez)
  probe2entrez <- lapply(probe2entrez, as.character)
  probe2concept <- entrez2concept[unlist(probe2entrez)]
  names(probe2concept) <- names(probe2entrez)
  probe2concept <- probe2concept[sapply(probe2concept, length) > 0]

  # find duplicity of concepts and correct weights
  concept2probe <- turnListAround(probe2concept)
  duplicity <- sapply(concept2probe[rnames], length)
  names(duplicity) <- rnames
  if (share)     # divides weight of concept equally over multiple probes
    conceptmatrix <- conceptmatrix / matrix(duplicity, nrow = nrow(conceptmatrix), ncol=ncol(conceptmatrix))
  conceptmatrix <- conceptmatrix[duplicity>0,]

  # find weights
  weights <- lapply(probe2concept, function(pb)
    if(pb %in% rownames(conceptmatrix))
      conceptmatrix[pb,]
    else
      NULL)
  weights <- do.call(rbind, weights)
  weights <- apply(weights, 2, function(cp) cp[cp>0])

  # find alias
  concept2name <- matrix(scan(concept2name, what="", sep="\t", skip=1, quote="", quiet=TRUE), ncol=2, byrow=TRUE)
  nms <- concept2name[,1]
  concept2name <- as.list(concept2name[,2])
  names(concept2name) <- nms
                           browser()
  # perform tests and do multiple testing
  if (length(weights) > 1) {
    multtest <- match.arg(multtest)
    res <- p.adjust(gt(response, exprs, ..., weights = weights), method = multtest)
  } else
    res <- gt(response, exprs, ..., weights = weights)

  # add names
  alias(res) <- concept2name[names(res)]

  if (sort)
    res <- sort(res)

  res
}

focusLevel <- function(test, sets, focus, ancestors, offspring,  
  stop = 1, atoms = TRUE, trace) {

  # rename input
  useAtoms <- atoms
  if (stop <= 1) {
    maxalpha <- stop
    stopafter <- Inf
  } else {
    maxalpha <- 1
    stopafter <- stop
  }       
  if (missing(trace))
    trace <- gt.options()$trace
       
  # input checking 1: sets
  if (missing(sets) && is(test, "gt.object") && !is.null(test@subsets)) 
    sets <- test@subsets
  if (missing(sets)) stop("argument \"sets\" is missing with no default")
  if (is.character(sets))
    if (is(test, "gt.object") && !is.null(test@subsets)) {
      test <- test[sets]
      sets <- test@subsets
    }
  if (is.null(names(sets)))
    stop("sets input has no names attribute.")

  # input checking 2: ancestors and offspring
  if (missing(ancestors) && is(test, "gt.object") && !is.null(test@structure$ancestors))
    ancestors <- test@structure$ancestors
  if (missing(offspring) && is(test, "gt.object") && !is.null(test@structure$offspring))
    offspring <- test@structure$offspring
  if (missing(ancestors) && missing(offspring)) {     # Infer from sets
    ancestors <- new.env(hash=TRUE)
    offspring <- new.env(hash=TRUE)
    for (i in 1:length(sets)) {
      namei <- names(sets)[i]
      for (j in 1:length(sets)) {
        namej <- names(sets)[j]
        if (i != j && length(sets[[i]]) <= length(sets[[j]]) && all(sets[[i]] %in% sets[[j]])) {
          ancestors[[namei]] <- c(ancestors[[namei]], namej)
          offspring[[namej]] <- c(offspring[[namej]], namei)
        }
      }
    }
  }      
  if ((!missing(ancestors)) && is.environment(ancestors))
    ancestors <- as.list(ancestors)
  if ((!missing(offspring)) && is.environment(offspring))
    offspring <- as.list(offspring)
  if (missing(ancestors))
    ancestors <- turnListAround(offspring)
  if (missing(offspring))
    offspring <- turnListAround(ancestors)    

  # Preprocess gt.object input and calculate focus level p-values
  if (trace) cat("Getting raw p-values: ")
  K <- length(sets)
  digitsK <- trunc(log10(K))+1
  if (is(test, "gt.object")) {
    if (is.list(test@weights))
      stop("The focus level method is not applicable with individually weighted sets")
    rawgt <- test
    test <- function(set) rawgt@functions$test(set)[1]
    if (all(names(sets) %in% names(rawgt))) {
      rawgt <- rawgt[names(sets)]
    } else {
      result <- t(sapply(1:K, function(i) {
        if (trace) {
          if (i > 1) cat(rep("\b", digitsK+trunc(log10(i-1))+4), sep="")
          cat(i, " / ", K, sep="")
          flush.console()
        }
        rawgt@functions$test(sets[[i]])
      }))
      rawgt@result <- result
      colnames(rawgt@result) <- c("p-value", "Statistic", "Expected", "Std.dev", "#Cov")
      rownames(rawgt@result) <- names(sets)
      rawgt@subsets <- sets
    }
    rawp <- p.value(rawgt)[focus]
  } else {
    rawgt <- NULL
    rawp <- sapply(1:K, function(i) {
      if (trace) {
        cat(rep("\b", 2*digitsK+3), i, " / ", K, sep="")
        flush.console()
      }
      test(sets[[i]])
    })
    names(rawp) <- names(sets)
  }
  rawp[is.na(rawp)] <- 1
  if (trace) cat(rep("\b", 2*digitsK+25), sep="")

     
  # Prepare the objects that store the test results
  pFocus <- rawp[focus]                                   # Stores the p-values of focus nodes
  sigFocus <- logical(length(focus))                # Keeps track of focus nodes which are declared significant
  names(sigFocus) <- focus
  emptyFocus <- logical(length(focus))              # Keeps track of subgraphs which are completely significant
  names(emptyFocus) <- focus
  atoms <- new.env(hash=TRUE, size=length(focus))   # Stores the atoms of offspring sets of each focus node used to make unions
  unions <- new.env(hash=TRUE, size=length(focus))  # Keeps track of all unions that may be tested
  #pUnions <- vector("list", length(focus))          # Stores the p-values of unions that may be tested
  #names(pUnions) <- focus 
  pUnions <- new.env(hash=TRUE, size=length(focus))
  
  sigUnions <- vector("list", length(focus))        # Keeps track of unions that have so far been called significant
  names(sigUnions) <- focus 
  offspringAtoms <- lapply(as.list(focus), function(term) { # Stores the offspring nodes as unions of atoms
    offnames <- intersect(offspring[[term]], names(sets))
    off <- matrix(,length(offnames),0)
    rownames(off) <- offnames
    off
  })
  names(offspringAtoms) <- focus
  sigOffspring <- vector("list", length(focus))     # Stores which offspring has already been declared significant
  names(sigOffspring) <- focus
  adjustedP <- rep(NA, length(sets))             # Prepare the vector of corrected p-values
  names(adjustedP) <- names(sets)

  # Find all GO terms above the focus level
  forefathers <- unique(unlist(ancestors[focus]))
  forefathers <- setdiff(forefathers, focus)
  forefathers <- setdiff(forefathers, unique(unlist(offspring[focus])))

  # Initialize
  alpha <- 0
  holm <- length(focus)
  indirectAffected <- list()
  ready <- FALSE
  change <- TRUE
  if (missing(trace)) trace <- interactive()

  
  while (! ready) {
  
    # Find the focus terms where the action is
    affected1 <- focus[(!sigFocus) & (pFocus * holm <= alpha)]    # Find newly significant focus level terms
    opensubgraphs <- focus[sigFocus & (!emptyFocus)]              # Find the subgraphs in which something may happen
    minP <- sapply(opensubgraphs, function(ff) min(pUnions[[ff]][!sigUnions[[ff]]]))  # Find the smallest p-value not yet declared significant
    if (length(minP) > 0) {
      names(minP) <- opensubgraphs
      affected2 <- names(minP * holm <= alpha)                      # Find those subgraphs for which that minimum is significant
    } else {
      affected2 <- character(0)
    }
    affected <- unique(c(affected1, affected2, names(indirectAffected)))  # Include those significant through upward propagation
    
    newSigGO <- character(0)
    change <- FALSE
    
    for (term in affected) {
      
      # If a focus term was declared significant. Start a new subgraph
      if (!sigFocus[term]) {                                
        sigFocus[term] <- TRUE
        newSigGO <- c(newSigGO, term)                       # A GO term has been declared significant
        if (trace > 1) cat("Rejected:", term, "\n")
        alloffspring <- intersect(offspring[[term]], names(sets))
        if (length(alloffspring) > 0) {
          offspringSets <- sets[alloffspring]
          if (useAtoms)
            TermAtoms <- getAtoms(offspringSets)                                  # Get the set of atoms
          else
            TermAtoms <- getNoAtoms(offspringSets) 
          atoms[[term]] <- TermAtoms
          unions[[term]] <- matrix(rep(TRUE, length(TermAtoms)), 1, length(TermAtoms))  # Prepare the matrix of unions of atoms
          sigUnions[[term]] <- FALSE
          pUnions[[term]] <- sapply(list(unique(unlist(TermAtoms))), test)                  # Start by testing the union of all atoms
          pUnions[[term]][is.na(pUnions[[term]])] <- 1
          offspringAtoms[[term]] <- matrix(sapply(TermAtoms, function(y)            # Write all offspring as unions of atoms
            sapply(offspringSets, function(x) all(y %in% x))), ncol = length(TermAtoms))
          rownames(offspringAtoms[[term]]) <- names(offspringSets)
          sigOffspring[[term]] <- logical(length(offspringSets))
          names(sigOffspring[[term]]) <- names(offspringSets)
        } else {                                                                # An empty version for when the focus term is an end node
          sigUnions[[term]] <- logical(0)
          atoms[[term]] <- list()
          unions[[term]] <- matrix(,0,0)
          offspringAtoms[[term]] <- matrix(,0,0)
          sigOffspring[[term]] <- logical(0)
        }
        change <- TRUE
      } 
      
      # Propagate significance from offspring that was declared significant in another subgraph
      propagate <- indirectAffected[[term]]                 
      propagate <- propagate[!(propagate %in% term)]
      propagate <- propagate[!sigOffspring[[term]][propagate]]
      if (length(propagate) > 0) {
        pPatterns <- matrix(,0,length(atoms[[term]]))   # Get all superset patterns of a propagated GO term 
        for (i in 1:length(propagate)) {
          basePattern <- offspringAtoms[[term]][propagate[[i]],] # The propagated GO term as unions of atoms
          ancestorPatterns <- fillPattern(basePattern)      # All superset patterns as unions of atoms
          ancestorPatterns <- ancestorPatterns[!intersectPatterns(ancestorPatterns, pPatterns),,drop=FALSE]    # Remove duplicates
          pPatterns <- rbind(pPatterns, ancestorPatterns)
        }
        matchedPatterns1 <- intersectPatterns(pPatterns, unions[[term]])  # These new patterns were already testable
        matchedPatterns2 <- intersectPatterns(unions[[term]], pPatterns)  # These already testable patterns are now called significant
        newPatterns <- pPatterns[!matchedPatterns1,, drop=FALSE]          # These are new patterns
        if (trace > 1) cat("\t\tSignificance of", nrow(newPatterns), "sets from", propagate, " propagated to", term, "\n")
        unions[[term]] <- rbind(unions[[term]], newPatterns)              # Make all supersets testable and give them raw p 0
        pUnions[[term]][which(matchedPatterns2)] <- 0                     
        pUnions[[term]] <- c(pUnions[[term]], rep(0, nrow(newPatterns)))
        sigUnions[[term]] <- c(sigUnions[[term]], rep(FALSE, nrow(newPatterns)))    # These patterns will be called significant later
        change <- TRUE
      }
      
      # Find the testable non-significant unions with small p-values
      newsigs <- (pUnions[[term]] * holm <= alpha) & !sigUnions[[term]]     
      newsigs <- which(newsigs)
      
      # Find whether there are GO terms among the newly significant unions
      sigPatterns <- unions[[term]][newsigs,, drop=FALSE]
      offspringPatterns <- offspringAtoms[[term]][!sigOffspring[[term]],,drop=FALSE]     # Patterns of not already significant offspring
      matched <- intersectPatterns(offspringPatterns, sigPatterns)                  # Any new offspring terms among the significant patterns?
      newSigOffspring <- rownames(offspringPatterns)[matched]
      if (trace > 1 && (length(setdiff(newSigOffspring, propagate))>0)) {
        cat("Signficant:", setdiff(newSigOffspring, propagate), "\n")
      }
      newSigGO <- c(newSigGO, newSigOffspring)                 
      sigOffspring[[term]][newSigOffspring] <- TRUE
      
      # Expand the current subgraph by finding new unions that may now be tested, and find the p-values
      newpatterns <- matrix(, 0, length(atoms[[term]]))
      for (ix in newsigs) {
        sigUnionsMatrix <- unions[[term]][sigUnions[[term]], ,drop = FALSE]         # The unions so far significant for this term
        pattern <- unions[[term]][ix,]      # the significant pattern
        if (sum(pattern) > 1) {
          for (iy in (1:length(pattern))[pattern]) { # For-loop over the TRUEs
            newpattern <- pattern
            newpattern[iy] <- FALSE # All direct subsets have one extra FALSE
            reallyNew <- !any(intersectPatterns(matrix(newpattern,nrow=1), unions[[term]])) # Is the pattern really new?
            if (reallyNew) {      # Are the other parents of this pattern also present?
              parentspresent <- all(sapply((1:length(newpattern))[!pattern], function(iz) { # Loop over the FALSEs of pattern
                newpatternparent <- newpattern
                newpatternparent[iz] <- TRUE                        # The parents of newpattern have one extra TRUE
                any(apply(sigUnionsMatrix, 1, function(pttn) all(pttn == newpatternparent))) # Is this superset present among the significant tests?
              }))
              if (parentspresent) {
                newpatterns <- rbind(newpatterns, newpattern)
                rownames(newpatterns) <- NULL
              }
            }
          }
        }
        sigUnions[[term]][ix] <- TRUE # Only now call the term itself significant (prevents duplicate patterns)
      }
      unions[[term]] <- rbind(unions[[term]], newpatterns)
      sigUnions[[term]] <- c(sigUnions[[term]], rep(FALSE, nrow(newpatterns)))
      if (length(newpatterns) > 0) {                        # Calculate and store their p-values
        if (trace > 1) cat("\t\ttests:", nrow(newpatterns), "in", term, "\n")
        newsets <- lapply(as.list(1:nrow(newpatterns)), function(i) { # Assemble gene sets from the atoms
          unique(unlist(atoms[[term]][newpatterns[i,]]))
        })
        newpvalues <- sapply(newsets, test)
        newpvalues[is.na(newpvalues)] <- 1
        pUnions[[term]] <- c(pUnions[[term]], newpvalues) 
        change <- TRUE
      }
      
      # Is the subgraph emptied?
      empty <- (length(atoms[[term]]) == 0) || (all(sigOffspring[[term]]))
      if (empty) {                                          
        emptyFocus[term] <- TRUE
      }
    } 
    
    if (length(newSigGO)>0) {
      change <- TRUE                # Don't change alpha yet; there may be propagation to be done
      adjustedP[newSigGO] <- alpha  # Adjusted P for newly affected GO terms
    }
    
    # Find all forefather terms that are now significant
    affectedGOforefathers <- unique(unlist(ancestors[newSigGO])) # Find GO terms above the focus level significant through propagation
    affectedGOforefathers <- intersect(affectedGOforefathers, forefathers)
    newlyAffectedGOforefathers <- intersect(affectedGOforefathers, names(adjustedP[is.na(adjustedP)]))
    adjustedP[newlyAffectedGOforefathers] <- alpha
    if (trace > 1 && (length(newlyAffectedGOforefathers) > 0))
      cat("Rejected because of rejected offspring:", newlyAffectedGOforefathers, "\n")
      
    # For all significant GO terms, see if they are also present in other subtrees  
    affectedGOwithParents <- lapply(as.list(newSigGO), function(nsg) { 
      present1 <- sapply(offspringAtoms, function(off) nsg %in% rownames(off))
      present2 <- focus %in% nsg
      focus[present1 | present2]
    })      # Creates a list of new significant GO terms, listing the subtrees they appear in
    names(affectedGOwithParents) <- newSigGO
    indirectAffected <- turnListAround(affectedGOwithParents)  # Reverses the list to a list of subtrees, listing the significant GO offspring terms
    
    # Output progress information
    if (trace == 1) {
      cat(paste(rep("\b", 48), collapse=""))
      cat("Alpha = ", format(alpha, digits=3, scientific=T, width= 10), ": rejected terms: ", format(sum(!is.na(adjustedP)), width=5), ".", sep="")
      flush.console()
    }
    
    # If nothing happened, increase alpha
    if (!change) { 
      allPs <- sort(c(pFocus, unlist(as.list(pUnions))))
      allPs <- allPs[allPs * holm > alpha]
      alpha <- allPs[1] * holm
      names(alpha) <- NULL
      if (trace > 1) cat("\tAlpha =", format(alpha, digits=3, scientific=T, width= 10), "\n")
    } else {
      if (trace > 1 && (holm > sum(!emptyFocus))) cat("Holm's factor:", sum(!emptyFocus), "\n")
      holm <- sum(!emptyFocus)
    }
    ready <- (holm == 0) || (alpha > maxalpha) || (sum(!is.na(adjustedP)) >= stopafter)
  } 
  
  # ready
  if (trace==1) {
    cat(paste(rep("\b", 48), collapse=""))
    cat("Alpha = ", format(1, digits=3, scientific=T, width= 10), ": rejected terms: ", format(length(adjustedP), width=5), ".\n", sep="")
  }
  if (alpha >= 1)
    adjustedP[is.na(adjustedP)] <- 1
  
  # return
  if (!is.null(rawgt)) {
    extra <- rawgt@extra
    extra[["focuslevel"]] <- adjustedP
    rawgt@extra <- as.data.frame(extra) 
    rawgt@structure <- list(ancestors=ancestors,offspring=offspring)
    return(rawgt)  
  } else {
    return(data.frame(raw.p = rawp, focuslevel = adjustedP))
  }
}


# Finds all ancestor patterns of a pattern
fillPattern <- function(pattern) {
  k <- sum(!pattern)
  out <- matrix(T, 2^k, length(pattern))
  if (k>0) {
    out[,!pattern] <- sapply(1:k, function(i) {
      rep(c(T,F), each = 2^(i-1), times = 2^(k-i))
    })
  }
  out
}


# Finds patterns in "patterns" which also occur in "matchto"
# Equivalent to %in% but for matrices
intersectPatterns <- function(patterns, matchto) {
  if (nrow(matchto) > 0) {
    matched <- apply(patterns, 1, function(pattern1) {
      any(apply(matchto, 1, function(pattern2) 
        all(pattern1 == pattern2)
      ))
    })
  } else {
    matched <- logical(nrow(patterns))
  }
  dim(matched) <- NULL
  matched
}


# Starts from a named list and "turns it around"
# Returns a named list of length(all elements of the list)
# Each element of the list gives the names of the original list elements
# that contained that element
.turnListAround <- function(aList) { #old
  newlist <- new.env(hash=TRUE)
  objs <- names(aList)
  if (is.null(objs)) objs <- seq_along(alist)
  for (i in objs) {
    for (j in aList[[i]]) {
      newlist[[j]] <- c(newlist[[j]], i)
    }
  }
  as.list(newlist)
}
      
turnListAround <- function(alist) {
  alist2 <- unlist(alist)
  alist1 <- rep(names(alist), sapply(alist, length))
  res <- tapply(alist1, alist2, identity, simplify=FALSE)
  res
}

# This function extracts the smallest possible number of atoms from 
# sets, such that all sets can be built as unions of these atoms
# Note: These atoms lead to slightly conservative closed testing
# example: 1,2,23 is reduced to 1,2,3 and leads to unnessesary testing of 13 prior to testing 1.
# But: 1,12,13,23 is now reduced to 1,2,3 while otherwise it would not be reduced.
getAtoms <- function(allsets) {
          
  if (!is(allsets, "list")) {                                           # Coerce to a list
    allsets <- list(allsets)
  }
  allsets <- allsets[sapply(allsets, length) > 0]                       # Remove empty sets
  allsets <- lapply(allsets, function(set) set[!is.na(set)])            # Remove NAs
  setdiffs <- vector("list", length(allsets))                           # Prepare output
  i <- 0
  lastAtom <- character(0)
  while (length(allsets) > 0) {
    allsets <- lapply(allsets, function(set) setdiff(set, lastAtom))    # Remove probes in the last atom from every set
    allsets <- allsets[sapply(allsets, length) > 0]                     # Remove empty sets
    if (length(allsets) > 0) {
      i <- i+1
      allsets <- allsets[sort.list(sapply(allsets, length))]            # Sort by size
      lastAtom <- allsets[[1]]                                          # Next atom: smallest non-empty set
      setdiffs[i] <- allsets[1]                                         # Store the atom
    }
  } 

  setdiffs[1:i]
}

# No atoms variant: only throws away redundant sets
getNoAtoms <- function(sets) {
                     
  if (!is(sets, "list")) {                                     # Coerce to a list
    sets <- list(sets)
  }
  sets <- sets[sapply(sets, length) > 0]                       # Remove empty sets
  sets <- lapply(sets, function(set) set[!is.na(set)])         # Remove NAs
  K <- length(sets)
  redundant <- rep(FALSE, K)                                   # redundant sets are sets that are unions of other sets
  for (i in 1:K) {
    contained <- sapply(sets, function(set) all(set %in% sets[[i]]))
    redundant[i] <- all(sets[[i]] %in% unlist(sets[contained & (1:K != i) & !redundant]))
  }
  sets[!redundant]
}


findFocus <- function(sets, ancestors, offspring, maxsize = 10, atoms = TRUE) {

  useAtoms <- atoms

  if (is(sets, "gt.object") && !is.null(sets@subsets)) 
    sets <- sets@subsets
  if (missing(sets)) stop("argument \"sets\" is missing with no default")
  if (is.character(sets))
    if (is(test, "gt.object") && !is.null(test@subsets)) {
      test <- test[sets]
      sets <- test@subsets
    }
  if (missing(ancestors) && missing(offspring)) {     # Infer from sets
    ancestors <- new.env(hash=TRUE)
    offspring <- new.env(hash=TRUE)
    for (i in 1:length(sets)) {
      namei <- names(sets)[i]
      for (j in 1:length(sets)) {
        namej <- names(sets)[j]
        if (i != j && length(sets[[i]]) <= length(sets[[j]]) && all(sets[[i]] %in% sets[[j]])) {
          ancestors[[namei]] <- c(ancestors[[namei]], namej)
          offspring[[namej]] <- c(offspring[[namej]], namei)
        }
      }
    }
  }      
  if ((!missing(ancestors)) && is.environment(ancestors))
    ancestors <- as.list(ancestors)
  if ((!missing(offspring)) && is.environment(offspring))
    offspring <- as.list(offspring)
  if (missing(ancestors))
    ancestors <- turnListAround(offspring)
  if (missing(offspring))
    offspring <- turnListAround(ancestors)    
                        
  # Prune offspring
  offspring <- lapply(offspring, function(set) intersect(set, names(sets)))                      
                        
  # Find all nodes with at most 5*maxatoms offspring sets
  # and at most maxatoms atoms
  allnodes <- names(sets)
  doable <- sapply(offspring[allnodes], length) <= 5 * maxsize
  names(doable) <- names(sets)
  for (term in allnodes[doable]) {
    if (length(offspring[[term]]) > 0) {
      if (useAtoms)
        atoms <- getAtoms(sets[offspring[[term]]])
      else
        atoms <- getNoAtoms(sets[offspring[[term]]])
    } else {
      atoms <- character(0)
    }
    doable[term] <- (length(atoms) <= maxsize)
  }

  # Find all doable nodes with no doable ancestors
  alldoable <- allnodes[doable]
  ancestors <- ancestors[doable]
  redundant <- sapply(alldoable, function(id) {
    any(ancestors[[id]] %in% alldoable)
  })
  alldoable[!redundant]
}


# Finds the leaves of a significant graph
leaveNodes <- function(object, alpha=0.05, ancestors,type) {

  if (missing(ancestors)) {     # Infer from sets
    sets <- object@subsets
    ancestors <- new.env(hash=TRUE)
    for (i in 1:length(sets)) {
      namei <- names(sets)[i]
      for (j in 1:length(sets)) {
        namej <- names(sets)[j]
        if (i != j && length(sets[[i]]) <= length(sets[[j]]) && all(sets[[i]] %in% sets[[j]])) {
          ancestors[[namei]] <- c(ancestors[[namei]], namej)
        }
      }
    }
    ancestors <- as.list(ancestors)
  }

 if (missing(type)) type=names(object@extra)[1]
 
  focusP <- object@extra[[type]]      
  if (is.null(focusP)) stop("No focus level p-values")
  
  significant <- names(object)[focusP <= alpha]
  sign.anc <- unique(unlist(ancestors[significant]))
  significant <- setdiff(significant, sign.anc)
  
  object[significant]
}

# Takes sets to ancestors mapping; converts it to sets to parents mapping
ancestors2parents <- function(ancestors) {
  lapply(ancestors, function(anc) {
    setdiff(anc, unique(unlist(ancestors[anc])))
  })
}

gt <- function(response, alternative, null, data, test.value,    
            model = c("linear", "logistic", "cox", "poisson", "multinomial"), levels,
            directional = FALSE, standardize = FALSE, permutations = 0, 
            subsets, weights, alias, x = FALSE, trace) {
  
  # store the call
  call <- match.call()
  
  # avoid conflict between "levels" input and "levels" function
  if (missing(levels)) levels <- NULL
                       
  # data default
  if (missing(data)) {
    if ((!missing(alternative)) && (is(alternative, "ExpressionSet"))) {
      data <- pData(alternative)
    } else
      data <- NULL
  }
  if (is.matrix(data))  
    data <- data.frame(data)

  # evaluate response, which may be one of the colnames of data
  response <- eval(call$response, data, parent.frame())

  # settle null, alternative and response if response is a formula
  if (missing(null) || is.null(null)) {
    if ((!missing(alternative)) && is(response, "formula"))
      null <- response
    else
      null <- ~1
  } 
  if (missing(alternative))
    if (is(response, "formula"))
      alternative <- response
    else
      stop("argument \"alternative\" is missing, with no default")  
  if (is(response, "formula")) {
    name.response <-  deparse(eval(response)[[2]])
    response <- eval(attr(terms(response, data=data), "variables"), data, environment(response))[[attr(terms(response, data=data), "response")]]
  } else {
    name.response <- deparse(call$response)
  }
  
  # remove redundant levels from factor response
  # and coerce response to factor in case of levels input
  if (is.factor(response) || !is.null(levels))
    response <- factor(response) 
                                     
  # get the model
  if (missing(model)) {
    if(is(response, "Surv")) 
      model <- "cox"
    else if ((is.factor(response) && length(levels(response)) <= 2) || is.logical(response)) 
      model <- "logistic"
    else if (is.factor(response) && length(levels(response)) > 2)
      model <- "multinomial"
  }
  model <- match.arg(tolower(model), c("linear", "logistic", "cox", "poisson", "multinomial"))

  # if multinomial, coerce to factor and remove redundant level
  if (model=="multinomial" && !is.factor(response))
      response <- factor(response)
  
  # if multinomial, coerce to logistic if possible
  if (model=="multinomial" && nlevels(response)==2)
    model <- "logistic"
  
  # find the sample size
  if (model == "cox") {
    if (attr(response, "type") %in% c("right", "counting"))
      n <- nrow(response)
    else
      stop("survival data of type", attr(response, "type"), "not supported")
  } else {
    n <- length(response)
  }
                


  
  # remove terms from alternative that are also in null
  if (is(null, "formula") && is(alternative, "formula") && 
      identical(environment(null), environment(alternative))) {
    dup <- attr(terms(alternative, data=data), "term.labels") %in% attr(terms(null, data=data), "term.labels")
    if (all(dup)) stop("all covariates in alternative also in null")  
    if (any(dup)) 
      alternative <- formula(terms(alternative,data=data)[!dup])
  }
  
  
  # print a warning, when strata appear in alternative that do not appear in null, remove them from alternative
  if (is(alternative, "formula")) {
    if (length(attr(terms(alternative, specials = "strata", data=data), "specials")$strata) > 0) {
      altterms <- terms(alternative, specials = "strata", data=data)
      strata <- untangle.specials(altterms, "strata", 1)
      strata.nrs <- strata$terms
      alternative <- formula(altterms[-strata.nrs])
      warning("there are strata in alternative, which do no appear in null. strata only appearing in alternative are ignored")
      if (length(attr(terms(alternative, data=data), "term.labels")) == 0)
        stop("all covariates in alternative also in null")
    }
  }
  
  
  # extract strata out of null  
  if (is(null, "formula")) {
    nullterms <- terms(null, specials = "strata", data=data)
    if (length(attr(nullterms, "specials")$strata) > 0) {
      if (model == "cox") {
        strata <- untangle.specials(nullterms, "strata", 1)
        strata.nrs <- strata$terms
        strata.nrs2 <- attr(nullterms, "specials")$strata
        if (missing(data)) 
          strata <- strata(eval(attr(nullterms, "variables"), 
                                environment(nullterms))[strata.nrs2], shortlabel = TRUE)
        else
          strata <- strata(eval(attr(nullterms, 
                                        "variables"), data, environment(nullterms))[strata.nrs2], 
                              shortlabel = TRUE)
        null <- formula(nullterms[-strata.nrs])
      } 
      else 
        stop("strata only implemented for Cox model")
    }
    else 
      strata <- NULL
  }
  

  # get null and alternative
  null <- .getNull(null, data, n, model)
  alternative <- .getAlternative(alternative, data, n)

  # Adjust input due to levels argument
  if ((!is.null(levels)) && is.factor(response)) {
    if (!all(levels %in% levels(response)))
      stop("argument \"levels\" does not match levels(response)")
    if (length(levels) > 1) {
      select <- response %in% levels
      response <- factor(response[select], levels=levels)
      alternative <- alternative[select,,drop=FALSE]
      null$null <- null$null[select,, drop=FALSE]
      if (!is.null(null$offset)) 
        null$offset <- null$offset[select]
      if (length(levels) == 2)
        model <- "logistic"
    } else {
      response <- factor(response == levels)
      levels(response) <- c("other", levels)
      model <- "logistic"
    }
  }

  # prepare legends for plots later
  legend <- list()
  if (model == "logistic") {
    if (is.factor(response)) {
      legend$cov <- paste("assoc. with", name.response, "=", rev(levels(response)))
      legend$subj <- paste(name.response, "=", rev(levels(response)))
    } else {
      legend$cov <- paste("assoc. with", name.response, "=", 1:0)
      legend$subj <- paste(name.response, "=", 1:0)
    }
  } else if (model == "multinomial") {
    legend$cov <- paste("assoc. with", name.response, "=", levels(response))
    legend$subj <- paste(name.response, "=", levels(response))
  } else if (model %in% c("linear", "poisson")) {
    legend$cov <- paste(c("pos. assoc. with", "neg. assoc. with"), name.response)
    legend$subj <- paste(c("pos. residual", "neg. residual"), name.response)
  } else { # model = "survival" 
    legend$cov <- c("pos. assoc. with survival", "neg. assoc. with survival")
    legend$subj <- c("late event or censored", "early event")
  }

  #subsets and weigths
  if (!missing(subsets) && !is.list(subsets))
    subsets <- list(subsets)
  many.subsets <- !missing(subsets)
  one.weight <- (!missing(weights)) && (!is.list(weights)) && (length(weights)==ncol(alternative)) && many.subsets
  many.weights <- (!missing(weights)) && (!one.weight)
  if (many.weights && !is.list(weights))
    weights <- list(weights)

  # if a test.value was specified, adjust the offset term
  # NOTE: test.value is interpreted relative to alternative BEFORE standardizaton and weighting
  if (!missing(test.value)) {
    if (length(test.value) == ncol(alternative))
      test.offset <- drop(alternative %*% test.value)
    else if ((length(subsets)==1) && (length(test.value) == length(subsets[[1]])))
      test.offset <- drop(alternative[,subsets[[1]], drop=FALSE] %*% test.value)
    else
      stop("the length of \"test.value\" (",length(test.value), ") does not match the the number of covariates in \"alternative\" (", ncol(alternative), ")")
    if (!is.null(null$offset))
      offset <- null$offset + test.offset
    else      
      offset <- test.offset
  } else
    offset <- null$offset   
  null <- null$null
  if (model == "multinomial" && !is.null(offset))
    stop("offset term and test.value not yet implemented for the multinomial model")

  # conservatively impute missing values in alternative
  all.na <- apply(is.na(alternative), 2, all)
  some.na <- apply(is.na(alternative), 2, any) & !all.na
  if (ncol(null) == 0) {
    if (model == "cox") {
      alternative[,some.na] <- apply(alternative[,some.na, drop=FALSE], 2, function(cov) {
        cov[is.na(cov)] <- mean(cov, na.rm=TRUE)
        cov
      })
    } else
      alternative[is.na(alternative)] <- 0
  } else {
    alternative[,some.na] <- apply(alternative[,some.na, drop=FALSE], 2, function(cov) {
      fit <- lm(cov ~ 0 + null, x = TRUE)
      coefs <- coef(fit)
      coefs[is.na(coefs)] <- 0
      cov[is.na(cov)] <- drop(null %*% coefs)[is.na(cov)]
      cov
    })
    alternative[,all.na] <- 0 
  }
                            
  # deafult alias
  if (missing(alias)) alias <- NULL

  # check weights and subsets lengths
  if (many.subsets && many.weights) {
    if (length(subsets) != length(weights))
      stop("lengths of \"subsets\" and \"weights\" do not match")
    if ((!is.null(names(subsets))) && (!is.null(names(weights))) && (!all(names(subsets)==names(weights))))
      if (is.null(alias))
        alias <- names(weights)
      else
        warning("names of subsets and weights do not match")
  }
  
  # make sure subsets is a list of names, compatible with colnames(alternative)
  if (many.subsets && gt.options()$trim) {
    osl <- sapply(subsets, length)
    subsets <- lapply(subsets, function(sst) {
      if (!is.character(sst)) 
        colnames(alternative)[sst]
      else
        intersect(sst, colnames(alternative))
    })
  }
                                  
  # make sure that weights is a named list, compatible with colnames(alternative)
  if (many.weights) {
    names.weights <- names(weights)
    weights <- lapply(1:length(weights), function (i) {
      wt <- weights[[i]]
      if (!is.null(names(wt)))
        wt <- wt[names(wt) %in% colnames(alternative)]
      else 
        if (many.subsets && length(wt) == length(subsets[[i]]))
          names(wt) <- subsets[[i]]
        else if (length(wt) == ncol(alternative))
          names(wt) <- colnames(alternative)
      wt
    })
    names(weights) <- names.weights
    if (any(sapply(lapply(weights, names), is.null)))
      stop("weights input is not compatible with covariates input.")
  }
  
  # make subsets and weights compatible
  if (many.subsets && many.weights) {
    weights <- lapply(1:length(weights), function(i) {
      if (all(subsets[[i]] %in% names(weights[[i]])))
        weights[[i]][subsets[[i]]]
      else 
        stop("names of weights input incompatible with subsets input.")
    })
  }

  # trim zero weights
  if (many.weights) {
    if (any(unlist(weights)==0)) {
      weights <- lapply(weights, function(wt) wt[wt != 0])
      many.subsets <- FALSE   # to redo subsets
    }
  }
  
  # make subsets in case of short named weights
  if (many.weights && !many.subsets && any(sapply(weights, length) != ncol(alternative))) {
    subsets <- lapply(weights, names)
    many.subsets <- TRUE
  }
  
  # check missing values in subsets
  if (many.subsets && any(sapply(subsets, function(x) any(is.na(x))))) {
    stop("missing values in \"subsets\"")
  }
  
  # prepare progress info
  if (missing(trace)) trace <- gt.options()$trace && (many.weights || many.subsets)
  if (trace && (many.subsets || many.weights)) {
    if (many.subsets) 
      K <- length(subsets) 
    else 
      K <- length(weights) 
    digitsK <- trunc(log10(K))+1
  }

  # standardize and weight
  if (standardize || one.weight) {
    if (one.weight) {
      if (length(weights) != ncol(alternative)) 
        stop("length of \"weights\" does not match column count of \"alternative\"")
      all.weights <- weights
    } else
      all.weights <- rep(1, ncol(alternative))
    if (standardize) {
      vars <- apply(alternative,2,var) * (n-1)/n
      vars[vars == 0] <- 1
      all.weights <- all.weights / vars
    }
    alternative <- alternative * matrix(sqrt(all.weights), nrow(alternative), ncol(alternative), byrow=TRUE)
  }
                       
  # Make the test function
  funs <- switch(model,
    linear = .lineartest(response, Z=null, X=alternative, offset=offset, dir = directional, perms = permutations),
    logistic = .glmtest(response, Z=null, X=alternative, offset=offset, family = "binomial", dir = directional, perms=permutations),
    poisson = .glmtest(response, Z=null, X=alternative, offset=offset, family = "poisson", dir = directional, perms=permutations),
    multinomial = .multinomialtest(response, Z=null, X=alternative, dir = directional, perms=permutations),
    cox = .coxtest(response, Z=null, X=alternative, offset=offset, dir = directional, perms=permutations, strat=strata)
  )    
  test <- funs$test
                                                      
  # Do the test
  if ((!many.subsets) && (!many.weights)) {           # single weighting; single subset
    res <- test()
  } else {     
    L <- if (many.subsets) length(subsets) else length(weights)                 
    res <- sapply(1:L, function (i) {
      if (trace && L>1) {
        cat(rep("\b", 2*digitsK+3), i, " / ", K, sep="")
        flush.console()
      }
      if (!many.weights) {                                           # single weighting; many subsets
        uit <- test(subset=subsets[[i]]) 
      } else if (!many.subsets) {                                    # many weightings; single subset
        uit <- test(weights=weights[[i]]) 
      } else {                                                       # many weightings; many subsets
        uit <- test(subset=subsets[[i]], weights=weights[[i]])
      } 
      uit
    })
    if (many.subsets && !is.null(names(subsets)))
      colnames(res) <- names(subsets)
    else if (many.weights && !is.null(names(weights)))
      colnames(res) <- names(weights)
  }
  if (trace && (many.subsets || many.weights) && L>1) cat("\n")
  res <- t(res)
                                                    
  # return
  out <- new("gt.object")
  out@call <- call
  colnames(res) <- c("p-value", "Statistic", "Expected", "Std.dev", "#Cov")
  out@result <- res
  out@functions <- funs
  if (many.subsets) out@subsets <- subsets
  if (many.weights) out@weights <- weights
  out@directional <- directional > 0
  out@legend <- legend
  out@model <- model
  if (!is.null(alias)) alias(out) <- alias

  if (x) {
    out@null <- null
    out@alternative <- alternative
  }
  
  return(out)
}

#==========================================================
# Function "sampling" compares the p.value(s) found with
# p-values from randomly generated "pathways" of the same size
# as the tested pathway.
#==========================================================
comparative <- function(object, N = 1e3, z.scores = TRUE, trace)
{
  p <- object@functions$df()[3]

  if (is.null(object@weights)) {
  
    # comparative proportion can be calculated at once for all subsets with the same size
    sizes <- unique(size(object))
    sizes <- as.list(sizes)
  
    K <- length(sizes)
    digitsK <- trunc(log10(K))+1

    if (missing(trace)) trace <- interactive() && K > 1
  
    sampling.list <- lapply(seq_along(sizes), function(i) {
      if (trace) {
        cat(rep("\b", 2*digitsK+3), i, " / ", K, sep="")
        flush.console()
      }
      m <- sizes[[i]]
      if (m %in% c(0,p)) 
        pps <- NA
      else {      
        if (m < p/2) {
          randomsets <- replicate(N, sample(p, m), simplify = FALSE)
        } else {
          randomsets <- replicate(N, - sample(p, p-m), simplify = FALSE)
        }               
        pps <- sapply(1:N, function(j) {
          res <- object@functions$test(randomsets[[j]], calculateP = !z.scores)
          if (z.scores) 
            -(res["S"] - res["ES"]) / res["sdS"]     #minus z as proxy for p
          else
            res["p"]
        })
      }
    })
    names(sampling.list) <- paste("size", sizes, sep="")
  
    if (z.scores) true.p <- -z.score(object) else true.p <- p.value(object)
    true.size <- paste("size", size(object), sep="")
    comparative <- sapply(1:length(object), function(i) {
      if (true.size[i] %in% c(0,p))
        NA
      else
        mean(true.p[i] >= sampling.list[[true.size[i]]])
    })
  } else { 
    K <- length(object)
    digitsK <- trunc(log10(K))+1

    if (missing(trace)) trace <- interactive() && K > 1
  
    if (z.scores) true.p <- -z.score(object) else true.p <- p.value(object)
        
  
    if (is.null(object@subsets)) {
      comparative <- sapply(1:length(object), function(i) {
        randomweights <- replicate(N, object@weights[[i]][sample(p,p)], simplify=FALSE)
        if (trace) {
          cat(rep("\b", 2*digitsK+3), i, " / ", K, sep="")
          flush.console()
        }
        pps <- sapply(1:N, function(j) {
          if (trace) {
            cat(rep("\b", 2*digitsK+3), N*(i-1) + j, " / ", K, sep="")
            flush.console()
          }
          res <- object@functions$test(weight = randomweights[[j]], calculateP = !z.scores)            
          if (z.scores) 
            -(res["S"] - res["ES"]) / res["sdS"]     #minus z as proxy for p
          else
            res["p"]
        })
        mean(true.p[i] >= pps)
      })  
    } else {
      comparative <- sapply(1:length(object), function(i) {
        size <- length(object@subsets[[i]])
        randomsubsets <- replicate(N, sample(p,size), simplify=FALSE)
        if (trace) {
          cat(rep("\b", 2*digitsK+3), i, " / ", K, sep="")
          flush.console()
        }
        pps <- sapply(1:N, function(j) {
          if (trace) {
            cat(rep("\b", 2*digitsK+3), N*(i-1) + j, " / ", K, sep="")
            flush.console()
          }
          res <- object@functions$test(subset = randomsubsets[[j]], weight = object@weights[[i]], calculateP = !z.scores)
          if (z.scores) 
            -(res["S"] - res["ES"]) / res["sdS"]     #minus z as proxy for p
          else
            res["p"]
        })
        mean(true.p[i] >= pps)
      })  
    }      
  }
  if (trace) cat("\n")
 
  if (is.null(object@extra))
    object@extra <- as.data.frame(matrix(,length(object),0), row.names=names(object))
  object@extra[["comparative"]] <- comparative
  object

}


#==========================================================

#==========================================================
# CLASS DEFINITION *** CLASS DEFINITION *** CLASS DEFINITION
#==========================================================
setClassUnion("matrixOrNULL", c("matrix", "NULL"))
setClassUnion("listOrNULL", c("list", "NULL"))

setClass("gt.object", 
  representation(
    result = "matrix",
    extra = "data.frameOrNULL",
    call = "call", 
    functions = "environment",#"list",
    subsets = "listOrNULL",
    structure = "listOrNULL",
    weights = "listOrNULL",
    alternative = "matrixOrNULL",
    null = "matrixOrNULL",
    directional = "logical",
    legend = "list",
    model = "character"
  ),
  prototype = list(
    extra = NULL,
    subsets = NULL,
    structure = NULL,
    weights = NULL,
    alternative = NULL,
    null = NULL,
    directional = FALSE
  )
)

#==========================================================
# Function "show" prints a "gt.object" object
#==========================================================
setMethod("show", "gt.object", function(object)
{
  if (!is.null(alias(object))) {
    chars <- nchar(alias(object))
    mp <- gt.options()$max.print
    alias(object) <- ifelse(chars > mp,
      paste(substr(alias(object),1,mp-3), "...", sep=""),
      alias(object))
  }
  print(result(object), digits = 3)
})

setGeneric("summary")
setMethod("summary", "gt.object", function(object, ...)
{
  cat("\"gt.object\" object from package globaltest\n\n")
  cat("Call:\n")
  cat(deparse(object@call), "\n\n")
  df <- object@functions$df()
  cat("Model:", object@model, "regression.\n")
  cat("Degrees of freedom:", df[1], "total;", df[2], "null;", df[2], "+", df[3], "alternative.\n")
  if ((!is.null(object@subsets)) || !is.null(object@weights))
    cat("Tested:", length(object), "subsets.\n") 
  nperms = object@functions$nperms()
  cat("Null distibution: ")
  if (nperms[1]) {
    cat(if(!nperms[2]) "all", nperms[1], if(nperms[2]) "random", "permutations.\n")
  } else {
    cat("asymptotic.\n")
  }
  cat("\n")
  show(object)
})


#==========================================================
# Functions to extract relevant information from 
# a gt.object object
#==========================================================
setGeneric("result", function(object, ...) standardGeneric("result"))
setMethod("result", "gt.object",
  function(object) { 
    if (is.null(object@extra))
      data.frame(object@result, check.names=FALSE)
    else
      data.frame(object@extra, object@result, check.names=FALSE)
})

setGeneric(".result", function(object, ...) standardGeneric(".result"))
setMethod(".result", "gt.object",
  function(object) 
    object@result
)


#==========================================================
setGeneric("extract", function(object, ...) standardGeneric("extract"))
setMethod("extract", "gt.object", function(object, ...) {
  if (!is.null(object@structure$ancestors))
    uit <- leafNodes(object, alpha=1)
  else
    uit <- object
  if (uit@model == "multinomial") {
    cols <- factor(uit@functions$positive(unlist(subsets(uit))), levels=seq_along(uit@legend$cov))
    levels(cols) <- uit@legend$cov
  } else {
    cols <- factor(uit@functions$positive(unlist(subsets(uit))), levels=0:1)
    levels(cols) <- rev(uit@legend$cov)
  }
  names(uit) <- uit@functions$cov.names(unlist(subsets(uit)))
  if (is.null(uit@extra)) {
    uit@extra <- as.data.frame(as.matrix(cols))
    colnames(uit@extra) <- "direction"
  } else
    uit@extra$direction <- as.character(cols)
  uit
})



setGeneric("weights") 
setMethod("weights", "gt.object", function(object) {
  
  # base weights based on covariate variance
  X <- object@functions$getX()
  weights <- colSums(X*X)
  if (object@model == "multinomial")
    weights <- rowSums(matrix(weights, object@functions$df()[3]))
  names(weights) <- object@functions$cov.names()
                                  
  # find weights for specific weights and subsets chosen
  if (length(object@subsets) > 0) {
    weights <- lapply(object@subsets, function(set) weights[set])
  }
  if (length(object@weights) > 0) 
    if (is.list(weights)) {
      weights <- lapply(as.list(1:length(weights)), function(i)
        weights[[i]] * object@weights[[i]])
      names(weights) <- names(object@weights)  
    } else
      weights <- lapply(object@weights, function(wts) weights * wts)
                  
  # set the max weight to 1  
  if (is.list(weights))
    weights <- lapply(weights, function(wts) wts / max(wts))
  else
    weights <- weights / max(weights)
      
  # reduce a list of length 1 to a vector    
  if (is.list(weights) && length(weights) == 1)
    weights <- weights[[1]]

  weights      
})

#==========================================================
setGeneric("subsets", function(object, ...) standardGeneric("subsets"))
setMethod("subsets", "gt.object", function(object, ...) {
  object@subsets
})


#==========================================================
setGeneric("p.value", function(object, ...) standardGeneric("p.value"))
setMethod("p.value", "gt.object",
  function(object) {
    out <- .result(object)[,1,drop=FALSE]
    colnames(out) <- NULL
    drop(out)
  }
)

#==========================================================
setGeneric("z.score", function(object, ...) standardGeneric("z.score"))
setMethod("z.score", "gt.object",
  function(object) {
    out <- .result(object)
    colnames(out) <- NULL            
    (out[,2] - out[,3]) / out[,4]
  }
)


#==========================================================
setGeneric("size", function(object, ...) standardGeneric("size"))
setMethod("size", "gt.object",
  function(object) {
    .result(object)[,"#Cov"]
  }
)


#==========================================================
# The subsetting methods for "gt.object"
#==========================================================
setMethod("[", "gt.object", 
            function(x, i, j,...,drop) 
{
  if (all(i %in% names(x)) || 
          all(i %in% 1:length(x)) ||
          all(i %in% -1:-length(x)) ||
          (is.logical(i) && (length(i) == length(x)))) {
    x@extra <- x@extra[i, ,drop=FALSE]
    if (!is.null(x@subsets)) x@subsets <- x@subsets[i]
    if (!is.null(x@weights)) x@weights <- x@weights[i]
    if (!is.null(x@structure)) {
      selector <- 1:length(x)
      names(selector) <- names(x)
      sub <- names(selector[i])
      if (length(sub) < length(x)) {
        x@structure$ancestors <- x@structure$ancestors[sub]
        x@structure$ancestors <- lapply(x@structure$ancestors, function(xx) intersect(xx, sub))
        x@structure$ancestors <- x@structure$ancestors[sapply(x@structure$ancestors, length) > 0]
        x@structure$offspring <- x@structure$offspring[sub]
        x@structure$offspring <- lapply(x@structure$offspring, function(xx) intersect(xx, sub))      
        x@structure$offspring <- x@structure$offspring[sapply(x@structure$offspring, length) > 0]
      }
    }
    x@result <- x@result[i, ,drop = FALSE] 
    x
  } else {
    stop("invalid index set", call. = FALSE)
  }
})            

setMethod("[[", "gt.object", 
            function(x, i, j,...,exact) 
{
   x[i]
})

#==========================================================
# The length method for "gt.object"
#==========================================================
setMethod("length", "gt.object", 
            function(x) 
{
  nrow(.result(x))
})            

#==========================================================
# The length method for "gt.object"
#==========================================================
leafNodes <- function(object, alpha=0.05, type = c("focuslevel","inheritance")) {

  if (is.null(object@structure$ancestors)) {     # Infer from sets
    sets <- object@subsets
    ancestors <- new.env(hash=TRUE)
    offspring <- new.env(hash=TRUE)
    for (i in 1:length(sets)) {
      namei <- names(sets)[i]
      for (j in 1:length(sets)) {
        namej <- names(sets)[j]
        if (i != j && length(sets[[i]]) <= length(sets[[j]]) && all(sets[[i]] %in% sets[[j]])) {
          ancestors[[namei]] <- c(ancestors[[namei]], namej)
          offspring[[namej]] <- c(offspring[[namej]], namei)
        }
      }
    }
    object@structure$ancestors <- as.list(ancestors)
    object@structure$offspring <- as.list(offspring)
  }

  if (missing(type)) 
    type <- c("focuslevel","inheritance")
  else
    type <- match.arg(type)  
  type <- type[type %in% names(object@extra)]
  if (length(type) < 1)
    stop("no focus level or inheritance p-values in object.")
  if (length(type) > 1)
    stop("both focus level and inheritance p-values in object. Please specify type.")

  ps <- object@extra[[type]]
  significant <- names(object)[ps <= alpha]
  sign.anc <- unique(unlist(object@structure$ancestors[significant]))
  leaves <- setdiff(significant, sign.anc)

  object[leaves]
}


#==========================================================
# The names and alias methods for "gt.object" 
# (applies to pathwaynames)
#==========================================================
setMethod("names", "gt.object", 
            function(x) 
{
  rownames(.result(x))
})      


setMethod("names<-", "gt.object", 
            function(x, value) 
{
  rownames(x@result) <- value
  if (!is.null(x@extra)) rownames(x@extra) <- value
  if (!is.null(x@weights)) names(x@weights) <- value
  if (!is.null(x@subsets)) names(x@subsets) <- value
  x
})            

setGeneric("alias")
setMethod("alias", "gt.object",
  function(object) {
    object@extra$alias  
})

setGeneric("alias<-", function(x, value) standardGeneric("alias<-"))
setMethod("alias<-", "gt.object",
  function(x, value) {
    if (length(value) != length(x))
      stop("alias has length ", length(value), " but object has length ", length(x))
    extra <- x@extra
    extra$alias <- value
    x@extra <- as.data.frame(extra, stringsAsFactors=FALSE)
    if (is.null(rownames(x@extra))) rownames(x@extra) <- names(x)
    x
})



#==========================================================
# A sort method for "gt.object"
#==========================================================
setMethod("sort", matchSignature(signature(x = "gt.object"), sort),
  function(x, decreasing = FALSE ) {
    mch <- match(c("focuslevel", "inheritance"), names(x@extra))
    if (any(!is.na(mch))) {
      mch <- mch[!is.na(mch)][1]
      adjp <- x@extra[[mch]]
      ix <- order(adjp, p.value(x), -z.score(x), decreasing=decreasing)
    } else
      ix <- order(p.value(x), -z.score(x), decreasing=decreasing)
    x[ix]
  }
)

#==========================================================
# Model.matrix extracts the model matrix (only if x=TRUE)
#==========================================================
setMethod("model.matrix", matchSignature(signature(object = "gt.object"), model.matrix),
  function(object, ... ) {
    list(alternative = object@alternative, null = object@null)
  }
)


#==========================================================
# Multiple testing correction for "gt.object" object
#==========================================================
setGeneric("p.adjust")
setMethod("p.adjust", matchSignature(signature(p = "gt.object"), p.adjust),
  function(p, method = p.adjust.methods, n = length(p)) {
    method <- method[1]
    method <- p.adjust.methods[grep(method, p.adjust.methods, ignore.case=TRUE)]
    if(length(method)==(0))   # this is just to get a good error message
      method <- match.arg(method)
    if (is.null(p@extra))
      p@extra <- data.frame(matrix(,length(p),0), row.names=names(p))
    if (missing(n))
      p@extra[[method]] <- p.adjust(p.value(p), method=method)
    else
      p@extra[[method]] <- p.adjust(p.value(p), method=method, n=n)
    p
  }
)



#==========================================================
# Histogram method to visualize permutations
#==========================================================
setGeneric("hist", function(x,...) standardGeneric("hist"))
setMethod("hist", "gt.object", function(x, ...)  {

  gt.hist <- function(x, breaks=20, main="", xlab = "Permutation test statistics", ...) {

    if (length(x) > 1)
    stop("length(object) > 1. Please reduce to a single test result")
  
    if (is.null(x@weights)) 
      weights <- rep(1, size(x))
    else
      weights <- x@weights[[1]]
    if (is.null(x@subsets))
      subset <- seq_len(size(x))
    else
      subset <- x@subsets[[1]]
  
    recalculate <- x@functions$permutations(subset, weights)
    Qs <- recalculate$permS
    Q <- recalculate$S
    nperm <- length(Qs)
    hst <- hist(Qs, xlim = c(1.1 * min(0, Qs, Q), 1.1 * max(Qs, Q)), breaks = breaks, 
      main = main, xlab = xlab, ...)
    h <- max(hst$counts)
    arrows( Q, h/2, Q, 0 , lwd=2)
    text( Q, h/2, 'Observed\ntest\nstatistic' , pos=3)
  
    # No output
    invisible(list(statistic = Q, histogram = hst))
  }
  
  gt.hist(x,...)
})        


#==========================================================
# Graph plot for focus level and inheritance procedures
#==========================================================
draw <- function(object, alpha=0.05, type = c("focuslevel","inheritance"), names=FALSE, sign.only = FALSE, interactive = FALSE) {

  # check availablity of packages
  requireNamespace("Rgraphviz") || stop("package \"Rgraphviz\" is not available.")

  # find ancestors and offspring if missing
  if (is.null(object@structure$ancestors)) {     # Infer from sets
    sets <- object@subsets
    ancestors <- new.env(hash=TRUE)
    offspring <- new.env(hash=TRUE)
    for (i in 1:length(sets)) {
      namei <- names(sets)[i]
      for (j in 1:length(sets)) {
        namej <- names(sets)[j]
        if (i != j && length(sets[[i]]) <= length(sets[[j]]) && all(sets[[i]] %in% sets[[j]])) {
          ancestors[[namei]] <- c(ancestors[[namei]], namej)
          offspring[[namej]] <- c(offspring[[namej]], namei)
        }
      }
    }
    object@structure$ancestors <- as.list(ancestors)
    object@structure$offspring <- as.list(offspring)
  }

  # find type if missing
  if (missing(type)) 
    type <- c("focuslevel","inheritance")
  else
    type <- match.arg(type)  
  type <- type[type %in% names(object@extra)]
  if (length(type) < 1)
    stop("no focus level or inheritance p-values in object.")
  if (length(type) > 1)
    stop("both focus level and inheritance p-values in object. Please specify type.")

  ps <- object@extra[[type]]
  significant <- names(object)[ps <= alpha]

  parents <- ancestors2parents(object@structure$ancestors)

  # make the graph object
  graph <- as.matrix(sapply(names(object), function(node) names(object) %in% parents[[node]]))
  rownames(graph) <- colnames(graph) <- names(object)
  if (sign.only) {
    graph <- graph[significant, significant, drop=FALSE]
    if (length(significant)==0)
      stop("no significant nodes to plot.")
  }
  graph <- as(graph, "graphNEL")
  
  nodes <- Rgraphviz::buildNodeList(graph)
  edges <- Rgraphviz::buildEdgeList(graph)
  nAttrs <- list()
  eAttrs <- list()

  # color significant nodes
  if (!sign.only) {
    signode <- sapply(nodes, Rgraphviz::name) %in% significant
    names(signode) <- names(nodes)
    sigedge <- (sapply(edges, Rgraphviz::from) %in% significant) & 
      (sapply(edges, Rgraphviz::to) %in% significant)
    names(sigedge) <- names(edges)
    nodecolor <- ifelse(signode, "black", "#BBBBBB")
    nAttrs$color <- nodecolor
    nAttrs$fontcolor <- nodecolor
    
    edgecolor <- ifelse(sigedge, "black", "#BBBBBB")
    eAttrs$color <- edgecolor
  }

  # if no names, give the plot numbers in order
  # this requires plotting the graph twice
  if (!names) {
    nAttrs$label <- 1:length(names(nodes))
    names(nAttrs$label) <- names(nodes)
    pg <- Rgraphviz::agopen(graph, name="pg", nodeAttrs = nAttrs, edgeAttrs = eAttrs)
    x <- Rgraphviz::getNodeXY(pg)$x
    y <- Rgraphviz::getNodeXY(pg)$y
    ordering <- sort.list(order(-y, x))
    nAttrs$label <- ordering
    names(nAttrs$label) <- names(nodes)
    Rgraphviz::plot(graph, attrs = list(node=list(shape="rectangle")), nodeAttrs = nAttrs, edgeAttrs = eAttrs)
  } else
    Rgraphviz::plot(graph, attrs = list(node=list(shape="rectangle")), nodeAttrs = nAttrs, edgeAttrs = eAttrs)
    
  # Make the plot interactive if asked
  if (interactive) {
    cat("Click in the plot to see name and alias. Press escape to return.\n")
    flush.console()
    repeat {
      p <- locator(n = 1) 
      if (is.null(p))
        break()
      pg <- Rgraphviz::plot(graph, attrs = list(node=list(shape="rectangle")), nodeAttrs = nAttrs, edgeAttrs = eAttrs)
      x <- Rgraphviz::getNodeXY(pg)$x
      y <- Rgraphviz::getNodeXY(pg)$y
      distance <- abs(p$x - x) + abs(p$y - y)
      idx <- which.min(distance)
      legend("topleft", legend = paste(nAttrs$label[idx], names(object)[idx], alias(object)[idx]), bg = "white", box.lty=0)
    }
  }
  
  # return a legend if the plot has numbers
  if (!names) {
    legend <- cbind(name=names(object), alias=alias(object))[sort.list(ordering),]
    legend <- data.frame(legend, stringsAsFactors=FALSE)
  } else
    legend <- NULL
    
  invisible(legend)
}

%\VignetteIndexEntry{Global Test}
%\VignetteDepends{globaltest, Rgraphviz, golubEsets, hu6800.db, vsn, lungExpression, GO.db, Biobase, org.Hs.eg.db, annotate, KEGGREST}
%\VignetteKeywords{Hypothesis testing}
%\VignettePackage{globaltest}

\documentclass{report}
\usepackage{natbib, Sweave, times}
\bibliographystyle{apalike}

\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}
\newcommand{\Rfunarg}[1]{{\textit{#1}}}
\sloppy

\title{The Global Test \\ and the \Rpackage{globaltest} \texttt{R} package}

\author{Jelle Goeman \and Jan Oosting \and Livio Finos \and Aldo Solari \and Dominic Edelmann}

\begin{document}
\SweaveOpts{concordance=TRUE}

\maketitle \tableofcontents \newpage

\chapter{Introduction}

This vignette explains the use of the \Rpackage{globaltest} package. Chapter \ref{general chapter} describes the use of the test and the package from a general statistical perspective. Later chapters explain how to use the \Rpackage{globaltest} package for specific applications.


\section{Citing \Rpackage{globaltest}}

When using the \Rpackage{globaltest} package, please cite one or more of the following papers, as appropriate.
\begin{itemize}
  \item \cite{Goeman2004} is the original paper describing the global test for linear and logistic regression, and its application to gene set testing.
  \item \cite{Goeman2005} extends the global test to survival data and explains how to deal with nuisance (null) covariates.
  \item \cite{Goeman2006} proves the local optimality of the global test and explores its general theoretical properties. This is the core paper of the global test methodology
  \item \cite{Goeman2008} develops the Focus Level method for multiple testing correction in the Gene Ontology graph.
  \item \cite{Goeman2009} derives the asymptotic distribution of the global test for generalized linear models.
  \item \cite{Jelier2011} describes the weighted test based on concept profiles (Section \ref{concept}).
  \item \cite{Goeman2012} describes the inheritance multiple testing procedure that is used in the \Rfunction{covariates} plot.
\end{itemize}


\section{Package overview}

The global test is meant for data sets in which many covariates (or features) have been measured for the same subjects, together with a response variable, e.g.\ a class label, a survival time or a continuous measurement. The global test can be used on a group (or subset) of the covariates, testing whether that group of covariates is associated with the response variable.

The null hypothesis of the global test is that none of the covariates in the tested group is associated with the response. The alternative is that at least one of the covariates has such an association. However, the global test is designed in such a way that it is especially directed against the alternative that most of the covariates are associated with the response in a small way. In fact, against such an alternative the global test is the optimal test to use \citep{Goeman2006}.

The global test is based on regression models in which the distribution of the response variable is modeled as a function of the covariates. The type of regression model depends on the response. Currently implemented models are
\begin{itemize}
  \item linear regression (continuous response),
  \item logistic regression (binary response),
  \item multinomial logistic regression (multi-class response),
  \item Poisson regression (count response),
  \item the Cox proportional hazards model (survival response).
\end{itemize}
Modeling in terms of a regression model makes it easy to adjust the test for the confounding effect of nuisance covariates: covariates that are known to have an effect on the response and which are correlated with (some of) the covariates of interest, and which may, if not adjusted for, lead to spurious associations.

The \Rpackage{globaltest} package implements the global test along with additional functionality. Several diagnostic plots can be used to visualize the test result and to decompose it to see the influence of individual covariates and subjects. Multiple testing procedures are offered for the situation in which a user wants to perform many global tests on the same data, e.g.\ when testing many alternative subsets. In that case, possible relationships between the test results arise due to subset relationships among tested sets which may be exploited.

The package also offers some functions that are tailored to specific applications of the global test. In the current version, the only application supported in this way is gene set testing (see Chapter \ref{gene set testing}). Tailored functions for other applications (goodness-of-fit testing, prediction/classification pre-testing, testing for the presence of a random effect) are under development.



\section{Comparison with the likelihood ratio test}

In its most general form, the global test is a score test for nested parametric models, and as such it is a competitor of the likelihood ratio test. It can be used in every situation in which a likelihood ratio test may also be used, but the global test's properties are different from those of the likelihood ratio test. We summarize the differences briefly from a theoretical statistical perspective. For more details, see \cite{Goeman2006}.

It is well known that the likelihood ratio test is invariant to the parametrization of the alternative model. The global test does not have this property: it depends on the model's precise parametrization. Therefore, there is not a single global test for a given pair of null and alternative hypothesis, but a multitude of tests: one for each possible parametrization of the alternative hypothesis. In return for giving up this parametrization-invariance, the global test gains an optimality-property that depends on the parametrization of the model. As detailed in \cite{Goeman2006}, the global test is optimal (among all possible tests) on average in a neighborhood of the null hypothesis. The shape of this neighborhood is determined by the parametrization of the alternative hypothesis. In practice, this means that in situations in which a ``natural'' parametrization of the alternative model exists, the global test for that parametrization is often more powerful than the likelihood ratio test \citep[examples in][]{Goeman2006}.

A second important property of the global test is that it may still be used in situations in which the alternative model cannot be fitted to the data, which may happen, for example, if the alternative model is overparameterized, or in high dimensional situations in which there are more parameters than observations. In such cases the likelihood ratio test usually breaks down, but the global test still functions, often with good power.

Being a score test, the global test is most focused on alternatives close to the null hypothesis. This means that the global test is good at detecting alternatives that have many small effects (in terms of the chosen parametrization), but that it may not be the optimal test to use if the effects are very large.



\chapter{The global test} \label{general chapter}

\section{Global test basics} \label{basics}

We illustrate most of the features of the \Rpackage{globaltest} package and its functions with a very simple application on simulated data using a linear regression model. More extensive real examples relating to specific areas of application can be found in later chapters of this vignette.

\subsection{Example data} \label{example data}

We simulate some data

<<make data>>=
set.seed(1)
Y <- rnorm(20)
X <- matrix(rnorm(200), 20, 10)
X[,1:3] <- X[,1:3] + Y
colnames(X) <- LETTERS[1:10]
@

This generates a data matrix \Robject{X} with 10 covariates called \Robject{A}, \Robject{B}, \ldots, \Robject{J}, and a response \Robject{Y}. In truth, the covariates  \Robject{A}, \Robject{B}, and \Robject{C} are associated with \Robject{Y}, and the rest are not.

We start the \Rpackage{globaltest} package

<<>>=
library(globaltest)
@


\subsection{Options}

The \Rpackage{globaltest} package has a \Rfunction{gt.options} function, which can be used to set some global options of the package. We use this in this vignette to switch off the progress information, which is useful if the functions are used interactively, but does not combine well with \Rfunction{Sweave}, which was used to make this vignette. We also set the \verb:max.print: option in \Rpackage{globaltest}, which abbreviates long Gene Ontology terms in Chapter \ref{gene set testing}.
<<options>>=
gt.options(trace=FALSE, max.print=45)
@


\subsection{The test} \label{basic test}

The main workhorse function of the \Rpackage{globaltest} package is the \Rfunction{gt} function, which performs the actual test. There are several alternative ways to call this function, depending on the user's preference to work with \Rclass{formula} objects or matrices. We start with the \Rclass{formula}-based way, because this is closest to the statistical theory. Matrix-based calls are detailed in Section \ref{alternative calls}.

In the data set of Section \ref{example data}, if we are interested in testing for association between the group of variables \verb:A:, \verb:B: and \verb:C: with the response \verb:Y:, we can test the null hypothesis \verb:Y ~ 1: that the response depends on none of the variables in the group, against the alternative hypothesis \verb:Y ~ A + B + C: that \verb:A:, \verb:B: and \verb:C: may have an influence on the response. We test this with
<<full formula simple>>=
gt(Y~1, Y~A+B+C, data = X)
@
Unlike in \Rfunction{anova}, the order of the models matters in this call: the second argument must always be the alternative hypothesis.

The output lists the p-value of the test, the test statistic with its expected value and standard deviation under the null hypothesis. The \verb:#Cov: column give the number of covariates in the alternative model that are not in the null model. In the linear model the test statistic is scaled in such a way that it takes values between 0 and 100. The test statistic can be interpreted as 100 times a weighted average (partial) correlation between the covariates of the alternative and the residuals of the response. In other models, the test statistic has a roughly similar scaling and interpretation.


\subsection{Nuisance covariates}

A similar syntax can be used to correct the test for nuisance covariates. To correct the test of the previous section for the possible confounding influence of the covariate \verb:D:, we specify the null hypothesis \verb:Y ~ D: versus the alternative \verb:Y ~ A + B + C + D:. Note that the nuisance covariate occurs both in the null and alternative models.
<<full formula>>=
gt(Y~D, Y~A+B+C+D, data = X)
@


\subsection{The \Rclass{gt.object} object: extracting information}

The \Rfunction{gt} function returns a \Rclass{gt.object} object, which stores some useful information, for example the information to make diagnostic plots. Many methods have been defined for this object. One useful function is the \Rfunction{summary} method
<<summary>>=
summary(gt(Y~A, Y~A+B+C, data = X))
@

Other functions to extract useful information from a \Rclass{gt.object}. For example,
<<>>=
res <- gt(Y~A, Y~A+B+C, data = X)
p.value(res)
z.score(res)
result(res)
size(res)
@

The \Rfunction{z.score} function returns the test statistic standardized by its expectation and standard deviation under the null hypothesis; \Rfunction{result} returns a \Rclass{data.frame} with the test result; \Rfunction{size} returns the number of alternative covariates.


\subsection{Alternative function calls} \label{alternative calls}

The call to $\Rfunction{gt}$ is quite flexible, and the null and alternative hypotheses can be specified using either \Rclass{formula} objects or design matrices. We illustrate both types of calls, starting with the \Rclass{formula}-based ones.

As the global test always tests nested models, there is no need to repeat the response and the null covariates when specifying the alternative model, so we may abbreviate the call of the previous section by specifying only those alternative covariates that do not already appear in the null model. Therefore,
<<eval=FALSE>>=
gt(Y~A, ~B+C, data = X)
@
also tests the null hypothesis \verb:Y ~ A: versus the alternative \verb:Y ~ A + B + C:.

If only a single model is specified, \Rfunction{gt} will test a null model with only an intercept against the specified model. So, to test the null hypothesis \verb:Y ~ 1: against the alternative \verb:Y ~ A + B + C:, we may write
<<>>=
gt(Y~A+B+C, data = X)
@

The dot (\verb:.:) argument for \Rclass{formula} objects can often be useful. To test \verb:Y ~ A: against the global alternative that all covariates are associated with \Robject{Y}, we can test
<<>>=
gt(Y~A, ~., data = X)
@
Using the information from the column names in the \Rfunarg{data} argument, the \verb:~.: argument is automatically expanded to \verb:~ A + B + C + D + E + F + G + H + I + J:.

In some applications it is more natural to work with design matrices directly, rather than to specify them through a \Rclass{formula}. To perform the test of \verb:Y ~ 1: against \verb:Y ~ .:, we may write
<<>>=
gt(Y, X)
@

Similarly, the null hypothesis may be specified as a design matrix. The call
<<null design>>=
designA <- cbind(1, X[,"A"])
gt(Y, X, designA)
@
gives the same result as \verb:gt(Y~A, ~., data = X):, except for the \verb:#Cov: output: the function cannot detect that some of the null covariates are also present in the alternative design matrix, only that the latter contains exactly correlated ones. Note that when specified in this way the null design matrix must be a complete design matrix, i.e. with any intercept term included in the matrix.


\subsection{Models} \label{models}

The \Rfunction{gt} function can work with the following models: linear regression, logistic regression and multinomial logistic regression, poisson regression and the Cox proportional hazards model. The model to be used can be specified by the \Rfunarg{model} argument.

<<poisson>>=
P <- rpois(20, lambda=2)
gt(P~A, ~., data=X, model = "Poisson")
gt(P~A, ~., data=X, model = "linear")
@

If the null model has no covariates (i.e. \verb:~0: or \verb:~1:), the logistic and Poisson model results are identical to the linear model results.

If missing, the function will try to determine the model from the input. If the response is a \Rclass{factor} with two levels or a \Rclass{logical}, it uses a logistic model; if a factor with more than two levels, a multinomial logistic model; if the response is a \Rclass{Surv} object, it uses a Cox model (for examples, see Section \ref{survival}). In all other cases the default is linear regression.

Use \Rfunction{summary} to check which model was used.


\subsection{Stratified Cox model and competing risks survival analysis} \label{models}

When applying the \Rfunction{gt} for the Cox proportional hazards model, the user may also specify strata. For this purpose, the null hypothesis should be given as a \Rclass{formula} object. The strata can then be specified as in the package \Rpackage{survival}. We first simulate some survival data via


<<survival data>>=
time <- rexp(20,1/100)
status <- rbinom(20,1,0.5)
str <- rbinom(20,1,0.5)
@

To test the alternative \verb:Surv(time,status) ~ A + B + strata(str): against the null hypothesis \verb:Surv(time,status) ~ strata(str):, one can use the call

<<>>=
gt(Surv(time,status), ~A+B+strata(str), ~strata(str), data=X)
@

As already described above, one could also use the shorter call:
<<>>=
gt(Surv(time,status), ~A+B, ~strata(str), data=X)
@


All strata terms must be both part of alternative and the null hypothesis, e.g. we do not support the possibility of testing the alternative alternative \verb:Surv(time,status) ~ A + B + strata(C): against the null hypothesis \verb:Surv(time,status) ~ A + B:.

In case that a strata term is only specified in the alternative, a warning is printed and the corresponding strata term is ignored.

The \Rfunction{gt} function for the stratified Cox model can also be used to apply the global test for the cause-specific hazards model. Let us assume, that there are two different event types indicated by the values $1$ and $2$ in the status variable:
<<>>=
status <- status * (rbinom(20,1,0.5) + 1)
@

Using the \Rpackage{mstate} package, we first transform the variables into long format with event type-specific covariates:

<<>>=
library(mstate)
survdat <- data.frame(X, "time.01" = time, "time.02" = time,
                      "status.01" = ifelse(status == 1, 1, 0),
                      "status.02" = ifelse(status == 2, 1, 0))
survdat <- msprep(time = c(NA, "time.01","time.02"), 
                  status = c(NA, 'status.01','status.02'),
                  data = survdat, trans = trans.comprisk(2),
                  keep=c("A","B"))
survdat <- expand.covs(survdat, c("A","B"))
@

Now testing the alternative \verb:Surv(time,status) ~ A + B: against the null hypothesis \verb:Surv(time,status) ~ 1: in the cause-specific hazards model with event types $1$ and $2$ can e.g. be performed using

<<>>=
gt(Surv(time,status), ~A.1+B.1+A.2+B.2, ~strata(trans), data=survdat)
@

\subsection{Null distribution: asymptotic or permutations} \label{permhist}

By default the global test uses an analytic null distribution to calculate the p-values of the test. This analytic distribution is exact in case of the linear model with normally distributed errors, and asymptotic in all other models. The distribution that is used is described in \cite{Goeman2009} for linear and generalized linear models, and in \cite{Goeman2005} for the Cox proportional hazards model. The assumption underlying the asymptotic distribution is that the sample size is (much) larger than the number of covariates of the null hypothesis; the dimensionality of the alternative is not an issue.

For the linear, logistic and poisson models, the reported p-values are numerically reliable up to at least two decimal places down to values of around $10^{-12}$. Reported lower p-values are less reliable (although they can be trusted to be below $10^{-12}$).

In situations in which the assumptions underlying the asymptotics are questionable, or in which an exact alpha level of the test is necessary, it is possible to calculate the p-value using permutations instead. Because permutations require an exchangeable null hypothesis, such a permutation p-value is only available for the linear model and for the exchangeable null hypotheses \verb:~1: and \verb:~0: in other models.

To calculate permutation p-values, specify the number of permutations with the \Rfunarg{permutations} argument. The default, \verb:permutations = 0:, selects the asymptotic distribution. If the number of permutations specified in \Rfunarg{permutations} is larger than the total number of possible permutations, all possible permutations are used; otherwise the function draws permutations at random. Use \Rfunction{summary} to see which variant was actually used.

Compare
<<permutations>>=
gt(Y,X)
gt(Y,X, permutations=1e4)
@

The distribution of the permuted test statistic can be visualized using the \Rfunction{hist} function.

\begin{figure}[!ht]
<<fig=TRUE>>=
hist(gt(Y,X, permutations=1e4))
@
\end{figure}



\subsection{Intercept terms}

If \Rfunarg{null} is given as a \Rclass{formula} object, intercept terms are automatically included in the model unless this term is explicitly removed with \verb:~0+...: or \verb:~...-1:, as is usual in \Rclass{formula} objects. This automatic addition of an intercept does not happen if \Rfunarg{null} is specified as a design matrix. Therefore, the calls
<<>>=
A <- X[,"A"]
gt(Y,X,A)
gt(Y,X,~A)
@
test different null hypotheses: \verb:Y ~ 1 + A: and \verb:Y ~ 0 + A:, respectively.

In contrast, in the alternative model the intercept term is always suppressed, even if \Rfunarg{alternative} is a \Rclass{formula} and an intercept is not present in the null model. If a user wants to include an intercept term in the alternative model but not in the null model, he must explicitly construct an intercept variable. The reason for this is that the test result is not invariant to the scaling of variables in the alternative, and therefore also not invariant to relative scaling of the intercept to the other variables. The user must therefore choose and construct an appropriately scaled intercept. The call
<<no intercept>>=
gt(Y~0+A, ~ B+C, data = X)
@
suppresses the intercept both in null and alternative hypotheses. To include an intercept in the alternative, we must say something like
<<alternative intercept>>=
IC <- rep(1, 20)
gt(Y~0+A, ~ IC+B+C, data = X)
@
Note that setting \verb:IC <- rep(2, 20): gives a different result.


\subsection{Covariates of class \Rclass{factor}}

Another consequence of the fact that the global test is not invariant to the parametrization of the alternative model is that one must carefully consider the choice of contrasts for \Rclass{factor} covariates. We distinguish nominal (unordered) factors and ordinal (ordered) factors.

The usual coding of nominal factors with a reference category and dummy variables that describe the difference between each category and the reference is usually not appropriate for global test, as this parametrization (and therefore the test result) depends on the choice of the reference category, which is often arbitrary. More appropriate is to do a symmetric parametrization with a dummy for each category. This works even if multiple factors are considered, because the global test is not adversely affected by overparametrization. If \Rfunction{gt} was called with the argument \Rfunarg{x} set to \Robject{TRUE}, we can use \Rfunction{model.matrix} on the \Rclass{gt.object} to check the design matrix.
<<factors>>=
set.seed(1234)
YY <- rnorm(6)
FF <- factor(rep(letters[1:2], 3))
GG <- factor(rep(letters[3:5], 2))
model.matrix(gt(YY ~ FF + GG, x = TRUE))$alternative
@
This choice of contrasts guarantees that the test result does not depend on the order of the levels of any factors.

For ordered factors it is often reasonable to make contrasts between adjacent categories.
In a model without an intercept term the frequently used \emph{split coding} scheme allows the parameters $\beta_i$ to be interpreted as the increases in the transition from category $i-1$ to category $i$, which is intuitively appropriate for ordinal data. In our example this yields

<<ordinal>>=
GG <- ordered(GG)
model.matrix(gt(YY ~ GG, x = TRUE))$alternative
@

If now an intercept term is included in \emph{null} (i.e. if it is not explicitly removed), this choice of contrasts is equivalent to taking an arbitrary category to be the reference category and, starting from that, assuming that the effects of categories further apart are more diverse than the effects of categories close-by. More explicitly, choosing the first, second, and third category as reference theoretically would result in the design matrices

<<alternative contrasts>>=
R1 <- matrix(c(0,1,1,0,1,1,0,0,1,0,0,1),6,2,dimnames=list(1:6,c("GGd","GGe")))
R2 <- matrix(c(-1,0,0,-1,0,0,0,0,1,0,0,1),6,2,dimnames=list(1:6,c("GGc","GGe")))
R3 <- matrix(c(-1,0,0,-1,0,0,-1,-1,0,-1,-1,0),6,2,dimnames=list(1:6,c("GGc","GGd")))
@

It can be shown that the global test statistic --- and hence the test result --- is invariant to the choice of the reference category. In the \Rfunction{gt} function we can check this easily with

<<ordinal gt>>=
gt(YY ~ GG)
gt(YY, alternative=R1)
@

The same results are obtained for \Robject{R2} and \Robject{R3}, respectively.
The choice of contrasts therefore guarantees that, in a model with an intercept term, the test result does not depend on the choice of the reference category. The difference in the number of covariates included in the alternative (3 vs. 2 in the above outputs) is due to the additional vector of ones in the split coding which, however, does not have any effect on the test result. (Strictly speaking, the effective number of covariates included in the alternative is the number given by the output minus the number of ordinal factors.)
Note that otherwise, if the intercept term is removed from \Rfunarg{null}, the test result will depend on the choice of the reference category, which may not be desirable. The used implementation protects us from such situations and, most notably, leads to more interpretable results if an intercept is excluded from the null model. If a user nevertheless wants to test such alternatives that do depend on the choice of the reference category, he must explicitly specify a corresponding design matrix in \Rfunarg{alternative} (such as \Robject{R1}, \Robject{R2}, and \Robject{R3} from above). This, for example, gives

<<ordinal gt no intercept>>=
gt(YY, alternative=R1, null=~0)
@

In contrast, the variant that \Rfunction{gt} is based on leads to

<<ordinal gt no intercept variant>>=
gt(YY ~ GG, null=~0)
@

\subsection{Directing the test: weights} \label{weighting}

The global test assigns relative weights to each covariate in the alternative which determine the contribution of each covariate to the test result. The default weighting, which follows from the theory of the test \citep{Goeman2006}, is proportional to the residual variance of each of the covariates, after orthogonalizing them with respect to the null covariates. The weights that \Rfunction{gt} uses internally can be retrieved with the \Rfunction{weights} function.
<<weights>>=
res <- gt(Y, X)
weights(res)
@
Only the ratios between weights are relevant. The weights that are returned are scaled so that the maximum weight is 1.

In some applications the default weighting is not appropriate, for example if the covariates are all measured in different units and the relative scaling of the units is arbitrary. In that case it is better to standardize all covariates to unit standard deviation before performing the test. This can be done using the \Rfunarg{standardize} argument.
<<>>=
res <- gt(Y,X, standardize=TRUE)
weights(res)
@

Alternatively, the function can work with user-specified weights, given in the \Rfunarg{weights} argument. These weights are multiplied with the default weights, unless the \Rfunarg{standardize} argument is set to \verb:TRUE:. The following two calls give the same test result.
<<eval=FALSE>>=
gt(Y, X[,c("A","A","B")], weights=c(.5,.5,1))
gt(Y, X[,c("A","B")])
@


\subsection{Directing the test: directional}

The power of the global test does not depend on the sign of the true regression coefficients. However, in some applications the regression coefficients of different covariates are a priori expected to have the same sign. Using the \Rfunarg{directional} argument The test can be directed to be more powerful against the alternative that the regression coefficients under the alternative all have the same sign.
<<>>=
gt(Y, X, directional = TRUE)
@

In the hierarchical model formulation of the test, this is achieved by making the random regression coefficients a priori positively correlated. The default, \verb:directional = TRUE:, corresponds to an a priori correlation between regression coefficients of $\sqrt{1/2}$. If desired, the \Rfunarg{directional} argument can be set to a value other than \verb:TRUE:. Setting \Rfunarg{directional} to a value of $d$ corresponds to an a priori correlation of $\sqrt{d/(1+d)}$.

If some covariates are a priori expected to have regression coefficients with opposite signs, the corresponding covariates can be given negative weights.


\subsection{Offset terms and testing values other than zero}

By default, the global test tests the null hypothesis that all regression coefficients of the covariates of the alternative hypothesis are all zero. It is also possible to test the null hypothesis that these covariates have a different value than zero, specified by the user. This can be done using the \Rfunarg{test.value} argument.
<<>>=
gt(Y~A+B+C,data=X, test.value=c(.2,.2,.2))
@
The \Rfunarg{test.value} argument is always applied to the original alternative design matrix, i.e.\ before any standardization or weighting.

Specifying \Rfunarg{test.value} in this way is equivalent to adding an \Rfunction{offset} term to the null hypothesis of $X\mathbf{v}$, where $X$ is the design matrix of the alternative hypothesis and $\mathbf{v}$ is the specified \Rfunarg{test.value}.
<<>>=
os <- X[,1:3]%*%c(.2,.2,.2)
gt(Y~offset(os), ~A+B+C, data=X)
@

Offset terms are not implemented for the multinomial logistic model.


\section{Diagnostic plots}

Aside from the permutations histogram already mentioned in Section \ref{permhist}, there are two main diagnostic plots that can help users to interpret a test result. Both plots are based on a decomposition of the test result into component test statistics that only use part of the information that the full test uses.


\subsection{The \Rfunction{covariates} plot} \label{covariates}

As shown in \cite{Goeman2004}, the global test statistic on a collection of alternative covariates can be seen as a weighted average of the global test statistics for each individual alternative covariate.
<<covariates preparation>>=
gt(Y~A+B, data=X)
gt(Y~A, data=X)
gt(Y~B, data=X)
@
The test statistic of the test against \verb:~A+B: is between the test statistics against the alternatives \verb:~A: and \verb:~B:, even though the cumulative evidence of \Robject{A} and \Robject{B} may make the p-value of the combined test smaller than that of each individual one. This is because the global test statistic for an alternative hypothesis is always a weighted average of the test statistics for tests of the component single covariate alternatives. The \Rfunction{covariates} plot is based on this decomposition of the test statistic into the contributions made by each of the covariates in the alternative hypothesis.

The contribution of each such covariate is itself a test. It can be useful to make a plot of these test results to find those covariates or groups of covariates that contribute most to a significant test result.

\begin{figure}[!ht]
<<covariates, fig=TRUE>>=
covariates(gt(Y,X))
@
\end{figure}

The \Rfunction{covariates} plot by default plots the p-values of the tests of individual component covariates of the alternative. Other characteristic values of the component tests may be plotted using the \Rfunarg{what} argument: specifying \verb:what = "z": plots standardized test statistics (compare the \Rfunction{z.score} method for \Rclass{gt.object} objects); specifying \verb:what = "s": gives the unstandardized test statistics and \verb:what = "w": give the unstandardized test statistics weighted for the relative weights of the covariates in the test (compare the \Rfunction{weights} method for \Rclass{gt.object} objects). If (weighted or unweighted) test statistics are plotted, bars and stripes appear to signify mean and standard deviation of the bars under the null hypothesis.

\begin{figure}[!ht]
<<covariatesW, fig=TRUE>>=
covariates(gt(Y,X), what="w")
@
\end{figure}

The plotted covariates are ordered in a hierarchical clustering graph. The distance measure used for the graph is absolute correlation distance if the \Rfunarg{directional} argument of \Rfunction{gt} was \Robject{FALSE} (the default), or correlation distance otherwise. (Absolute) correlation distance is appropriate here because the test results for the individual covariates can be expected to be similar if the covariates are strongly correlated, and because the sign of the correlation matters only if a directional test was used. The default clustering method is average linkage. This can be changed if desired, using the \Rfunarg{cluster} argument. Clustering can also be turned off by setting \verb:cluster = FALSE:.

The hierarchical clustering graph induces a collection of subsets of the tested covariates between the full set that is the top of the clustering graph and the single covariates that are the leaves. There are $2k-1$ such sets for a graph with $k$ leave nodes, including top and leaves. It is possible to do a multiple testing procedure on all $2k-1$ sets, controlling the family-wise error rate while taking the structure of the graph into account. The \Rfunction{covariates} function performs such a procedure, called the \emph{inheritance} procedure, which is an adaptation of the method of \cite{Meinshausen2008}: see Section \ref{inheritance}. By coloring the part of the clustering graph that has a significant multiplicity-corrected p-value in black, the user can get an impression what covariates and clusters of covariates are most clearly associated with the response variable. The significance threshold at which a multiplicity-corrected p-value is called significant can be adjusted with the \Rfunarg{alpha} argument (default 0.05). In some situations the significant branches do not reach all the way to the leaf nodes. The interpretation of this is that the multiple testing procedure can infer with confidence that at least one of the covariates below the last significant branch is associated with the response, but it cannot pinpoint with enough confidence which one(s).

The result of the covariates function can be stored to access the information in the graph. The \Rfunction{covariates} function returns a \Rclass{gt.object} containing all tests on all subsets induced by the clustering graph, with their familywise error adjusted p-values.
<<covariates output>>=
res <- covariates(gt(Y,X))
res[1:10]
@
The names of the subsets should be read as follows. ``O'' refers to the origin or root, and each ``[1'' refers to a first (or left) branch, whereas each ``[2'' refers to a second (or right) branch. Leaf nodes are also referred to by name. To get the leaf nodes of the subgraph that is significant after multiple testing correction, use the \Rfunction{leafNodes} function
<<covariates leafNodes>>=
leafNodes(res, alpha=0.10)
@
To get a nice table of only the information of the single covariates, including their direction of association, use the \Rfunction{extract} function.
<<extract>>=
extract(res)
@

The function \Rfunction{covariates} tries to sort the bars in such a way that the most significant covariates appear on the left. This sorting is, of course, constrained by the dendrogram if present. Setting the \Rfunarg{sort} argument to \verb:FALSE: to keep the bars in the original order as much as possible under the same constraints.

An additional option \Rfunarg{zoom} is available that ``zooms in'' on the significant branches by discarding the non-significant ones. If the whole graph is non-significant \Rfunarg{zoom} has no effect.
\begin{figure}[!ht]
<<covariates_zoom, fig=TRUE>>=
covariates(gt(Y,X), zoom=TRUE)
@
\end{figure}

The default colors, legend and labels in the plot can be adjusted with the \Rfunarg{colors}, \Rfunarg{legend} and \Rfunarg{alias} arguments.

The covariates returns the test results for all tests it performs, invisibly, as a \Rclass{gt.object}. The \Rfunction{leafNodes} function can be used to extract useful information from this object. Using \Rfunction{leafNodes} with the same value of alpha that was used in the covariates function, extracts the test results for the leaves of the significant subgraph. Using \verb:alpha = 1: extracts the test results for leaves of the full graph, i.e.\ for the individual covariates.

By default, the \Rfunction{covariates} function can only make a plot for a single test result, even if the \Rclass{gt.object} contains multiple test results (see Section \ref{manytests}). However, by providing a filename in the \Rfunarg{pdf} argument of the \Rfunction{covariates} function it is possible to make multiple plots, writing them to a pdf file as separate pages.

Those who like a more machine-learning oriented terminology can use the \Rfunction{features} function, which is identical to \Rfunction{covariates} in all respects.

\subsection{The \Rfunction{subjects} plot} \label{subjects}

Alternatively, it is possible to visualize the influence of the subjects, rather than of the covariates, on the test result. This can be useful in order to look for subjects that have an overly large influence on the test result, of to find subjects that deviate from the main pattern.

Visualizing the test result in terms of the contributions of the subjects can be done using a different decomposition of the test result. In the linear model the test statistic $Q$ can be viewed as a weighted sum of the quantities
\[
Q_i = \mathrm{sign}(Y_i-\mu_i) \sum_{j=1}^n \sum_{k=1}^p X_{ik} X_{jk} (Y_j-\mu_j),
\]
where $Y_i$ is the response variable of subject $i$, $\mu_i$ that person's expected response under the null hypothesis, and $X$ the design matrix of the alternative. We subtract $\hat\mathrm{E}(Q_i) = \mathrm{sign}(Y_i-\mu_i) \sum_{k=1}^p X_{ik} X_{ik} (Y_i-\mu_i)$ as a crude estimate of the expectation of $Q_i$. An estimate of the variance of $Q_i$ is $\mathrm{Var}\{Q_i - \hat\mathrm{E}(Q_i)\} = \sigma^2 \sum_{j=1}^n \sum_{k=1}^p X_{ik}^2 X_{jk}^2$. The quantities are asymptotically normally distributed. A similar decomposition can be made for the test statistic in other models than the linear one.

The resulting quantity $Q_i - \hat\mathrm{E}(Q_i)$ can be interpreted as the contribution of the $i$-th subject to the test statistic in the sense that it is proportional to the difference between the test statistic for the full sample and the test statistic of a reduced sample in which subject $i$ has been removed. It can also be interpreted as an alternative test statistic for the same null hypothesis as the global test, but one which uses only part of the information that the full global test uses.

The contribution $Q_i - \hat\mathrm{E}(Q_i)$ of individual $i$ takes a large value if other subjects who are similar to subject $i$ in terms of their covariates $X$ (measured in correlation distance) also tend to be similar in terms of their residual $Y_j-\mu_j$ (i.e. has the same sign). This contribution $Q_i - \hat\mathrm{E}(Q_i)$ can, therefore, be viewed as a partial global test statistic that rejects if individuals that are similar to individual $i$ in terms of their alternative covariates tend to deviate from the null model in the same direction as individual $i$  with their response variable.

The \Rfunction{subjects} function plots the p-values of these partial test statistics. As in the \Rfunction{covariates} function, other values may be plotted using the \Rfunarg{what} argument. Specifying \verb:what = "z": plots test statistics standardized by their expectation and standard deviation; specifying \verb:what = "s": gives the unstandardized test statistics $Q_i$ and \verb:what = "w": give the unstandardized test statistics weighted for the relative weights of the subjects in the test (proportional to $|Y_i|$). If weighted or unweighted standardized test statistics are plotted, bars and stripes appear to signify mean and standard deviation of the bars under the null hypothesis.

\begin{figure}[!ht]
<<fig=TRUE>>=
subjects(gt(Y,X))
@
\end{figure}

An additional argument $\Rfunarg{mirror}$ (default: \verb:TRUE:) can be used to plot the unsigned version $\bar Q_i = \sum_{j=1}^n \sum_{k=1}^p X_{ik} X_{jk} (Y_j-\mu_j)$ (no effect if \verb:what = "p":). Combined with \verb:what = "s":, this gives the first partial least squares component of the data, which can be interpreted as a first order approximation of the estimated linear predictor under the alternative. In the resulting plot, large positive values correspond to subjects that have a much higher predicted value under the alternative hypotheses than under the null, whereas large negative values correspond to subjects with a much lower expected value under the alternative than under the null.

\begin{figure}[!ht]
<<fig=TRUE>>=
subjects(gt(Y,X), what="s", mirror=FALSE)
@
\end{figure}

As in the \Rfunction{covariates} plot, the subjects in the \Rfunction{subjects} plot are ordered in a hierarchical clustering graph. The distance measure used for the clustering graph is correlation distance. Correlation distance is appropriate because the test results for subjects can be expected to be similar if their measurements are close in terms of correlation distance. The default clustering method is average linkage. This can be changed if desired, using the \Rfunarg{cluster} argument. Clustering can also be turned off by setting \verb:cluster = FALSE:. Unlike in the \Rfunction{covariates} plot, no multiple testing is done on the clustering graph.

The function tries to sort the bars in such a way that the most significant partial tests appear on the left. This sorting is, of course, constrained by the dendrogram if present. Setting the \Rfunarg{sort} argument to \verb:FALSE: to keep the bars in the original order as much as possible under the same constraints.

The default colors, legend and labels in the plot can be adjusted with the \Rfunarg{colors}, \Rfunarg{legend} and \Rfunarg{alias} arguments.

By default, the \Rfunction{subjects} function can only make a plot for a single test result, even if the \Rclass{gt.object} contains multiple test results (see Section \ref{manytests}). However, by providing a filename in the \Rfunarg{pdf} argument of the \Rfunction{subjects} function it is possible to make multiple plots, writing them to a pdf file as separate pages.


\section{Doing many tests: multiple testing}

In high-dimensional data, when the dimensionality of the design matrix of the alternative is very high, it is often interesting to study subsets of the covariates, or to compare alternative weighting options. The \Rpackage{globaltest} package facilitates this by making it possible to perform tests for many alternatives at once, and to perform various algorithms for multiple testing correction.


\subsection{Many subsets or many weights} \label{manytests}

To test one or many subsets covariates of the alternative design matrix, use the \Rfunarg{subsets} argument. If a single subset is to be tested, the \Rfunarg{subsets} argument can be presented as a vector of covariate names or of covariate indices in the alternative design matrix.
<<subset>>=
set <- LETTERS[1:3]
gt(Y,X, subsets = set)
@
To test many subsets, \Rfunarg{subsets} can be a (named) list of such vectors.
<<many sets>>=
sets <- list(one=LETTERS[1:3], two=LETTERS[4:6])
gt(Y,X, subsets = sets)
@
Duplicate identifiers in the subset vectors are not removed, but lead to increased weight for the duplicated covariates in the resulting test, except if the \verb:trim: option was set to \verb:TRUE: (see Section \ref{trim}).

To retrieve the subsets from a \Rclass{gt.object}, use the \Rfunction{subsets} method.
<<subsets method>>=
res <- gt(Y,X, subsets = sets)
subsets(res)
@

Weighting was already discussed in Section \ref{weighting}. To test many different weights simultaneously, the \Rfunarg{weights} argument can also be given as a (named) list, similar to the subsets argument.
<<many weights>>=
wts <- list(up = 1:10, down = 10:1)
gt(Y,X,weights=wts)
@
Weights can also be used as an alternative way of specifying subsets, by giving weight 1 to included covariates and 0 to others.

Weights and subsets can also be combined. Either specify a single weights vector for many subsets
<<single weight many subsets>>=
gt(Y,X, subsets=sets, weights=1:10)
@
or specify a separate weights vector for each subset. In the latter case case each weights vector may be either a vector of the same length as the number of covariates in the alternative design matrix, or, alternatively, be equal in length to corresponding subset.
<<subsets and weights>>=
gt(Y,X, subsets=sets, weights=wts)
gt(Y,X, subsets=sets, weights=list(1:3,7:5))
@

Note that in case of a name conflict between the \Rfunarg{subsets} and \Rfunarg{weights} arguments, the names of the \Rfunarg{weights} argument are returned under ``alias''. In general, the alias is meant to store additional information on each test performed. Unlike the name, the alias does not have to be unique. An alias for the test result may be provided with the \Rfunarg{alias} argument, or added or changed later using the \Rfunction{alias} method.
<<alias>>=
res <- gt(Y,X, weights=wts, alias = c("one", "two"))
alias(res)
alias(res) <- c("ONE", "TWO")
@

To take a subset of the test results, a \Robject{gt.object} can be subsetted using \verb:[: or \verb:[[: as with other \verb:R: objects. There is no distinction between \verb:[: or \verb:[[:. A \Robject{gt.object} can be sorted to increasing p-values with the \Rfunction{sort} command. In case of equal p-values, which may happen e.g.\ when doing permutation testing, the tests with the same p-values are sorted to decreasing z-scores.
<<sort>>=
res[1]
sort(res)
@


\subsection{Unstructured multiple testing procedures} \label{multtest}

When doing many tests, it is important to correct for multiple testing. The \Rpackage{globaltest} package offers different methods for correcting for multiple testing. For unstructured tests in which the tests are simply considered as an exchangeable list with no inherent structure. These methods are described in the help file of the \Rfunction{p.adjust} function (\Rpackage{stats} package). The three most important ones are
\begin{itemize}
  \item[Holm] The procedure of \cite{Holm1979} for control of the family-wise error rate
  \item[BH] The procedure of \cite{Benjamini1995} for control of the false discovery rate
  \item[BY] The procedure of \cite{Benjamini2001} for control of the false discovery rate
\end{itemize}
The procedures of Holm and \cite{Benjamini2001} are valid for any dependency structure between the null hypotheses, but the procedure of \cite{Benjamini1995} is only valid for independent or positively correlated test statistics \citep[see][for details]{Benjamini2001}.

Multiplicity-corrected p-values can be calculated with the \Rfunction{p.adjust} function. The default procedure is Holm's procedure.
<<p.adjust>>=
p.adjust(res)
p.adjust(res, "BH")
p.adjust(res, "BY")
@


\subsection{Graph-structured hypotheses 1: the focus level method} \label{focus level}

Sometimes the sets of covariates that are to be tested are structured in such a way that some sets are subsets of other sets. Such a structure can be exploited to gain improved power in a multiple testing procedure. The \Rpackage{globaltest} package offers two procedures that make use of the structure of the sets when controlling the familywise error rate. These procedures are the focus level procedure of \cite{Goeman2008}, and the inheritance procedure, a variant of the procedure of \cite{Meinshausen2008}. We treat both of these methods in turn.

Sets of covariates can be viewed as nodes in a graph, with subset relationships form the directed edges. Viewed in this way, any collection of covariates forms a directed acyclic graph.  The inheritance procedure is restricted to tree-structured graphs. The focus level is not so restricted, and can work with any directed acyclic graph.

To illustrate the focus level method, let's make some covariate sets of interest.
<<focuslevel set structure>>=
level1 <- as.list(LETTERS[1:10])
names(level1) <- letters[1:10]
level2 <- list(abc = LETTERS[1:3], cde  = LETTERS[3:5],
                     fgh = LETTERS[6:8], hij = LETTERS[8:10])
level3 <- list(all = LETTERS[1:10])
dag <- c(level1, level2, level3)
@
This gives one top node, 10 leaf nodes and 4 intermediate nodes. The structure is a directed acyclic graph because leaf nodes ``C'' and ``H'' both have more than one parent.

The focus level method requires the choice of a \emph{focus level}. This is the level in the graph at which the procedure starts testing. If significant nodes are found at this level, the procedure will fan out to find significant ancestors and offspring of that significant node. A focus level can be specified as a character vector of node identifiers, or it can be generated in an automated way using the \Rfunction{findFocus} function.
<<focus level choice>>=
fl <- names(level2)
fl <- findFocus(dag, maxsize=8)
@
The \Rfunction{findFocus} function chooses the focus level in such a way that each focus level node has at most \Rfunarg{maxsize} non-redundant offspring nodes, where a redundant node is a node that can be constructed as a union of other nodes. An optional argument \Rfunarg{atoms} (default: \verb:TRUE:) first decomposes all nodes into \emph{atoms}: small sets from which all offspring sets can be reconstructed as unions of atoms. Making use of these atoms often reduces computation time considerably, although it may, in theory, result in some loss of power.

To apply the focus level method, first create a \Rclass{gt.object} that contains all the covariates under the alternative, e.g.\ the \Rclass{gt.object} that uses the full alternative design matrix.
<<focus level>>=
res <- gt(Y,X)
res <- focusLevel(res, sets = dag, focus=fl)
sort(res)
@
As the \Rfunction{p.adjust} function, the \Rfunction{focusLevel} function reports familywise error rate adjusted p-values.

It is a property of both the inheritance and the focus level method, that the adjusted p-value of a node can never be smaller than a p-value of an ancestor node. The significant graph at a certain significance level is therefore always a coherent graph, which always contains all ancestor nodes of any rejected node. Such a graph can be succinctly summarized by reporting only its leaf nodes. This can be done using the \Rfunction{leafNodes} function.
<<focus level leaf nodes>>=
leafNodes(res)
@
The \Rfunarg{alpha} argument of the \Rfunction{leafNodes} function can be used to specify the rejection threshold for the familywise error of the significant graph.

To visualize the test result as a graph, use the \Rfunction{draw}. By default, this function draws the graph with the significant nodes in black and the non-significant ones in gray. The \Rfunarg{alpha} argument can be used to change the significance threshold. Alternatively, it is possible to draw only the significant subgraph, setting the \Rfunarg{sign.only} argument to \verb:TRUE:.
\begin{figure}[!ht]
<<draw, fig=TRUE>>=
draw(res, names=TRUE)
@
\end{figure}
The \Rfunarg{names} argument (default \verb:FALSE:) forces the use of names in the nodes. This can quickly become unreadable even for small graphs if the names for the nodes are long. By default, therefore, \Rfunction{draw} numbers the nodes, returning a legend to interpret the numbers.
<<draw legend, eval=FALSE>>=
legend <- draw(res)
@

The \Rfunarg{interactive} argument can be used to make the plot interactive. In an interactive plot, click on a node to see the node label. Exit the interactive plot by pressing escape.


\subsection{Graph-structured hypotheses 2: the inheritance method}   \label{inheritance}

An alternative method for multiple testing in graph-structured hypotheses is the inheritance method. This procedure is based on the work of \cite{Meinshausen2008}. \Rfunction{inheritance} reports familywise error rate adjusted p-values, as \Rfunction{p.adjust} and \Rfunction{focusLevel} functions do. Compared with the focus level method, the inheritance procedure is less computationally intensive, and does not require the definition of any (focus) level. However, it requires that the graph has a tree structure, rather than the more general directed acyclic graph structure that the focus level works with.

To illustrate the inheritance method, we make use of the example data. However, we can not make uso of the \verb:dag: object created in Section \ref{focus level} since it does not have a tree structure. For example, \verb:c: in \verb:dag: is a descendant of both \verb:abc: and \verb:cde:. We modify the commands of the previous section to make sure that each element of \verb:dag: has (at maximum) one parent; this guarantees that it is a tree-structured graph.

<<inheritance set structure>>=
level1 <- as.list(LETTERS[1:10])
names(level1) <- letters[1:10]
level2 <- list(ab = LETTERS[1:2], cde = LETTERS[3:5], fg = LETTERS[6:7], hij = LETTERS[8:10])
level3 <- list(all = LETTERS[1:10])
tree <- c(level1, level2, level3)
@

Now we can apply the \Rfunction{inheritance} method. The syntax of the function is very similar to the \Rfunction{focusLevel} function.
<<inheritance>>=
res <- gt(Y,X)
resI <- inheritance(res, tree)
resI
@

The inheritance procedure has two variants: one with and one without the \Rfunarg{Shaffer} variant \citep{Meinshausen2008}. Setting the argument \verb:Shaffer = TRUE: allows uniform improvement of the power of the procedure, but it the familywise error rate control is guaranteed only if the hypotheses tested in each node of the graph with only leaf nodes as offspring is precisely the intersection hypothesis of its child nodes. When doing the inheritance procedure in combination with the global test, this condition is fulfilled if the set of covariates at each node with only leaf nodes as offspring is precisely the union of the sets of covariates of its offspring leaf nodes. This condition is fulfilled for the \verb:tree: graph above, but if we had set \verb:level1 <- as.list(LETTERS[1:9]):, the node \verb:hij: contains a covariate (\verb:J:) that is not present in any of its child nodes, so that the condition for the Shaffer improvement is not fulfilled, and setting
\verb:Shaffer = TRUE: does not control the familywise error rate. If \Rfunarg{test} is a \Rclass{gt.object} the procedure check if structure of \Rfunarg{sets} allows for a Shaffer improvement, and sets \Rfunarg{Shaffer} to the correct default. In other cases, checking the validity of the Shaffer improvement is left to the user. Note that setting \verb:Shaffer = TRUE: always gives a correct procedure.

The tree structure of the hypotheses may be fixed a priori, based on the prior knowledge rather than on the data. However, in some situations a data-driven definition of the structure is allowed. \cite{Meinshausen2008} suggests to use a hierarchical clustering method using as distance matrix based on the (correlation) distance between explanatory covariates. This is valid for the global test, and may in some cases also be valid if other tests are performed.

In \Rfunction{inheritance}, the tree-structured graph \Rfunarg{sets} can be an object of class \Rclass{hclust} or \Rclass{dendrogram}. If \Rfunarg{sets} is missing and \Rfunarg{test} is a \Rclass{gt.object} the structure is derived from the structure of \Rfunarg{test}.

<<inheritance>>=
hc <- hclust(dist(t(X)))
resHC <- inheritance(res, hc)
resHC
@

It is a property of both the inheritance and the focus level method, that the adjusted p-value of a node can never be smaller than a p-value of an ancestor node. The significant graph at a certain significance level is therefore always a coherent graph, which always contains all ancestor nodes of any rejected node. Such a graph can be succinctly summarized by reporting only its leaf nodes. This can be done using the \Rfunction{leafNodes} function.
<<inheritance leaf nodes>>=
leafNodes(resI)
leafNodes(resHC)
@
The \Rfunarg{alpha} argument of the \Rfunction{leafNodes} function can be used to specify the rejection threshold for the familywise error of the significant graph.

Like for \Rfunction{focusLevel}, the \Rfunction{draw} can be used to visualize the test result as a graph:
\begin{figure}[!ht]
<<inheritance_draw, fig=TRUE>>=
draw(resHC, names=TRUE)
@
\end{figure}
However, in most cases the \Rfunction{covariates} function does a better graphical job. \Rfunction{covariates} performs \Rfunction{hclust} on the covariates and calls the \Rfunction{inheritance} function using this data-driven structure.
<<inheritance covariates, eval=FALSE>>=
covariates(res)
@


\chapter{Gene Set Testing} \label{gene set testing}

\section{Introduction}

One important application of the global test is in gene set testing in gene expression microarray data \citep{Goeman2004, Goeman2005}. Such data consist of simultaneous gene expression measurements of many thousands of probes across the genome, performed for a number of biological samples. The typical goal of a microarray experiment is to find associations between the expression of genes and a phenotype variable.

Gene set testing is a common denominator for a type of analysis for microarray data that takes together groups of genes that have a common annotation, e.g.\ which are all annotated to the same Gene Ontology term, which are all members of the same KEGG pathway, or which have a similar chromosomal location. Gene set testing methods test such gene sets together to investigate whether the genes in the gene set have a higher association with the response than expected by chance. These methods provide a single p-value for the gene set, rather than a p-value for each gene.

The global test is well suited for gene set testing; in fact, the global test was initially designed specifically with this application in mind \citep{Goeman2004}. The model that the global test uses for gene set testing is a regression model, such as might also be used to predict the response based on the gene expression measurements: in this model the gene expression measurements correspond to the covariates and the phenotype corresponds to the response. The null hypothesis that the global test tests is the null hypotheses that all regression coefficients of all the genes in the gene set are zero, i.e.\ the genes in the gene set have no predictive ability for predicting the response. The global test can therefore be seen as a method that looks for differentially expressed gene sets.

The global test tests gene sets in a single step, based on the full data, without an intermediate step of finding individual differentially expressed genes. In the classification scheme for gene set testing methods of \cite{Goeman2007}, the global test is a \emph{self-contained} method rather than a \emph{competitive} one: it tests the null hypothesis that no gene in the gene set is associated with the phenotype rather than the null hypothesis that the genes in the gene set are not more associated with the phenotype than random genes on the microarray. The latter approach is followed by enrichment methods such as GSEA and methods based on Fisher's exact test. The global test is also a \emph{subject-sampling} rather than a \emph{gene-sampling} method. This means that when determining whether the genes in the gene set have a higher association with the phenotype than expected by chance, the method looks at the random biological variation between subjects, rather than comparing the gene set with random sets of genes. The latter approach is used by gene set testing methods based on Fisher's exact test. Unlike the validity of gene-sampling methods, the validity of subject-sampling methods does not depend on the unrealistic assumption that gene expression measurements are independent.

As shown by \cite{Goeman2006}, the global test is designed to have optimal power in the situation in which the gene set has many small non-zero regression coefficients. This means that the test is especially directed to find gene sets for which many genes are associated with the phenotype in a small way. This behavior is appropriate for gene set testing, because the situation that many genes are associated with the phenotype is usually the most interesting from a gene set perspective. Still, it is true that the null hypotheses that the global test tests is false even if only a single gene in the gene set is associated with the phenotype; especially smaller gene sets may therefore become significant as a result of only a single significant gene. However, because the test is directed especially against the alternative that there are many associated genes, such examples are rare among larger gene sets.


\section{Data format}

The globaltest package uses the usual statistical orientation of data matrices in which the columns of the data matrix correspond to covariates, and the rows of the data matrix correspond to subjects. In gene set testing and in other genomics applications it is more common to use the reverse orientation, in which the columns of the data matrix correspond to the subjects and the rows to the covariates. The \Rfunction{gt.options} function can be used to change the default orientation expected by \Rfunction{gt} for the \Rfunarg{alternative} argument.
<<transpose option, eval=FALSE>>=
gt.options(transpose=TRUE)
@

Note that this option is only relevant if \Rfunarg{alternative} is given as a matrix. A \Rclass{formula} or \Rclass{ExpressionSet} input (Section \ref{ExpressionSet}) input for \Rfunarg{alternative} is automatically interpreted correctly.


\subsection{Using \Rclass{ExpressionSet} data} \label{ExpressionSet}

We illustrate gene set testing using the \cite{Golub1999} data set, a famous data set which was one of the first to use microarray data in a classification context. This dataset is available from bioconductor as the \Rpackage{golubEsets} package. We load the \verb:Golub_Train: data set, consisting of 38 Leukemia patients for which 7129 gene expression measurements were taken.
<<load Golub>>=
library(golubEsets)
data(Golub_Train)
@
The \verb:Golub_Train: data are in \Rclass{ExpressionSet} format, which is the standard format in bioconductor for storing gene expression data. The \Rclass{ExpressionSet} objects contain the gene expression data, phenotypic data, and annotation information about the genes and the experiment, all in the same \verb:R: object. The data have to be properly normalized and log- or otherwise transformed, as usual in microarray data. We keep the normalization simple and use only \Rpackage{vsn}.
<<vsn>>=
library(vsn)
exprs(Golub_Train) <- exprs(vsn2(Golub_Train))
@

The phenotype of interest is the leukemia subtype, coded as the variable \verb:ALL.AML:, with values \verb:"ALL": and \verb:"AML":, in \verb:pData(Golub_Train):. It is generally a good idea to start by testing the overall expression profile to see whether that is notably different between AML and ALL patients. We supply the \Rclass{ExpressionSet} \verb:Golub_Train: in the \Rfunarg{alternative} argument of \Rfunction{gt}. Because the \Rfunarg{alternative} argument is of class \Rclass{ExpressionSet}, the function now uses \verb:t(exprs(Golub_Train)): as the \Rfunarg{alternative} argument and \verb:pData(Golub_Train): as the \Rfunarg{data} argument.
<<overall>>=
gt(ALL.AML, Golub_Train)
@
From the test result we conclude that the overall expression profile of ALL patients and AML patients differs markedly in this experiment. This is not very surprising, as this data set has been used in many papers as an example of a data set that can be classified very easily. From this result we may expect to find many genes and gene sets to be differentially expressed.

If the overall test is not significant or only marginally significant, it can be difficult to find many genes or pathways that are differentially expressed. In this case it is usually not a good idea to perform a broad untargeted data mining type analysis of the data, e.g.\ by testing complete pathway databases, because it is likely that in this case the signal of the genes and gene sets that are differentially expressed is drowned in the noise of the genes that are not differentially expressed. A more targeted approach focussed on a limited number of candidate gene sets may be more opportune in such a situation.

Adjustment of the test result for confounders such as batch effects, clinical or phenotype covariates can be specified by specifying these variables as covariates under the null hypothesis, as described in Section \ref{basic test}. When using \Rclass{ExpressionSet} data, the easiest way to do this is with a \Rclass{formula}. The terms of such a \Rclass{formula} are automatically interpreted in terms of the \Rfunction{pData} slot of the \Rclass{ExpressionSet}. Missing data ar not allowed in phenotype variables, so we illustrate the adjustment for confounders by correcting for the data source in the Golub data (the DFCI and CALGB centers)
<<Source>>=
gt(ALL.AML ~ Source, Golub_Train)
@
In this specific case we see that the association between gene expression and disease subtype is completely confounded by the source variable. In fact, all ALL patients came from DFCI, and all AML patients from CALGB. In this case we cannot distinguish between the effects of disease subtype from the center effects: the design of this study is, unfortunately, broken.


\subsection{Other input formats}

Alternatively, the formula or matrix-based input described in Section \ref{basics} may also be used instead of the \Rclass{ExpressionSet}-based one. For matrix-based input, \Rfunction{gt} expects the usual statistical data-format in which the subjects correspond to the rows of the data matrix and the covariates (probes or genes) are the columns. The option \Rfunarg{transpose} in \Rfunction{gt.options} can be used to change this. Setting
<<transpose option, eval=FALSE>>=
gt.options(transpose=TRUE)
@
changes the default behavior of \Rfunction{gt} to expect the transposed format that is usual in genomics, with the rows of the data matrix corresponding to the genes and the columns to the subjects.

The \Rfunction{gtKEGG}, \Rfunction{gtGO} and \Rfunction{gtBroad} functions (Section \ref{databases}) always expect the genomics data format rather than the usual statistical format.


\subsection{The \Rfunarg{trim} option} \label{trim}

A second useful option to set when doing gene set testing is the \Rfunarg{trim} option. This option governs the way \Rfunction{gt} handles covariate names that appear in the \Rfunarg{subsets} argument, but are not present in the expression data matrix. The default behavior of \Rfunction{gt} is to return an error when this happens. However, in gene set testing covariates may easily be missing from the expression data, for example because the subsets are based on the annotation of the complete microarray, while some genes have been removed from the expression data matrix, perhaps due to poor measurement quality. Setting
<<trim option, eval=FALSE>>=
gt.options(trim=TRUE)
@
makes \Rfunction{gt} silently remove such missing covariates from the \Rfunarg{subsets} argument.

Additionally, if \verb:trim = TRUE:, duplicate covariate names in \Rfunarg{subsets} are automatically removed.


\section{Testing gene set databases} \label{databases}

The most common approach to gene set testing is to test gene sets from public databases. The globaltest package provides utility functions for three such databases: Gene Ontology, KEGG and the pathway databases maintained by the Broad Institute. In all cases, these functions make heavy use of the annotation packages available in Bioconductor. If the microarray that was used does not have an annotation package, the Entrez-based organism annotation packages (e.g.\ \Rpackage{org.Hs.eg.db} for human) can be used instead.


\subsection{KEGG}

The functions \Rfunction{gtKEGG} can be used to test KEGG terms. To test a single KEGG id, e.g.\ cell cycle (KEGG id \verb"04110"), use
<<gtKEGG>>=
gtKEGG(ALL.AML, Golub_Train, id = "04110")
@
The function automatically finds the right KEGG information from the \Rpackage{KEGGREST} package, and the right set of genes belonging to the KEGG id from the annotation package of the \Rpackage{hu6800} Affymetrix chip; the reference to this annotation package is contained in the \verb:Golub_Train: \Rclass{ExpressionSet} object. If \Rclass{ExpressionSet} objects are not used, the name of the annotation package can be supplied in the \Rfunarg{annotation} argument of \Rfunction{gtKEGG}.

Annotation packages are not always available for all microarray types. Therefore, a general Entrez-based annotation package is available for many organisms, e.g.\ \Rpackage{org.Hs.eg.db} for human. See \verb:www.bioconductor.org: for the names of the organism specific packages. This general entrez-based annotation package may be substituted for a specific probe annotation package if a mapping from probe(set) ids to Entrez is given (as a list or as a vector) in the \Rfunarg{probe2entrez} argument. For the Golub data we find such a mapping in the \Rpackage{hu6800.db} package.
<<KEGG organism package>>=
eg <- as.list(hu6800ENTREZID)
gtKEGG(ALL.AML, Golub_Train, id="04110", probe2entrez = eg, annotation="org.Hs.eg.db")
@

If more than one KEGG id is tested, multiple testing corrected p-values are automatically provided. The default multiple testing method is Holm's, but others are available through the \Rfunarg{multtest} argument. See also the \Rfunction{p.adjust} function, described in Section \ref{multtest}. The results are sorted to increasing p-values (using the \Rfunction{sort} method), unless the \Rfunarg{sort} argument of \Rfunction{gtKEGG} is set to \verb:FALSE:.
<<gtKEGG multtest>>=
gtKEGG(ALL.AML, Golub_Train, id=c("04110","04210"), multtest="BH")
@
If the \Rfunarg{id} argument is not specified, the function \Rfunction{gtKEGG} will test all KEGG pathways.
<<testKEGG,eval=FALSE>>=
gtKEGG(ALL.AML, Golub_Train)
@


\subsection{Gene Ontology}

To test Gene Ontology terms the special function \Rfunction{gtGO} is available. This function accepts the same arguments as \Rfunction{gt}, except the \Rfunarg{subsets} argument, which is replaced by a collection of options to create gene sets from Gene Ontology. To test a single gene ontology term, e.g.\ cell cycle (\verb"GO:0007049"), we say
<<gtGO>>=
gtGO(ALL.AML, Golub_Train, id="GO:0007049")
@
The function automatically finds the right Gene Ontology information from the \Rpackage{GO.db} package, and the right set of genes belonging to the gene ontology term from the annotation package of the \Rpackage{hu6800} Affymetrix chip; the reference to this annotation package is contained in the \verb:Golub_Train: \Rclass{ExpressionSet} object. If \Rclass{ExpressionSet} objects are not used, the name of the annotation package can be supplied in the \Rfunarg{annotation} argument of \Rfunction{gtGO}.

Annotation packages are not always available for all microarray types. Therefore, a general Entrez-based annotation package is available for many organisms, e.g.\ \Rpackage{org.Hs.eg.db} for human. See \verb:www.bioconductor.org: for the names of the organism specific packages. This general entrez-based annotation package may be substituted for a specific probe annotation package if a mapping from probe(set) ids to Entrez is given (as a list or as a vector) in the \Rfunarg{probe2entrez} argument. For the Golub data we find such a mapping in the \Rpackage{hu6800.db} package.
<<GO organism package>>=
eg <- as.list(hu6800ENTREZID)
gtGO(ALL.AML, Golub_Train, id="GO:0007049", probe2entrez = eg, annotation="org.Hs.eg")
@

It is also possible to test all terms in one or more of the three ontologies: Biological Process (BP), Molecular Function (MF) and Cellular component (CC). A minimum and/or a maximum number of genes may be specified for each term.
<<testBP,eval=FALSE>>=
gtGO(ALL.AML, Golub_Train, ontology="BP", minsize = 10, maxsize = 500)
@

If more than one gene ontology term is tested, multiple testing corrected p-values are automatically provided. The default multiple testing method is Holm's, but others are available through the \Rfunarg{multtest} argument. See also the \Rfunction{p.adjust} function, described in Section \ref{multtest}. The results are sorted to increasing p-values (using the \Rfunction{sort} method), unless the \Rfunarg{sort} argument of \Rfunction{gtGO} is set to \verb:FALSE:.
<<gtGO multtest>>=
gtGO(ALL.AML, Golub_Train, id=c("GO:0007049","GO:0006915"), multtest="BH")
@

A multiple testing method that is very suitable for Gene Ontology is the focus level method, described in more detail in Section \ref{focus level}. This multiple testing method presents a coherent significant subgraph of the Gene Ontology graph. This is a relatively computationally intensive method. To keep this vignette light, we shall only demonstrate the focus level method on the subgraph of ``cell cycle'' GO term and all its descendants.
<<focusGO>>=
descendants <- get("GO:0007049", GOBPOFFSPRING)
res <- gtGO(ALL.AML, Golub_Train, id = c("GO:0007049", descendants), multtest = "focus")
leafNodes(res)
@
The leaf nodes can be seen as a summary of the significant GO terms: they present the most specific terms that have been declared significant at a specified significance level \Rfunarg{alpha} (default 0.05). The graph can be drawn using the \Rfunction{draw} function. In the interactive mode of this function, click on the nodes to see the GO id and term. The default of this function is to draw the full graph, with the non-significant nodes greyed out. It is also possible to only draw the significant graph by setting the \Rfunarg{sign.only} argument to \verb:TRUE:. The draw function returns a legend to the graph, relating the numbers appearing in the plot to the GO terms. This is useful when using \Rfunction{draw} in non-interactive mode
\begin{figure}[!ht]
<<significantGO1,eval=FALSE>>=
draw(res, interactive=TRUE)
legend <- draw(res)
@
<<significantGO2, echo=FALSE, fig=TRUE>>=
draw(res)
@
\end{figure}


\subsection{The Broad gene sets}

A third frequently used database is the collection of curated gene sets maintained by the Broad institute. The sets are only available after registration at \verb&http://www.broad.mit.edu/gsea/downloads.jsp#msigdb&. To use the Broad gene sets, download the file \verb:msigdb_v.2.5.xml:, which contains all sets. A convenient function to read the xml file into \verb:R: is provided in the \Rfunction{getBroadSets} function from the \Rpackage{GSEABase} package. Once downloaded and read, the \Rfunction{gtBroad} function can be used to analyze these gene sets using the global test.
<<getBroadSets, eval=FALSE>>=
broad <- getBroadSets("your/path/to/msigdb_v.2.5.xml")
@
The examples in this vignette are displayed without results, because we cannot include the \verb:msigdb_v.2.5.xml: file in the \Rpackage{globaltest} package.

To test a single Broad set, e.g.\ the chromosomal location chr5q33, use
<<gtBroad, eval=FALSE>>=
gtBroad(ALL.AML, Golub_Train, id = "chr5q33", collection=broad)
@
The function automatically maps the gene set to the probe identifiers from the annotation package of the \Rpackage{hu6800} Affymetrix chip; the reference to this annotation package is contained in the \verb:Golub_Train: \Rclass{ExpressionSet} object. If \Rclass{ExpressionSet} objects are not used, the name of the annotation package can be supplied in the \Rfunarg{annotation} argument of \Rfunction{gtBroad}.

Annotation packages are not always available for all microarray types. Therefore, a general Entrez-based annotation package is available for many organisms. This general annotation package may be substituted for a specific annotation package if a mapping from probe(set) ids to Entrez is given (as a list or as a vector). For the Golub data we use the mapping from the \Rpackage{hu6800.db} package to obtain this mapping.
<<Broad organism package, eval=FALSE>>=
eg <- as.list(hu6800ENTREZID)
gtBroad(ALL.AML, Golub_Train, id = "chr5q33", collection=broad, probe2entrez = eg, annotation="org.Hs.eg.db")
@
See \verb:www.bioconductor.org: for the names of the organism specific packages.

If more than one Broad set is tested, multiple testing corrected p-values are automatically provided. The default multiple testing method is Holm's, but others are available through the \Rfunarg{multtest} argument. See also the \Rfunction{p.adjust} function, described in Section \ref{multtest}. The results are sorted to increasing p-values (using the \Rfunction{sort} method), unless the \Rfunarg{sort} argument of \Rfunction{gtBroad} is set to \verb:FALSE:.
<<gtBroad multtest, eval=FALSE>>=
gtBroad(ALL.AML, Golub_Train, id=c("chr5q33","chr5q34"), multtest="BH", collection=broad)
@

The broad collection contains four categories
\begin{itemize}
\item[c1] positional gene sets
\item[c2] curated gene sets
\item[c3] motif gene sets
\item[c4] computational gene sets
\item[c5] GO gene sets
\end{itemize}
To test all gene sets from a certain category, use
<<Broad c1, eval=FALSE>>=
gtBroad(ALL.AML, Golub_Train, category="c1", collection=broad)
@

\section{Concept profiles} \label{concept}

A drawback of the three gene set databases above is that they have hard criterion for membership: each gene either belongs to the set or it does not. In reality, however, association of genes with biological concepts is gradual. Some genes are more central to a certain biological process than others, and for some genes the association with a process is more certain or well-documented than for others. To take this into account, databases can be used that contain associations between genes and concepts, rather than simply gene sets. One of these is the Anni tool, available from \verb&http://www.biosemantics.org/anni&. A function to test concepts from Anni is given in the function \Rfunction{gtConcept}.

Like \Rfunction{gtBroad}, the function \Rfunction{gtConcept} requires the user to download files that are not available within \verb:R:, but can be found on \verb:www.biosemantics.org/weightedglobaltest:. The examples for \Rfunction{gtConcept} in this vignette are displayed without results, because we the concept files are too large to be included in the \Rpackage{globaltest} package. To test a certain collection, for example \verb:Body System.txt:, we say

<<gtConcept, eval=FALSE>>=
gtConcept(ALL.AML, Golub_Train, conceptmatrix="Body System.txt")
@

This automatically tests all concepts included in the file. Note that the files \verb"conceptID2name.txt" and \verb"entrezGeneToConceptID.txt" must also be downloaded from the same website or the function to work.

The function automatically maps the gene set to the probe identifiers from the annotation package of the \Rpackage{hu6800} Affymetrix chip; the reference to this annotation package is contained in the \verb:Golub_Train: \Rclass{ExpressionSet} object. If \Rclass{ExpressionSet} objects are not used, the name of the annotation package can be supplied in the \Rfunarg{annotation} argument of \Rfunction{gtConcept}.

Annotation packages are not always available for all microarray types. Therefore, a general Entrez-based annotation package is available for many organisms. This general annotation package may be substituted for a specific annotation package if a mapping from probe(set) ids to Entrez is given (as a list or as a vector). For the Golub data we use the mapping from the \Rpackage{hu6800.db} package to obtain this mapping.
<<gtConcept organism package, eval=FALSE>>=
eg <- as.list(hu6800ENTREZID)
gtConcept(ALL.AML, Golub_Train, conceptmatrix="Body System.txt", probe2entrez = eg, annotation="org.Hs.eg.db")
@

The \Rfunction{gtConcept} function uses the weighted version of the global test (see also Section \ref{weighting}), with weights given by each gene's association with a concept. An argument \Rfunarg{threshold} sets weights below the given threshold to zero, which limits computation time. The \verb:#Cov: column in the results output gives the number of probes with non-zero weight. A further argument \Rfunarg{share}, determines what to do with genes that have multiple probes. If \Rfunarg{share} is set to \Robject{TRUE}, the weight for each probe is set to the weight of the gene divided by the number of probes of that gene, making the probes share the total weight allocated to the gene. If \Rfunarg{share} is set to \Robject{FALSE}, each probe gets the full weight allocated to the gene.

Multiple testing corrected p-values are automatically provided by \Rfunction{gtConcept}. The default multiple testing method is Holm's, but others are available through the \Rfunarg{multtest} argument. See also the \Rfunction{p.adjust} function, described in Section \ref{multtest}. The results are sorted to increasing p-values (using the \Rfunction{sort} method), unless the \Rfunarg{sort} argument of \Rfunction{gtConcept} is set to \verb:FALSE:.
<<gtConcept multtest, eval=FALSE>>=
gtConcept(ALL.AML, Golub_Train, conceptmatrix="Body System.txt", multtest="BH")
@


\section{Gene and sample plots}

\subsection{Visualizing features}

The covariate (or ``features'') plot may be used to great effect for investigating to which individual probes or genes or to which subsets of the gene set a significant result for a gene set may be attributed.
\begin{figure}[!ht]
<<KEGG_covariates, fig=TRUE>>=
res <- gtKEGG(ALL.AML, Golub_Train, id = "04110")
features(res, alias=hu6800SYMBOL)
@
\end{figure}
The details of the \Rfunction{features} plot are described in Section \ref{covariates}. The \Rfunarg{alias} argument is useful to replace the probe identifiers with more familiar gene symbols.

The black line in the \Rfunction{features} plot represents the significant subgraph of the clustering tree. To find the leaf nodes that characterize the graph, use the function \Rfunction{leafNodes}.
<<LeafNodes geneplot>>=
ft <- features(res, alias=hu6800SYMBOL)
leafNodes(ft)
@
It may happen that the leaf nodes of the significant graph are not individual features, but sets of features higher up in the clustering graph. Use the \Rfunction{subsets} method to find which features belong to such a node.
<<subsets leafNodes, eval=FALSE>>=
subsets(leafNodes(ft))
@
It is possible to only plot the significant subtree with the \Rfunarg{zoom} argument. This is especially useful if the set of features is large.
\begin{figure}[!ht]
<<KEGG_covariates_zoom, fig=TRUE>>=
res <- gtKEGG(ALL.AML, Golub_Train, id = "04110")
features(res, alias=hu6800SYMBOL, zoom=TRUE)
@
\end{figure}

The \Rfunction{extract} function can be useful to get information on the individual features, and the \Rfunarg{plot} argument can be used to suppress plotting.
<<extract geneset>>=
ft <- features(res, alias=hu6800SYMBOL, plot=FALSE)
extract(ft)
@

When testing many GO or KEGG terms it can be convenient to make features plots for all tested gene sets at once, writing all plots to a pdf.
<<pdf covariates, eval=FALSE>>=
res_all <- gtKEGG(ALL.AML, Golub_Train)
features(res_all[1:5], pdf="KEGGcov.pdf", alias=hu6800SYMBOL)
@

\subsection{Visualizing subjects}

Similarly, the subjects plot, described in Section \ref{subjects}, can be used to investigate which subjects are similar in terms of their expression signature to other subjects with the same response variable, and which deviate from that pattern. In the \Rfunction{subjects} diagnostic plot, the subjects associated with strong evidence for the association between the response and the gene expression profile of the pathway have low p-values (tall bars), whereas the subjects with high p-values have weak or even contrary evidence. The most interesting subjects plot to look at is usually the subjects plot for the global test on all genes. From the figure, in this case, we note that the expression profile of the AML subjects seems more homogeneous than that of the ALL subjects: the latter group tends to be less coherent overall, and to contain more outlying subjects.
\begin{figure}[!ht]
<<KEGG_subjects, fig=TRUE>>=
res <- gt(ALL.AML, Golub_Train)
subjects(res)
@
\end{figure}
Just as with the \Rfunction{covariates} plot, \Rfunction{subjects} plots can be called on many gene sets at once, e.g.\ the top 25 pathways, and the results written to a pdf file.
<<pdf covariates, eval=FALSE>>=
res_all <- gtKEGG(ALL.AML, Golub_Train)
subjects(res_all[1:25], pdf="KEGGsubj.pdf")
@


\section{Survival data} \label{survival}

The examples in this chapter so far were all in a classification context, in which the response category had two possible values, and the logistic regression model was used. The \Rpackage{globaltest} package is not limited to this response type, but can also handle multi-category response (using a multinomial logistic regression model), continuous response (using a linear regresseion model), count data (using a Poisson regression model), and survival data (using the Cox proportional hazards model). See section \ref{models} for more details.

The multi-category, linear and count data versions are called in exactly the same way as the two-category one. The \Rfunction{gt} function will try to determine the model from the input, but the user can override any automatic choice by specifying the \Rfunarg{model} argument.

For survival data, the input format is similar to the one used by the \Rpackage{survival} package. In the \verb:michigan: data set \citep{Beer2002} from the \Rpackage{lungExpression} package, for example, the survival time is coded in a time variable \verb:TIME..months.:, and a status variable \verb:death:, for which 1 indicates that the patient passed away at the recorded time point, and 0 that the patient was withdrawn alive. To test for an overall association between the gene expression profile and survival, we test
<<lungExpression>>=
library(lungExpression)
data(michigan)
gt(Surv(TIME..months., death==1), michigan)
@


\section{Comparative proportions}

In some cases it can be of interest not only to know whether a certain gene set is significantly associated with a phenotype, but also whether it is exceptionally associated with the phenotype for a gene set of its size in the data set under study. This is a so-called competitive view on gene set testing. See \cite{Goeman2007} for issues involved with this competitive view.

It is possible to use \Rpackage{globaltest} for such competitive gene set exploration using the function \Rfunction{comparative}. For each gene set tested, this function calculates the proportion of randomly sampled gene sets of the same size as the tested gene set that has an equal or larger global test p-value. This comparative proportion can be used as a diagnostic for the test results. Gene sets with small comparative proportions are exceptionally significant in comparison to a random gene set of its size in the data set. The comparative proportion is a diagnostic that conveys additional information. It should not be interpreted as a p-value in the usual sense.
<<comparative>>=
res <- gtKEGG(ALL.AML, Golub_Train, id = "04110")
comparative(res)
@

The number of random gene sets of each size that are sampled can be controlled with the argument \Rfunarg{N} (default 1000). The argument \Rfunarg{zscores} (default: \verb:TRUE:) controls whether the comparison between the test results of the gene set and its random competitors is based on the p-values or on the z-scores of the test.

\chapter{Goodness-of-Fit Testing}\label{gof testing}


\section{Introduction}

Another application of the global test is in goodness-of-fit testing for regression models.
Generalized linear models, while flexible in terms of the supported response distributions, obey rather strong assumptions like linearity of the effect of the covariates on the predictor and the independence of the observations.
The Cox regression model, even though leaves the baseline hazard unspecified, relies on the quite restrictive proportional hazards assumption.
Therefore, in practical regression problems, lack of fit comes in all shapes and sizes:
\begin{itemize}
\item Unit- or cluster-specific heterogeneity may exist;
\item The effect of continuous covariates on the predictor may be of non-linear form;
\item Interactions between covariates may be missed or be more complex;
\item The proportional hazards assumption may not hold.
\end{itemize}

Distinguishing the different types of lack of fit is of practical importance:
if we find evidence against the model, we generally also want to know why the model does not fit.

In this Chapter we introduce a goodness-of-fit testing approach based on the global test.
It requires the specification of an alternative model, which identifies the type of lack of fit the test is directed against. Various types of lack of fit are treated within the same framework and many existing tests can be considered as special cases.

Suppose that we are concerned with the adequacy of some regression model \verb:Y ~ X:, where \verb:X: represents the null design matrix. The alternative model can be cast into the generic form  \verb:Y ~ X + Z:, where
the choice of \verb:Z: depends on the type of lack of fit under investigation.
Once \verb:Z: has been chosen, the global test is applied for testing \verb:Y ~ X: against \verb:Y ~ X + Z:.

Sometimes a reparameterization of the alternative model is necessary.
The required parameterization is either a penalized regression model with a ridge penalty on the coefficients associated with \verb:Z: or a mixed effect model where the coefficients associated with \verb:Z: are i.i.d. random effects.

The examples listed below illustrate testing against several types of lack of fit.
We have not attempted to write an exhaustive list, but rather to show how different
choices of \verb:Z: accomodate to various types of lack of fit.


\section{Heterogeneity}

The data \verb"faults" gives the number of faults in rolls of textile fabric with varying
length \citep{Bissell1972}. We consider a Poisson log-linear model with logarithm of the
roll length as covariate. However, we may allow for the possibility of extra-Poisson variation
by using a mixed model with i.i.d. random effects, one for each observation.
Here $\Robject{Z}$ is specified as the identity matrix with ones on the
main diagonal and zeros elsewhere. For testing against overdispersion, use
<<faults>>=
require("boot")
data(cloth)
Z <- matrix(diag(nrow(cloth)), ncol = nrow(cloth), dimnames = list(NULL, 1:nrow(cloth)))
gt(y ~ log(x), alternative = Z, data = cloth, model = "poisson")
@
The null hypothesis of no overdispersion can be rejected at the significance level of 5\%.

The data \verb"rats" comes from a carcinogen experiment using 150 female rats, 3 each from 50 litters \cite{Mantel1977}.
One rat from each litter was injected with a powerful carcinogen, and the time to tumor development, measured in weeks, was recorded.
It is conceivable that the risk of tumor formation may depend on the genetic background or the early environmental conditions shared by siblings within litters, but differing between litters. Thus, intra-litter correlation in time to tumor appearance may exists.
An alternative model allowing intra-litter correlations is a mixed model with i.i.d. random intercepts representing the litter effect. Here the matrix $\Robject{Z}$ is specified as a block matrix where each row is a vector of zeros except for a 1 in one position that indicates which litter the rat is from. For testing the hypothesis of no intra-litter correlation, use
<<litters>>=
library("survival")
data(rats)
nlitters<-length(unique(rats$litter))
Z<-matrix(NA,dim(rats)[1],nlitters, dimnames=list(NULL,1:nlitters))
for (i in 1:nlitters) Z[,i]<-(rats[,1]==i)*1
gt(Surv(time,status)~rx,alternative=Z,data=rats,model="cox")
@
The null hypothesis of no intra-litter correlation can not be rejected at the significance level of 5\%.

\section{Non-linearity}

In many applications, the assumption of a linear dependence of the response on covariates is inappropriate. Semiparametric models provide a flexible alternative for detecting non-linear
covariate effects. For a single continuous covariate \verb:X:, the model \verb:Y~X: is extended to \verb:Y~X+s(X):, where \verb:s(X): is an unspecified smooth function.

\subsection{P-Splines}

One increasingly popular idea to represent \verb:s(X): is the P-splines approach, introduced by \cite{Eilers1996}. In this approach \verb:s(X): is replaced by a B-spline basis \verb:Z:, giving the alternative model \verb:Y~X+Z:, where the coefficients associated with \verb:Z: are penalized to guarantee sufficient smoothness.

The function \Rfunction{gtPS} can be used to define P-splines. We need to specify the following arguments:
 i) \Rfunarg{bdeg}, the degree of B-spline basis,
ii) \Rfunarg{nint}, the number of intervals determined by equally-spaced knots placed on the \verb:X:-axis, and
iii) \Rfunarg{pord}, the order of the differences indicating the type of the penalty imposed to the coefficients.

The \Rfunarg{bdeg} and \Rfunarg{nint} arguments are used to construct a B-spline basis \verb:Z: (default values are \verb:bdeg=3: and \verb:nint=10:).
The order of differences \Rfunarg{pord} deserves more attention (default value is \verb:pord=2:).
Remember that we should obtain a ridge penalty on the coefficients associated with \verb:Z:.
This is true with \verb:pord=0:, but in the world of P-splines it is common to use a roughness penalty based on differences of adjacent B-Spline coefficients, for instance, second order differences \verb:pord=2:.

In this case we have to reparameterize the alternative model by decomposing \verb:Z: into \verb:U: and \verb:P:. This gives the alternative model \verb:Y~X+U+P: where the coefficients associated with \verb:U: are unpenalized whereas the coefficients associated with \verb"P" are penalized by a ridge penalty. However, the global test is not meant for testing the unpenalized coefficient, but it is concerned with the penalized coefficients. To get around this and test only for the penalized coefficients to be zero, we have to make sure that the columns of \verb:U: spans a subspace of the columns of \verb:X:, so that \verb:U: can be absorbed into \verb:X:. Otherwise, we are inadvertently changing the null hypothesis, or equivalently, we are considering the null model \verb:Y~X+U:.

We can best illustrate this with a simple example: we add some Gaussian noise to the second data set reported in \cite{Anscombe1973}, where \verb:Y: has a quadratic relation with \verb:X:. To test \verb:Y~X: against \verb:Y~X+s(X): with default values, use:
<<anscombe>>=
data(anscombe)
set.seed(0)
X<-anscombe$x2
Y<-anscombe$y2 + rnorm(length(X),0,3)
gtPS(Y~X)
@
The same result can be obtained by using \Rfunction{bbase} to construct the B-spline basis \verb:Z: and \Rfunction{reparamZ} to get the penalized part \verb:P: to be plugged into \Rfunction{gt}:
<<reparamZ>>=
Z<-bbase(X,bdeg=3,nint=10)
P<-reparamZ(Z,pord=2)
gt(Y~X,alternative=P)
@
A quick way to check whether \verb:U: is absorbed into the null design matrix or not is to fit the augmented null model and see if all the coefficients associated with \verb:U: are not defined because of singularities:
<<Uspan>>=
U<-reparamZ(Z,pord=2, returnU=TRUE)$U
lm(Y~X+U)$coefficients
@

The function \Rfunction{gtPS} allows the specification of multiple arguments:
<<arg pord>>=
gtPS(Y~X, pord=list(Z=0,P=2))
@
However, the result is not conclusive because \verb:pord=2: detects the deviation from linearity at the significance level of 5\%, whereas \verb:pord=0: does not. To assess the global significance, set \verb"robust=TRUE":
<<arg robust>>=
rob<-gtPS(Y~X, pord=list(Z=0,P=2), robust=TRUE)
rob@result
@

Another way to obtain a global result is to combine the matrices \verb:Z: (corresponding to \verb:pord=0:) and \verb:P: (corresponding to \verb:pord=2:) into one overall matrix:
<<cbind weights>>=
comb<-gt(Y~X, alternative=cbind(Z,P))
comb@result
@
However, it may not be satisfactory because the component matrices \verb:Z: and \verb:P: do not contribute equally in the test statistic. In constrast, the \Rfunarg{robust} argument assigns equal weight to each component:
<<robust weights>>=
colrange<-list(Z=1:ncol(Z), P=(ncol(Z)+1):(ncol(Z)+ncol(P)))
sapply(list(combined=comb,robust=rob), function(x){sapply(colrange,
function(y){sum(weights(x)[y])/sum(weights(x))})})
@

\subsection{Generalized additive models}

With multiple covariates, generalized addittive models (GAMs) augment the linear predictor
\verb:~X1+X2+...: by a sum of smooth terms \verb:s(X1)+s(X2)+...:.

A classic example dataset for GAMs is \verb:kyphosis:, representing observations
on 81 children undergoing corrective surgery of the spine.
For testing against non-linearity, the logististic model \verb:Kyphosis~Age+Number+Start: is compared to the GAM \verb:Kyphosis~...+s(Age)+s(Number)+s(Start):
<<kyphosis>>=
require("rpart")
data("kyphosis")
fit0<-glm(Kyphosis~., data = kyphosis, family="binomial")
res<-gtPS(fit0)
res@result
@
From the test result we can suspect that there is a non-linear effect in at least one covariate. To list the smooth terms specified in the alternative model, use:
<<sterms>>=
sterms(res)
@

A follow-up question concerns which covariates exhibit non-linearity.
To address this question, we can fit the the same alternative model used for the test to decide what modifications to the model may be appropriate to consider.
An advantage of having a specified alternative is that the same alternative model that was used in the test can be fitted.
We use the package \Rpackage{penalized} to perform ridge regression estimation
with the amount of shrinkage determined by the tuning parameter \Rfunarg{lambda2}. We set \Rfunarg{lambda2} equal to 0.086, the value maximizing the cross-validated likelihood.
To get the alternative design matrix used in the test, set the argument \Rfunarg{returnZ}
to \verb"TRUE":
<<penalized fit>>=
require("penalized")
Z<-gtPS(fit0, returnZ=TRUE)$Z
fit1<-penalized(Kyphosis, penalized=~ Z, unpenalized=~Age+Number+Start, data = kyphosis, model="logistic", lambda2 = 0.086, trace=FALSE)
@


\begin{figure}[h!]
\begin{center}
<<label=goodness_kyphosis,fig=TRUE,echo=FALSE>>=
bd=3
ni=10
po=2
covnames<-names(kyphosis)[-1]
d<-bd+ni-po
gammas<-fit1@penalized
betas<-fit1@unpenalized
l<-length(covnames)
cd<-c(0,cumsum(rep(d,l)))
op <- par(mfrow = c(2, 2))
for (i in 1:3){
x<-kyphosis[,covnames[i]]
sx<-sort(x,index.return=T)
ind<-vector("list", l)
ind[[i]]<-(cd[i]+1):(cd[i+1])
plot(sx$x, (Z[sx$ix,ind[[i]]]%*%gammas[ind[[i]]] ), type="b",ylim=c(-1.7,0.7), xlab=covnames[i], ylab=paste("s(",covnames[i],")", sep=""))
lines(abline(h=0,lty="dotted"))
rug(x)
}
par(op)
@
\end{center}
\caption{Kyphosis data: component smooth terms.}
\label{fig:kyphosis}
\end{figure}

Figure \ref{fig:kyphosis} shows the component smooth terms of the fitted GAM.
From the plots it seems that all the covariates have a quadratic pattern, though \verb:Number: it is much less pronounced than for the other two variables.

The argument \Rfunarg{covs} can be used to select a subset of the covariates, and testing for non-linearity is done for that subset only:
<<arg covs>>=
gtPS(fit0, covs=c("Age","Start"))
@

Because \verb:Number: and \verb:Start: are heavily tied, one can
modify the number of intervals for those covariates:
<<arg nint>>=
gtPS(fit0,covs=c("Age","Number","Start"), nint=list(a=5, b=c(5,1,1)), pord=0)
@
With \verb:pord=0:, the choice of \verb:nint: is crucial: too small may not be flexible enough to capture the variability of the data, too large tends to overfit the data. In constrast, higher-order penalties guarantee sufficient smoothness and are less affected by the choice of \verb:nint:.

An alternative GAM construction is to build and concatenate each model component like building blocks:
<<cbind GAM>>=
covs=c("Age","Number","Start")
bd=c(3,3,3);ni=c(10,10,10);po=c(2,2,2);cs<-c(0,cumsum(bd+ni-po))
X0<-model.matrix(fit0)[,]
combZ<-do.call(cbind,lapply(1:length(covs),function(x){reparamZ(bbase(kyphosis[,covs[x]], nint=ni[x], bdeg=bd[x]), pord=po[x])}))
comb<-gt(Kyphosis~., alternative=combZ, data = kyphosis, model="logistic")
comb@result
@
However, the model components may not contribute equally in the test statistic:
<<cbind weights GAM>>=
range<-lapply(1:length(covs),function(x){(cs[x]+1):(cs[x+1])})
names(range)<-covs
sapply(range,function(x){sum(weights(comb)[x])/sum(weights(comb))})
@
To assign equal weight to each component, as \Rfunction{gtPS} does, use the function \Rfunction{reweighZ}:
<<reweighZ>>=
rwgtZ<-do.call(cbind,lapply(1:length(covs),function(x){reweighZ(reparamZ(bbase(kyphosis[,covs[x]], nint=ni[x], bdeg=bd[x]), pord=po[x]),fit0)}))
rwgt<-gt(Kyphosis~., alternative=rwgtZ, data = kyphosis, model="logistic")
sapply(range,function(x){sum(weights(rwgt)[x])/sum(weights(rwgt))})
@

\section{Non-linear and missed interactions}

Suppose we are modelling the dependence of the response on several covariates, expressed as
\verb:Y~X1+X2+...:. For testing against the alternative that any non-linearities or interaction effects have been missed, one can consider the model \verb:Y~X1+X2+...+s(X1,X2,...):, where \verb:s(): is an unspecified multi-dimensional smooth function.

\subsection{Kernel smoothers}

Kernel smoothers have advantages over P-splines for constructing multi-dimensional smooth terms, even though tensor products of B-splines can still be used for low dimensions.

The data \verb:LakeAcidity: concerns 112 lakes in the Blue Ridge mountains area. Of interest is the dependence of the water acidity on the geographic locations (latitude and longitude) and the calcium concentration (in the log10 scale). To test\verb:ph~log10(cal)+lat+lon: against \verb:ph~...+s(cal,lat,lon):, use:
<<lake>>=
library(gss)
data(LakeAcidity)
fit0<-lm(ph~log10(cal)+lat+lon, data=LakeAcidity)
res<-gtKS(fit0)
res@result
sterms(res)
@
The smoothing matrix \verb:Z: is defined by a distance measure \Rfunarg{metric}, a kernel shape \Rfunarg{kernel} and a bandwidth \Rfunarg{quant}, expressed as the percentile of the distribution of distance between observations, which controls the amount of smoothing.
If the argument \Rfunarg{termlabels} is set to \verb:TRUE:, the smoothing term \verb:s(log10(cal),lat,lon): is obtained.

<<trace>>=
gtKS(fit0, quant=seq(.01,.99,.02), data=LakeAcidity, termlabels=TRUE, robust=T)
@

\begin{figure}[h!]
\begin{center}
<<label=goodness_trace,fig=TRUE,echo=FALSE>>=
p<-sapply(seq(.01,.99,.02),function(x){gtKS(fit0, termlabels=T,quant=x, data=LakeAcidity)@result[,1]})
plot(seq(.01,.99,.02),p, type="s", xlab="quant", ylab="p-value", ylim=c(0,.5), xlim=c(0,1))
abline(h=gtKS(ph~log10(cal)+lat+lon, quant=seq(.01,.99,.02), data=LakeAcidity, robust=T, termlabels=T)@result[,1], lty="dotted")
@
\end{center}
\caption{Lake Acidity data: significance trace.}
\label{fig:trace}
\end{figure}

The choice of the bandwidth may be crucial: the plot of Figure \ref{fig:trace} illustrates the influence of \verb"quant" (from .01 to .99 with increment of .02) on the significance of the test. The result seems conclusive since it stays mostly under the conventional 5\% level. \cite{Azzalini1993} considered the same plot, which they refer to as the `significance trace'. The global significance (dotted line) is obtained by setting \verb:robust=TRUE::


Latitude and longitude are included in the model to allow for geographical effects in the pattern of water acidity. However, it is less natural to include these terms separately since they define a two-dimensional co-ordinate system.
For testing whether the interaction between latitude and longitude is linear or is of a more complex non-linear form, a two-dimensional interaction surface \verb"s(lat,lon)" can be constructed by a tensor product of univariate P-splines penalized by a Kroneker sum of penalties. To test \verb"ph~lat+lon+lat:lon" against \verb"ph~...+s(lat,lon)", use:
<<btensor>>=
fit0<-lm(ph~lat*lon, data=LakeAcidity)
res<-gtPS(fit0, covs=c("lat","lon"), interact=TRUE, data=LakeAcidity)
res@result
sterms(res)
@

Figure \ref{fig:lake} displays the fitted alternative model, which suggests a non-linear interaction between latitude and longitude.

\begin{figure}[h!]
\begin{center}
<<label=goodness_lake,fig=TRUE,echo=FALSE>>=
Z<-gtPS(fit0, returnZ=TRUE, interact=TRUE)$Z
fit1<-penalized(ph, penalized=Z, unpenalized=~lat*lon, data = LakeAcidity, lambda2 = 1, trace=FALSE)
lon<-seq(79,85,length=50)
lat<-seq(33,38,length=50)
new<-data.frame(expand.grid(lon=lon, lat=lat))
Znew<-btensor(new, bdeg=c(3,3), nint=c(10,10), pord=c(2,2))
fitted<-matrix(predict(fit1,unpenalized=~lat*lon, penalized=Znew, data=new)[,1],50,50)
persp(lon,lat,fitted,theta=-25)
@
\end{center}
\caption{Lake Acidity data: fitted alternative model.}
\label{fig:lake}
 \end{figure}


To test against non-linear main effects or non-linear interactions, we can consider the
alternative \verb"ph~...+s(lat)+s(lon)+s(lat,lon)". Each model component can be constructed and combined like building blocks. The function \Rfunction{bbase} in combination with \Rfunction{reparamZ} can be used for constructing \verb"s(lat)" and \verb"s(lon)", whereas \Rfunction{btensor} for constructing \verb"s(lat,lon)" as tensor product of P-splines (reparameterized according to Kroneker sum of penalties). Finally, \Rfunction{reweighZ} can be used to give to each component the same contribution in the test statistic:
<<anova type>>=
Z1<-reweighZ(reparamZ(bbase(LakeAcidity$lat, bdeg=3, nint=10), pord=2), fit0)
Z2<-reweighZ(reparamZ(bbase(LakeAcidity$lon, bdeg=3, nint=10), pord=2), fit0)
Z12<-reweighZ(btensor(cbind(LakeAcidity$lat, LakeAcidity$lon),bdeg=c(3,3),nint=c(10,10),pord=c(2,2)), fit0)
gt(ph~lat*lon, alternative=cbind(Z1,Z2,Z12), data=LakeAcidity)
@



\subsection{Varying-coefficients models}

Sometimes the linear interaction \verb"X:F" between a continuous covariate \verb"X" and a factor \verb"F" is not appropriate, and a non-linear interaction \verb"s(X):F" may be preferred to let \verb"F" to vary smoothly over the range of "X".

Let's look at \verb:nox: data as an example. Ethanol fuel was burned in a single cylinder
engine. For various settings of the engine compression \verb"comp" and the equivalence
ratio \verb"equi", the emissions of nitrogen oxides \verb"nox" were recorded.
To test if the model \verb"nox~equi+comp+equi:comp" requires a non-linear form \verb:equi:, that is, to test against the varying-coefficients alternative model \verb"nox~...+s(equi)+s(equi):comp", use:
<<varying>>=
data(nox)
sE<-bbase(nox$equi, bdeg=3, nint=10)
sEbyC<-model.matrix(~0+sE:factor(comp), data=nox)[,]
gt(nox~equi*factor(comp), alternative=cbind(sE,sEbyC), data=nox)
@

\subsection{Missed interactions}

Consider the \verb:boston: data for 506 census tracts of Boston from the 1970 census. Suppose
we want to predict the price of a house based on various attributes like number of
rooms, distance to employment, and neighborhood type. These covariates may interact,
e.g. the number of rooms might not be as important if the neighborhood has lots
of crime. For checking whether any two-way linear interaction effect has been missed,
use:
<<boston>>=
library(MASS)
data(Boston)
res<-gtLI(medv~., data=Boston)
res@result
round(weights(res)/sum(weights(res)),4)
@
To prevent very unbalanced interaction terms contributions in the test statistic, we recommend to
rescale the covariates to unit standard deviation by \verb"standardize=TRUE" or to center and scale the data:
<<>>=
gtLI(medv~., data=Boston, standardize=T)
gtLI(medv~., data=scale(Boston))
@


\section{Non-proportional hazards}

Different extensions of the Cox model have been proposed to deal with non-proportional
hazards. One possibility is the addition of an interaction
term of the covariates with a time function, leading to time-varying effects of
the covariates. This allows the effect of the covariates to change over time, such as the
effect of a treatment that might wash away. However, time-varying covariates are not yet implemented in the function \Rfunction{gt} (but are likely to be in the future).


\addcontentsline{toc}{chapter}{References}
\label{references}
\bibliography{GlobalTest}

\end{document}

\name{gt.options}

\alias{gt.options}

\title{Options for globaltest package}

\description{Sets various global options for the functions in the globaltest package.}

\usage{
gt.options (trace, trim, transpose, max.print, warn.deprecated)
}

\arguments{
    \item{trace}{(Default: \code{TRUE}). If \code{TRUE}, prints progress information whenever many tests are to be performed. Such printing of progress information involves the printing of backspace characters, which is not compatible with use of \code{Sweave}.}
    \item{trim}{(Default: \code{FALSE}). If \code{FALSE}, returns an error if covariates in the \code{subsets} argument of \code{gt} are not present in the data; if \code{TRUE}, silently removes these covariates, and remove duplicates.}
    \item{transpose}{(Default: \code{FALSE}). If \code{TRUE}, \code{gt} expects the transposed data format that is usual in genomics, in which the subjects correspond to the columns of the data matrix and the covariates (or probes) are the rows. If \code{FALSE}, \code{gt} expects the usual statistical format instead.}
    \item{max.print}{(Default: \code{Inf}). The maximum number of characters to print for the alias.}
    \item{warn.deprecated}{(Default: \code{TRUE}). Whether or not to give a warning when the deprecated \code{globaltest} function is called.}
}

\details{The globaltest options can be set during a session, and apply to all calls to functions in the globaltest package for the rest of the session. They are not remembered between sessions.
}

\author{Jelle Goeman: \email{j.j.goeman@lumc.nl}}

\seealso{The \code{\link{gt}} function.}

\examples{
  # setting options
  gt.options(max.print=45, trim=TRUE)

  # reading options
  gt.options()
}

\keyword{htest}

\name{Multiple testing methods of the globaltest package}

\alias{focusLevel}
\alias{findFocus}
\alias{inheritance}
\alias{leafNodes}
\alias{draw}


\title{Multiple testing correction for the Global Test}

\description{A collection of multiple testing procedures for the Global Test. Methods for the focus level procedure of Goeman and Mansmann for graph-structured hypotheses, and for the inheritance procedure based on Meinshausen.}

\usage{
# The focus level method:
focusLevel (test, sets, focus, ancestors, offspring,
           stop = 1, atoms = TRUE, trace)

findFocus (sets, ancestors, offspring, maxsize = 10, atoms = TRUE)


# The inheritance method:
inheritance (test, sets, weights, ancestors, offspring, Shaffer,
            homogeneous = TRUE, trace)


# Utilities for focus level and inheritance method:
leafNodes (object, alpha=0.05, type = c("focuslevel","inheritance"))

draw (object, alpha = 0.05, type = c("focuslevel","inheritance"),
      names=FALSE, sign.only = FALSE, interactive = FALSE)
}

\arguments{
    \item{object}{A \code{\link{gt.object}}, usually one in which more than one test was performed.}
    \item{test}{Either a \code{\link{function}} or \code{\link{gt.object}}. If a function, that function should take as its argument a vector of covariate labels, and return  (raw) p-value. See the examples below. If a \code{\link{gt.object}} the call to \code{\link{gt}} that created it must have had all the covariates of \code{sets} (below) in its \code{alternative} argument.}
    \item{sets}{A named \code{\link[base:list]{list}} representing covariate sets of the hypotheses of interest, for which adjusted p-values are to be calculated. If it is missing but \code{test} is
        a \code{\link{gt.object}}, the \code{subsets} slot of that
	object will be used. If used in the \code{inheritance},
	\code{sets} describe a tree structure of hypotheses. In this
	case, object of class \code{\link[stats:hclust]{hclust}} or
	\code{\link[stats:dendrogram]{dendrogram}}.}

    \item{focus}{The focus level of the focus level method. Must be a subset of \code{names(sets)}. Represents the level of the graph at which the method is focused,
        i.e. has most power.}
    \item{ancestors}{An environment or list that maps each set in \code{sets} to all its ancestors, i.e. its proper supersets. If missing, \code{ancestors} is determined
        from the input of \code{offspring}, or, if that is also missing, from the input of \code{sets} (time-consuming).}
    \item{offspring}{An environment or list that maps each set in \code{sets} to all its offspring, i.e. its proper subsets. If missing, \code{offspring} is determined
        from the input of \code{ancestors}, or, if that is also missing, from the input of \code{sets} (time-consuming).}
    \item{stop}{Determines when to stop the algorithm. If \code{stop} is set to a value smaller than or equal to 1, the algorithm only calculates familywise error rate corrected
        p-values of at most \code{stop}. If \code{stop} is set to a value greater than 1, the algorithm stops when it has rejected at least \code{stop} hypotheses. If set
        to exactly 1, the algorithm calculates all familywise error rate corrected p-values. Corrected p-values that are not calculated are reported as \code{NA}.}
    \item{atoms}{If set to \code{TRUE}, the focus level algorithm partitions the offspring of each focus level set into the smallest possible building blocks, called
        atoms. Doing this often greatly accelerates computation, but sometimes at the cost of some power.}
    \item{trace}{If set to \code{TRUE}, reports progress information. The default is obtained from \code{\link[=gt.options]{gt.options()$trace}}. Alternatively,
        setting \code{trace = 2} gives much more extensive output (\code{focusLevel} only).}
    \item{maxsize}{Parameter to choose the height of the focus level. The focus level sets are chosen in such a way that the number of tests that is to be done for each
        focus level set is at most \code{2^maxsize - 1}.}
    \item{alpha}{The alpha level of familywise error control for the significant subgraph.}
    \item{Shaffer}{If set to \code{TRUE}, it applys the Shaffer improvement. If \code{Shaffer} is \code{NULL} and \code{object} is a \code{\link{gt.object}} the procedure checks whether  \code{Shaffer=TRUE} is valid, and sets the value accordingly.}
    \item{weights}{Optional weights vector for the leaf nodes. If it is missing but \code{test} is a \code{\link{gt.object}}, the result of \code{\link{weights}(object)} will be used. In all other cases \code{weights} is set to be uniform among all leaf nodes.}
    \item{homogeneous}{If set to \code{TRUE}, redistributes the alpha of rejected leaf node hypotheses homogeneously over the hypotheses under test, rather than to closest related hypotheses.}
    \item{type}{Argument for specifying which multiple testing correction method should be used. Only relevant if both the inheritance and the focuslevel procedures were
        performed on the same set of test results.}
    \item{names}{If set to \code{TRUE}, draws the graph with node names rather than numbers.}
    \item{sign.only}{If set to \code{TRUE}, draws only the subgraph corresponding to the significant nodes. If \code{FALSE}, draws the full graph with the non-significant
        nodes grayed out.}
    \item{interactive}{If set to \code{TRUE}, creates an interactive graph in which the user can see the node label by clicking on the node.}
}

\details{Multiple testing correction becomes important if the Global Test is performed on many covariate subsets.

If the hypotheses are structured in such a way that many of the tested subsets are subsets of other sets, more powerful procedures can be applied that take advantage of this structure to gain power. Two methods are implemented in the \code{globaltest} package: the \code{inheritance} method for tree-structured hypotheses and the \code{focusLevel} method for general directed acyclic graphs. For simple multiple testing that does not use such structure, see \code{\link[=gt.object]{p.adjust}}.

The \code{focusLevel} procedure makes use of the fact that some sets are subsets or supersets of each other, as specified by the user in the \code{offspring} and
\code{ancestors} arguments. Viewing the subset and superset structure as a graph, the procedure starts testing at a \code{focus} level: a subset of the nodes of the graph.
If the procedure finds significance at this focus level, it proceeds to find significant subsets and supersets of the focus level sets. Like Holm's procedure, the focus
level procedure is valid regardless of the correlation structure between the test statistics.

The focus level method requires the choice of a ``focus level'' in the graph. The \code{findFocus} function is a utility function for automatically choosing a focus level. It chooses a collection of focus level sets in such a way that the number of tests to be done for each focus level node is at most \code{2^maxsize}. In practice this usually means that each focus level node has at most \code{maxsize} leaf nodes as offspring. Choosing focus level nodes with too many offspring nodes may result in excessively long computation times.

The \code{inheritance} method is an alternative method for calculating familywise error rate corrected p-values. Like the focus level method, \code{inheritance} also makes use of the structure of the tested sets to gain power. In this case, however, the graph is restricted to a tree, as can be obtained for example if the tested subsets are obtained from a hierarchical clustering. The inheritance procedure is used in the \code{\link{covariates}} function. Like Holm's method and the focus level method, the inheritance procedure makes no assumptions on the joint distribution of the test statistics.

The \code{leafNodes} function extracts the leaf nodes of the significant subgraph after a focus level procedure was performed. As this graph is defined by its leaf nodes, this is the most efficient summary of the test result. Only implemented for \code{\link{gt.object}} input.

The \code{draw} function draws the graph, displaying the significant nodes. It either draws the full graph with the non-significant nodes grayed out (\code{sign.only = TRUE}), or it draws only the subgraph corresponding to the significant nodes.

See the vignette for extensive applications. }

\note{
In the graph terminology of the focus level method, \code{ancestor} means superset, and \code{offspring} means subset.

The validity of the focus level procedure depends on certain assumptions on the null hypothesis that is tested for each set. See the paper by Goeman and Mansmann (cited below) for the precise assumptions. Similar assumptions are necessary for the Shaffer improvement of the inheritance procedure.}

\value{The function \code{multtest} returns an object of class
  \code{\link[globaltest:gt.object-class]{gt.object}} with an
  appropriate column added to the test results matrix.


The \code{focusLevel} and \code{inheritance} functions returns a
\code{\link{gt.object}} if a
\code{\link[globaltest:gt.object-class]{gt.object}} argument was given
as input, otherwise it returns a matrix with a column of raw p-values
and a column of corrected p-values.


The function \code{leafNodes} returns a
\code{\link[globaltest:gt.object-class]{gt.object}}.


\code{findFocus} returns a character vector.}

\references{ The methods used by multtest:

Holm (1979) A simple sequentially rejective multiple test procedure. Scandinavian Journal of Statistics 6: 65-70.

Benjamini and Hochberg (1995) Controlling the false discovery rate: a practical and powerful approach to multiple testing. Journal of the Royal Statistical Society, Series
B 57: 289-300.

Benjamini and Yekutieli (2001) The control of the false discovery rate in multiple testing under dependency. Annals of Statistics 29 (4) 1165-1188.

The focus level method:

Goeman and Mansmann (2008) Multiple testing on the directed acyclic graph of gene ontology. Bioinformatics 24 (4) 537-544.

The inheritance method:

Meinshausen (2008) Hierarchical testing of variable importance. Biometrika 95 (2), 265-278.

For references related to applications of the test, see the vignette GlobalTest.pdf included with this package.}


\author{Jelle Goeman: \email{j.j.goeman@lumc.nl}; Livio Finos}

\seealso{ The \code{\link{gt}} function. The \code{\link{gt.object}} function and useful functions associated with that object.

Many more examples in the vignette! }

\examples{
    # Simple examples with random data here
    # Real data examples in the Vignette

    # Random data: covariates A,B,C are correlated with Y
    set.seed(1)
    Y <- rnorm(20)
    X <- matrix(rnorm(200), 20, 10)
    X[,1:3] <- X[,1:3] + Y
    colnames(X) <- LETTERS[1:10]

    # Some subsets of interest
    my.sets1 <- list(abc = LETTERS[1:3], cde  = LETTERS[3:5],
                     fgh = LETTERS[6:8], hij = LETTERS[8:10])
    res <- gt(Y, X, subsets = my.sets1)

    # Simple multiple testing
    p.adjust(res)
    p.adjust(res, "BH")

    # A whole structure of sets
    my.sets2 <- as.list(LETTERS[1:10])
    names(my.sets2) <- letters[1:10]
    my.sets3 <- list(all = LETTERS[1:10])
    my.sets <- c(my.sets2,my.sets1,my.sets3)

    # Do the focus level procedure
    # Choose a focus level by hand
    my.focus <- c("abc","cde","fgh","hij")
    # Or automated
    my.focus <- findFocus(my.sets, maxsize = 8)
    resF <- focusLevel(res, sets = my.sets, focus = my.focus)
    leafNodes(resF, alpha = .1)

    # Compare
    p.adjust(resF, "holm")

    # Focus level with a custom test
    Ftest <- function(set) anova(lm(Y~X[,set]))[["Pr(>F)"]][1]
    focusLevel(Ftest, sets=my.sets, focus=my.focus)

    # analyze data using inheritance procedure
    res <- gt(Y, X, subsets = list(colnames(X)))
    # define clusters on the covariates X
    hcl=hclust(dist(t(X)))
    # Do inheritance procedure
    resI=inheritance(res, sets = hcl)
    resI
    leafNodes(resI, alpha = .1)

    # inheritance procedure with a custom test
    inheritance(Ftest, sets = hcl, Shaffer=TRUE)

}

\keyword{htest}

\name{gt}

\alias{gt}
\alias{globaltest}

\title{Global Test}

\description{Tests a low-dimensional null hypothesis against a potentially high-dimensional alternative in regression models (linear regression, logistic regression, poisson regression, Cox proportional hazards model).}

\usage{
gt(response, alternative, null, data, test.value,
     model = c("linear", "logistic", "cox", "poisson", "multinomial"), levels,
     directional = FALSE, standardize = FALSE, permutations = 0, subsets,
     weights, alias, x = FALSE, trace)
}

\arguments{
    \item{response}{The response vector of the regression model. May be
      supplied as a vector or as a \code{\link[stats:formula]{formula}}
      object. In the latter case, the right hand side of \code{response}
      is passed on to \code{alternative} if that argument is missing, or
      otherwise to \code{null}.}

    \item{alternative}{The part of the design matrix corresponding to
      the alternative hypothesis. The covariates of the null model do
      not have to be supplied again here. May be given as a half
      \code{\link[stats:formula]{formula}} object (e.g. \code{~a+b}). In
      that case the intercept is always suppressed. When using the dot in a formula, make sure to           avoid the half formula (\code{~.}, but repeat the response on the left hand side.
      Alternatively, the
      \code{alternative} argument may also be given as an
      \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} object,
      in which case \code{t(exprs(alternative))} is used for the
      \code{alternative} argument, and \code{pData(alternative)} is
      passed on to the \code{data} argument if that argument is
      missing.}

    \item{null}{The part of the design matrix corresponding to the null hypothesis. May be given as a design matrix or as a half \code{\link[stats:formula]{formula}} object (e.g. \code{~a+b}). The default for \code{null} is \code{~1}, i.e. only an intercept. This intercept may be suppressed, if desired, with \code{null = ~0}. When given as a half formula object, one may also specifiy strata (e.g. \code{~strata(a)+b})}).
    \item{data}{Only used when \code{response}, \code{alternative}, or \code{null} is given in formula form. An optional data frame, list or environment containing the variables used in the formulae. If the variables in a formula are not found in \code{data}, the variables are taken from environment(formula), typically the environment from which \code{gt} is called.}
    \item{test.value}{An optional vector regression coefficients to test. The default is to test the null hypothesis that all regression coefficients of the covariates of the alternative are zero. The \code{test.value} argument can be used to test a value other than zero. The coefficients are applied to the design matrix of \code{alternative} before any standardization (see the \code{standardize} argument).}
    \item{model}{The type of regression model to be tested. If omitted, the function will try to determine the model from the class and values of the \code{response} argument.}
    \item{levels}{Only used if response is \code{\link{factor}}. Selects a subset of \code{levels(response)} to be tested, given as a character vector. If a vector of length \code{>1}, the test uses only the subjects with the specified outcome categories. If \code{levels} is of length 1, the test reduces the response to a two-valued factor, testing the specified outcome category against the others combined.}
    \item{directional}{If set to \code{TRUE}, directs the power of the test especially against the alternative that the true regression coefficients under the alternative have the same sign. The default is that the power of the test does not depend on the sign of the true regression coefficients. Set negative \code{weights} for covariates that are expected to have opposite sign.}
    \item{standardize}{If set to \code{TRUE}, standardizes all covariates of the alternative to have unit second central moment. This makes sure that the test result is independent of the relative scaling of the covariates. The default is to let covariates with more variance have a greater weight in the test.}
    \item{permutations}{The number of permutations to use. The default, \code{permutations = 0}, uses the asymptotic distribution. The asymptotic distribution is the exact distribution in case of the linear model with normal errors.}
    \item{subsets}{Optional argument that can be used to test one or more subsets of the covariates in \code{alternative}. Can be a vector of column names or column indices of \code{alternative}, or a list of such vectors. In the latter case, a separate test will be performed for each subset.}
    \item{weights}{Optional argument that can be used to give certain covariates in \code{alternative} greater weight in the test. Can be a vector or a list of vectors. In the latter case, a separate test will be performed for each weight vector. If both \code{subsets} and \code{weights} are specified as a list, they must have the same length. In that case, \code{weights} vectors may have either the same length as the number of covariates in \code{alternative}, or the same length as the corresponding subset vector. Weights can be negative; the sign has no effect unless \code{directional} is \code{TRUE}.}
    \item{alias}{Optional second label for each test. Should be a vector of the same length as \code{subsets}. See also \code{\link{alias}}.}
    \item{x}{If \code{TRUE}, gives back the \code{null} and \code{alternative} design matrices. Default is not to return these matrices.}
    \item{trace}{If \code{TRUE}, prints progress information. This is useful if many tests are performed, i.e.\ if \code{subsets} or \code{weights} is a list. Note that printing progress information involves printing of backspace characters, which is not compatible with use of Sweave. Defaults to \code{\link{gt.options}}\code{()$trace}.}
}

\details{The Global Test tests a low-dimensional null hypothesis against a (potentially) high-dimensional alternative, using the locally most powerful test of Goeman et al (2006). In this regression model implementation, it tests the null hypothesis \code{response ~ null}, that the covariates in \code{alternative} are not associated with the response, against the alternative model \code{response ~ null + alternative} that they are.

The test has a wide range of applications. In \link[=gtGO]{gene set testing} in microarray data analysis \code{alternative} may be a matrix of gene expression measurements, and the aim is to find which of a collection of predefined \code{subsets} of the genes (e.g. Gene Ontology terms or KEGG pathways) is most associated with the \code{response}. In penalized regression or other machine learning techniques, \code{alternative} may be a collection of predictor variables that may be used to predict a \code{response}, and the test may function as a useful pre-test to see if training the classifier is worthwhile. In goodness-of-fit testing, \code{null} may be a model with linear terms fitted to the \code{response}, and \code{alternative} may be a large collection of non-linear terms. The test may be used in this case to test the fit of the null model with linear terms against a non-linear alternative.

See the vignette for extensive examples of these applications.
}

\note{If \code{null} is supplied as a \code{\link[stats:formula]{formula}} object, an intercept is automatically included. As a consequence \code{gt(Y, X, Z)} will usually give a different result from \code{gt(Y, X, ~Z)}. The first call is equivalent to \code{gt(Y, X, ~0+Z)}, whereas the second call is equivalent to \code{gt(Y, X, cbind(1,Z))}.

P-values from the asymptotic distribution are accurate to at least two decimal places up to a value of around \code{1e-12}. Lower p-values are numerically less reliable.

Missing values are allowed in the \code{alternative} matrix only. Missing values are imputed conservatively (i.e. under the null hypothesis). Covariates with many missing values get reduced variance and therefore automatically carry less weight in the test result.
}

\value{The function returns an object of class \code{\link{gt.object}}. Several operations and diagnostic plots can be made from this object. See also \link[=diagnostics]{Diagnostic plots}.}

\references{
General theory and properties of the global test are described in

Goeman, Van de Geer and Van Houwelingen (2006) Journal of the Royal Statistical Society, Series B 68 (3) 477-493.

For references related to applications of the test, see the vignette GlobalTest.pdf included with this package.}

\author{Jelle Goeman: \email{j.j.goeman@lumc.nl}; Jan Oosting}

\seealso{
Diagnostic plots: \code{\link{covariates}}, \code{\link{subjects}}.

The \code{\link{gt.object}} function and useful functions associated with that object.

Many more examples in the vignette!
}

\examples{
    # Simple examples with random data here
    # Real data examples in the Vignette

    # Random data: covariates A,B,C are correlated with Y
    set.seed(1)
    Y <- rnorm(20)
    X <- matrix(rnorm(200), 20, 10)
    X[,1:3] <- X[,1:3] + Y
    colnames(X) <- LETTERS[1:10]

    # Compare the global test with the F-test
    gt(Y, X)
    anova(lm(Y~X))

    # Using formula input
    res <- gt(Y, ~A+B, null=~C+E, data=data.frame(X))
    summary(res)

    # Beware: null models with and without intercept
    Z <- rnorm(20)
    summary(gt(Y, X, null=~Z))
    summary(gt(Y, X, null=Z))

    # Logistic regression
    gt(Y>0, X)

    # Subsets and weights (1)
    my.sets <- list(c("A", "B"), c("C","D"), c("D", "E"))
    gt(Y, X, subsets = my.sets)
    my.weights <- list(1:2, 2:1, 3:2)
    gt(Y, X, subsets = my.sets, weights=my.weights)

    # Subsets and weights (2)
    gt(Y, X, subset = c("A", "B"))
    gt(Y, X, subset = c("A", "A", "B"))
    gt(Y, X, subset = c("A", "A", "B"), weight = c(.5,.5,1))

    # Permutation testing
    summary(gt(Y, X, perm=1e4))
}

\keyword{htest}

\name{gt goodness of fit methods}

\alias{gtPS}
\alias{gtKS}
\alias{gtLI}
\alias{bbase}
\alias{btensor}
\alias{reparamZ}
\alias{reweighZ}
\alias{sterms}

\title{Goodness of fit testing in regression models using Global Test}

\description{
Tests the goodness of fit of a regression model against a specified alternative using the Global Test. 
Three main functions are provided: \code{gtPS} uses Penalized Splines, \code{gtKS} uses Kernel Smoothers and \code{gtLI} uses Linear Interactions. The other functions are for external use in combination with \code{gt}.}

\usage{
gtPS(response, null, data, 
      model = c("linear", "logistic", "cox", "poisson", "multinomial"),
      ..., covs, bdeg = 3, nint= 10, pord = 2, interact = FALSE, robust = FALSE, 
      termlabels = FALSE, returnZ = FALSE)
  
gtKS(response, null, data, 
      model = c("linear", "logistic", "cox", "poisson", "multinomial"),
      ..., covs, quant = .25, metric = c("euclidean", "pearson"), 
      kernel=c("uniform", "exponential", "triangular", "neighbours", "gauss"),
      robust = FALSE, scale = TRUE, termlabels = FALSE, returnZ = FALSE)
	
gtLI(response, null, data, ..., covs, iorder=2, termlabels = FALSE, standardize = FALSE)

bbase(x, bdeg, nint)

btensor(xs, bdeg, nint, pord, returnU=FALSE)

reparamZ(Z, pord, K=NULL, tol = 1e-10, returnU=FALSE)

reweighZ(Z, null.fit)

sterms(object, ...)

}

\arguments{
    \item{response}{The response vector of the regression model. May be
      supplied as a vector, as a \code{\link[stats:formula]{formula}} object, or as an object of class \code{\link[stats:lm]{lm}}, \code{\link[stats:glm]{glm}} or \code{\link[stats:lm]{coxph}}. In the last two cases, the specification of \code{null} is not required.}
    \item{null}{The null design matrix. May be given as a matrix or as a half \code{\link[stats:formula]{formula}} object (e.g. \code{~a+b}).}
    \item{data}{Only used when \code{response} or \code{null} is given in formula form. An optional data frame, list or environment containing the variables used in the formulae.}
    \item{model}{The type of regression model to be tested. If omitted, the function will try to determine the model from the class and values of the \code{response} argument.}
    \item{...}{Any other arguments are also passed on to \code{\link{gt}}.}
    \item{covs}{A variable or a vector of variables that are the covariates the smooth terms are function of.}
    \item{bdeg}{A vector or a list of vectors which specifies the degree of the B-spline basis, with default \code{bdeg=3}.}
    \item{nint}{A vector or a list of vectors which specifies  the number of intervals determined by equally-spaced knots, with default \code{nint=10}.}
    \item{pord}{A vector or a list of vectors which specifies  the order of the differences indicating the type of the penalty imposed to the coefficients, with default \code{pord=2}.}
    \item{interact}{\code{TRUE} to consider a multidimensional smooth function of \code{covs}.}
    \item{termlabels}{\code{TRUE} to consider e.g. \code{s(log(cov))} instead of \code{s(cov)} when \code{null=~ log(cov)} and \code{covs} is missing.}
    \item{robust}{\code{TRUE} to obtain an overall test which combines multiple specifications of the B-spline basis arguments (when \code{bdeg}, \code{nint} and \code{pord} are lists) or multiple specifications of the bandwidth (when \code{quant} is a vector of quantiles).}
    \item{returnZ}{\code{TRUE} gives back the alternative design matrix used in the test.}
    \item{quant}{The smoothing bandwidth to be used, expressed as the percentile of the distribution of distance between observations, with default the 25th percentile. To investigate the sensitivity to different choices, \code{quant} can be a vector of percentiles. See also \code{robust} argument.}
    \item{metric}{A character string specifying the metric to be used. The available options are "euclidean" (the default), "pearson" and "mixed" (to be implemented).
"mixed" distance is chosen automatically if some of the selected covariates are not numeric.}
    \item{kernel}{A character string giving the smoothing kernel to be used. This must be one of "uniform", "exponential", "triangular", "neighbours", or "Gauss", with default "uniform".}
    \item{scale}{\code{TRUE} to center and scale the covariates before computing the distance.}
    \item{iorder}{Order of the linear interactions, e.g. second order interactions, third order etc., with default \code{iorder=2}.}
    \item{standardize}{TRUE standardizes all covariates of the alternative to have unit second central moment. This makes sure that the test result is independent of the relative scaling of the covariates.}
    \item{x}{A numeric vector of values at which to evaluate the B-spline basis.}
    \item{xs}{A matrix or dataframe where the columns correspond to covariates values.}
    \item{returnU}{code{TRUE} gives back the nonpenalized part.}
    \item{Z}{Alternative design matrix.}
    \item{K}{Penalty matrix (i.e. the penalty term is the quadratic form of K and the spline coefficients).}
    \item{tol}{Eigenvalues smaller than \code{tol} are considered zero.}
    \item{null.fit}{Fitted null model.}
    \item{object}{A \code{\link{gt.object}} from \code{\link{gtPS}}, \code{\link{gtKS}} or \code{\link{gtLI}}.}
}

\details{


These are functions to test for specific types of lack of fit by using the Global Test. 
Suppose that we are concerned with the adequacy of some regression model \code{response ~ null}, such as \code{Y ~ X1 + X2}.
The alternative model can be cast into the generic form \code{response ~ null + alternative}, which comprises different models that accomodate to different types of lack of fit. Thus, the specification of \code{alternative} is required. It identifies the type of lack of fit the test is directed against.

By using \code{gtPS}, the alternative is given by a user specified sum of smooth functions of continuous covariates, 
e.g.  \code{alternative= ~ s(X1)} when \code{covs="X1"} and \code{alternative= ~ s(X1) + s(X2)} when \code{covs=c("X1","X2")}.
Smooth terms are constructed using P-splines as proposed by Eilers and Marx (1996). This approach consists in constructing 
a B-spline basis of degree \code{bdeg} with \code{nint + 1} equidistant knots, where a difference penalty of order \code{pord} is applied to the basis coefficients. If \code{interact=TRUE}, the alternative is given by a multidimensional smooth function of \code{covs}, which is represented by a tensor product of marginal B-splines bases and Kronecker sum of the marginal penalties, e.g. \code{alternative= ~ s(X1,X2)} when \code{covs=c("X1","X2")} and \code{interact=TRUE}.

By using \code{gtKS} the alternative is given by a user specified multidimensional smooth term, e.g. \code{alternative= ~ s(X1, X2)} when \code{covs=c("X1","X2")}. 
Multidimensional smooth terms are represented by a kernel smoother defined by a distance measure (\code{metric}), a kernel shape (\code{kernel}) and a bandwidth (\code{quant}). 
Because the test is sensitive to the chosen value of \code{quant}, it is possible to specify \code{quant} as a vector of different values in combination with \code{robust=TRUE}. 
Distance measures for factor covariates and for the situation that both continuous and factor covariates are present are constructed as in le Cessie and van Houwelingen (1995), e.g. \code{covs=c("X1","X2")} and \code{distance="mixed"} when \code{X1} continuous and \code{X2} factor (to be implemented). 

By using \code{gtLI}, the alternative is given by all the possible ith-order linear interactions between \code{covs}, e.g. \code{alternative= ~ X1:X2 + X1:X3 + X2:X3} when \code{covs=c("X1","X2","X3")} and \code{iorder=2}. 

The remaining functions are meant for constructing the alternative design matrix that will be used in the \code{alternative} argument of the \code{gt} function. 
\code{bbase} constructs the B-spline basis for the covariate \code{x}. This function is based on the functions provided by Eilers and Marx (1996).
\code{btensor} builts a tensor product of B-splines for the covariates \code{xs}, which is reparameterized according with a Kroneker sum of penalties. 
\code{reparamZ} reparameterizes the alternative design matrix (e.g. a spline basis \code{B}) according with the order of differences \code{pord} or via the spectral decomposition of a roughness matrix \code{K}. When several smooth terms are to be combined, \code{reweighZ} assigns equal weight to each component term. 

See the vignette for more examples.
}

\section{Methods}{
  \describe{
    \item{sterms}{(gt.object): Prints the smooth terms specified by \code{\link{gtPS}}, \code{\link{gtKS}} or \code{\link{gtLI}}.}
    }
}


\note{Currently linear (normal), logistic, multinomial logistic and Poisson regression models with canonical links and Cox's proportional hazards regression model are supported.
}

\value{The function returns an object of class \code{\link{gt.object}}. Several operations and diagnostic plots can be made from this object.}

\references{

Eilers, Marx (1996).
Flexible smoothing with B-splines and penalties.
Statistical Science, 11: 89-121.

le Cessie, van Houwelingen (1995). Testing the Fit of a Regression Model Via Score Tests in Random Effects Models.
Biometrics 51: 600-614.

For references related to applications of the test, see the vignette GlobalTest.pdf included with this package.}

\author{Aldo Solari: \email{aldo.solari@unimib.it}}

\seealso{
The \code{\link{gt}} function. The \code{\link{gt.object}} and useful functions associated with that object.
}

\examples{

 # Random data
    set.seed(0)
    X1<-runif(50)
    s1 <- function(x) exp(2 * x)
    e <- rnorm(50)
    Y <-  s1(X1) + e
    
    ### gtPS
    res<-gtPS(Y~X1)
    res@result
    sterms(res)
    
    # model input
    rdata<-data.frame(Y,X1)
    nullmodel<-lm(Y~X1,data=rdata)
    gtPS(nullmodel)
    
    # formula input and termlabels
    gtPS(Y~exp(2*X1),data=rdata)
    gtPS(Y~exp(2*X1),covs="exp(2 * X1)",data=rdata)
    sterms(gtPS(Y~exp(2*X1),data=rdata,termlabels=TRUE))
    
    # P-splines arguments 
    gtPS(Y~X1, bdeg=3, nint=list(a=10, b=30), pord=0)
    gtPS(Y~X1, bdeg=3, nint=list(a=10, b=30), pord=0, robust=TRUE)

    # Random data: additive model 
    X2<-runif(50)
    s2 <- function(x) 0.2 * x^11 * (10 * (1 - x))^6 + 10 * (10 * x)^3 * (1 - x)^10
    Y <-  s1(X1) + s2(X2) + e
    gtPS(Y~X1+X2)
    gtPS(Y~X1+X2, covs="X2")
    sterms(gtPS(Y~X1+X2, nint=list(a=c(10,30), b=20)))
    
    # Random data: smooth surface
    s12 <- function(a, b, sa = 1, sb = 1) {
            (pi^sa * sb) * (1.2 * exp(-(a - 0.2)^2/sa^2 - (b - 0.3)^2/sb^2) + 
            0.8 * exp(-(a - 0.7)^2/sa^2 - (b - 0.8)^2/sb^2))
            }
    Y <- s12(X1,X2) + e
    
    # Tensor product of P-splines
    res<-gtPS(Y~X1*X2, interact=TRUE)
    res@result
    sterms(res)

    ### gtKS  
    res<-gtKS(Y~X1*X2)
    res@result
    sterms(res)
    gtKS(Y~X1*X2, quant=seq(.05,.95,.05), robust=TRUE)
    
    ### gtLI  
    library(MASS)
    data(Boston)
    gtLI(medv~., data=Boston, standardize=TRUE)

}

\keyword{goodness-of-fit}

\name{Diagnostic plots for globaltest}

\alias{covariates}
\alias{features}
\alias{subjects}
\alias{diagnostics}


\title{Global Test diagnostic plots}

\description{Plots to visualize the result of a Global Test in terms of the contributions of the covariates and the subjects.}

\usage{
covariates(object,
            what = c("p-value", "statistic", "z-score", "weighted"),
            cluster = "average", alpha = 0.05, sort = TRUE, zoom = FALSE,
            legend = TRUE, plot = TRUE, colors, alias, help.lines = FALSE,
            cex.labels = 0.6, ylim, pdf, trace)

features(...)

subjects(object,
            what = c("p-value", "statistic", "z-score", "weighted"),
            cluster = "average", sort = TRUE, mirror = TRUE,
            legend = TRUE, colors, alias, help.lines = FALSE,
            cex.labels = 0.6, ylim, pdf)
}


\arguments{
    \item{object}{A \code{\link{gt.object}}, usually created by a call to \code{\link{gt}}. The object must contain only a single test result, unless the \code{pdf} argument is used. See the help page of \code{\link{gt.object}} on reducing such an object in case it contains more than one test.}
    \item{what}{Gives a choice between various presentations of the same plot. See below under details.}
    \item{cluster}{The type of hierarchical clustering performed for the dendrogram. Default is average linkage clustering. For other options, see \code{\link[stats:hclust]{hclust}}. Setting \code{cluster = "none"} or \code{cluster = FALSE} suppresses the dendrogram altogether.}
    \item{alpha}{Parameter between 0 and 1. Sets the level of family-wise error control in the multiple testing procedure performed on the dendrogram. See below under details.}
    \item{sort}{If \code{TRUE}, the plot sorts the bars with the most significant covariates and subjects to the left, as far as is possible within the constraints of the dendrogram (if present).}
    \item{zoom}{If \code{TRUE}, discards non-significant branches from the dendrogram with the corresponding covariates. This is especially useful for large sets to "zoom" in on the significant results. If no dendrogram is requested, \code{zoom = TRUE} discards all covariates that are not significant after Holm multiple testing correction.}
    \item{legend}{If \code{TRUE}, draws a legend in the plot. To override the default labels of the legend, \code{legend} may also be given as a character vector with the labels of the legend.}
    \item{plot}{If \code{FALSE}, suppress all plotting.}
    \item{colors}{The colors to be used for the bars. See \code{\link[grDevices:rgb]{rgb}} for details on color specification.}
    \item{alias}{Optional alternative labels for the bars in the plots. Should be a character vector of the same length as the number of covariates or subjects, respectively.}
    \item{help.lines}{If \code{TRUE}, prints grey dotted lines that help connect the dendrogram to the bars.}
    \item{cex.labels}{Magnification factor for the x-axis labels.}
    \item{ylim}{Override for the y axis limits of the barplot.}
    \item{pdf}{Optional filename (\code{character}) of the pdf file to which the plots are to be written. If a filename is provided in \code{pdf}, many \code{covariates} or \code{subjects} plots of multiple tests can be made with a single call to \code{covariates} or \code{subjects}, writing the results to a pdf file.}
    \item{trace}{If \code{TRUE}, prints progress information. Note that printing progress information involves printing of backspace characters, which is not compatible with use of Sweave. Defaults to \code{\link{gt.options}}\code{()$trace}.}
    \item{mirror}{If \code{TRUE}, plots the reverse of the scores for the subjects with negative residual response, so that "good" scores are positive for all subjects.}
    \item{...}{All arguments of \code{features} are identical to those of \code{covariates}.}
}

\details{These two diagnostic plots decompose the test statistics into the contributions of the different covariates and subjects to make the influence of these covariates and subjects visible.

The \code{covariates} plot exploits the fact that the global test statistic for a set of alternative covariates can be written as a weighted sum of the global test statistics for each single contributing covariate. By displaying these component global test results in a bar plot the \code{covariates} plot gives insight into the subset of covariates that is most responsible for the significant test result. The plot can show the \code{p-values} of the component tests on a reversed log scale (the default); their test \code{statistics}, with stripes showing their mean and standard deviation under the null hypothesis; the \code{z-scores} of these test statistics, standardized to mean zero and standard deviation one; or the \code{weighted} test statistics, where the test statistics are multiplied by the relative weight that each covariate carries in the overall test. See the Vignette for more details.

The dendrogram of the \code{covariates} plot is based on correlation distance if the \code{directional} argument was set to \code{TRUE} in the call to \code{\link{gt}}, and uses absolute correlation distance otherwise. The coloring of the dendrogram is based on the multiple testing procedure of Meinshausen (2008): this procedure controls the family-wise error rate on all \code{2n-1} hypotheses associated with the subsets of covariates induced by the clustering graph. All significant subsets are colored black; non-significant ones remain grey. This coloring serves as an additional aid to find the subsets of the covariates most contributing to a significant test result.

The \code{features} function is a synonym for \code{covariates}, using exactly the same arguments.

The \code{subjects} plot exploits the fact that the global test can be written as a sum of contributions of each individual. Each of these contributions is itself a test statistic for the same null hypothesis as the full global test, but one which puts a greater weight on the observed information of a specific subject. These test statistic of subject \code{i} is significant if, for the other subjects, similarity in the alternative covariates to subject \code{i} tends to coincide with similarity in residual response to subject \code{i}. Like the \code{covariates} plot, the \code{subjects} plot can show the \code{p-values} of these component tests on a reversed log scale (the default); their test \code{statistics}, with stripes showing their mean and standard deviation under the null hypothesis; the \code{z-scores} of these test statistics, standardized to mean zero and standard deviation one; or the \code{weighted} test statistics, where the test statistics are multiplied by the relative weight that each covariate carries in the overall test. Setting \code{mirror=FALSE} reverses the bars of subjects with a negative residual response (not applicable if \code{p-values} are plotted). The resulting \code{statistics} values have the additional interpretation that they are proportional to the first order estimates of the linear predictors of each subject under the alternative, i.e. subjects with positive values have higher means under the alternative than under the null, and subjects with negative values have lower means under the alternative than under the null. See the Vignette for more details.

The dendrogram of the \code{subjects} plot is always based on correlation distance. There is no analogue to Meinshausen's multiple testing method for this dendrogram, so multiple testing is not performed.
}

\note{The term "z-score" is not meant to imply a normal distribution, but just refers to a studentized score. The z-scores of the \code{subjects} plot are asymptotically normal under the null hypothesis; the z-scores of the \code{covariates} plot are asymptotically distributed as a chi-squared variable with one degree of freedom.
}

\value{If called to make a single plot, the \code{covariates} function returns an object of class \code{\link{gt.object}}. Several methods are available to access this object: see \code{\link{gt.object}}. The \code{subjects} function returns a matrix. If called to make multiple plots, both functions return \code{NULL}.}

\references{
General theory and properties of the global test are described in

Goeman, Van de Geer and Van Houwelingen (2006) Journal of the Royal Statistical Society, Series B 68 (3) 477-493.

Meinshausen's method for multiple testing

Meinshausen (2008) Biometrika 95 (2) 265-278.

For more references related to applications of the test, see the vignette GlobalTest.pdf included with this package.}

\author{Jelle Goeman: \email{j.j.goeman@lumc.nl}; Livio Finos.}

\seealso{
Diagnostic plots: \code{\link{covariates}}, \code{\link{subjects}}.

The \code{\link{gt.object}} function and useful functions associated with that object.

Many more examples in the vignette!
}

\examples{
    # Simple examples with random data here
    # Real data examples in the Vignette

    # Random data: covariates A,B,C are correlated with Y
    set.seed(1)
    Y <- rnorm(20)
    X <- matrix(rnorm(200), 20, 10)
    X[,1:3] <- X[,1:3] + Y
    colnames(X) <- LETTERS[1:10]

    # Preparation: test
    res <- gt(Y,X)

    # Covariates
    covariates(res)
    covariates(res, what = "w")
    covariates(res, zoom = TRUE)

    # Subjects
    subjects(res)
    subjects(res, what = "w", mirror = FALSE)

    # Change legend, colors or labels
    covariates(res, legend = c("upregulated", "downregulated"))
    covariates(res, col = rainbow(2))
    covariates(res, alias = letters[1:10])

    # Extract data from the plot
    out <- covariates(res)
    result(out)
    extract(out)
}

\keyword{htest}

\name{mlogit}

\alias{mlogit}
\alias{mlogit-class}
\alias{residuals,mlogit-method}
\alias{fitted.values,mlogit-method}
\alias{coefficients,mlogit-method}
\alias{summary,mlogit-method}
\alias{show,mlogit-method}

\title{Multinomial Logistic Regression}

\description{Fits a multinomial logistic regression model to a nominal scale outcome.}

\usage{mlogit(formula, data, control = glm.control())}

\arguments{
    \item{formula}{An object of class \code{\link[stats:formula]{formula}}
containing a symbolic description of the model to be fit. See the documentation
of \code{\link[stats:formula]{formula}} for details.}
    \item{data}{An optional data frame containing the variables in the model.
If not found in 'data', the variables are taken from the environment from which
'mlogit' is called.}
    \item{control}{A list of parameters for controlling the fitting process.
See the documentation of \code{\link[stats:glm.control]{glm.control}} for details.} }

\details{The function mlogit fits a multinomial logistic regression
model for a multi-valued outcome with nominal scale. The
implementation and behaviour are designed to mimic those of
\code{\link[stats:glm]{glm}}, but the options are (as yet) more
limited. Missing values are not allowed in the data.

The model is fitted without using a reference outcome category; the
parameters are made identifiable by the requirement that the sum of
corresponding regression coefficients over the outcome categories is
zero.}

\value{An object of (S4) class \code{mlogit}. The class has slots:
coefficients (matrix), standard.err (matrix), fitted.values
(matrix), x (matrix), y (matrix), formula (formula), call (call),
df.null (numeric), df.residual (numeric), null.deviance (numeric),
deviance (numeric), iter (numeric), converged (logical).

Methods implemented for the \code{mlogit} class are
\code{coefficients}, \code{fitted.values}, \code{residuals} and
which extract the relevant quantities, and \code{summary}, which
gives the same output as with a \code{\link[stats:glm]{glm}}
object.}

\author{Jelle Goeman: \email{j.j.goeman@lumc.nl}; Jan Oosting}

\seealso{\code{\link{glm}}, \code{\link[nnet:multinom]{multinom}}.}

\examples{
  y <- factor(rep(1:4, 5))
  x <- 1:20
  fit <- mlogit(y ~ x)
  summary(fit)
  residuals(fit)
}

\keyword{nonlinear}

\name{Comparative proportions}

\alias{comparative}

\title{Comparative proportions for the Global Test}

\description{Comparing the result of a global test performed on a subset to the test results of random subsets of the same size.}

\usage{
comparative(object, N = 1e3, z.scores = TRUE, trace)
}

\arguments{
    \item{object}{A \code{\link{gt.object}}, usually one in which one or more subsets of a large number of covariates were tested.}
    \item{N}{The number of random subsets to generate.}
    \item{z.scores}{If set to \code{TRUE}, compares the subset to random subsets on the basis of the z-scores of the test. If \code{FALSE}, uses the p-values instead.}
    \item{trace}{If set to \code{TRUE}, reports progress information. The default is to set trace to \code{TRUE} if R is in \code{\link{interactive}} mode and more than one comparative proportion is to be calculated.}
}

\details{In a situation when many covariates out of a large set are associated with the response, it is sometimes interesting to know p-value of the tested subset compares to random subsets of the same size. The \code{comparative} function calculates the proportion of random subsets of the covariates of the same size as the tested subset that have a better score than the tested subset. This proportion is a diagnostic tool to help interpret the test result; it should not be interpreted as a p-value.
}

\value{An object of class \code{\link{gt.object}} with an appropriate column added to the test results matrix.}

\references{
The comparative proportion is an enrichment type analysis. For the pros and cons of such an analysis, see

Goeman and Buhlmann (2007) Analyzing gene expression data in terms of gene sets: methodological issues. Bioinformatics 23 (8) 980-987.
}

\author{Jelle Goeman: \email{j.j.goeman@lumc.nl}; Jan Oosting}

\seealso{
The \code{\link{gt}} function. The \code{\link{gt.object}} function and useful functions associated with that object.
}

\examples{
    # Simple examples with random data here
    # Real data examples in the Vignette

    # Random data: covariates A,B,C are correlated with Y
    set.seed(1)
    Y <- rnorm(20)
    X <- matrix(rnorm(200), 20, 10)
    X[,1:3] <- X[,1:3] + Y
    colnames(X) <- LETTERS[1:10]

    # Some subsets of interest
    my.sets <- list(c("A", "B"), c("C","D"), c("D", "E"))

    # Comparative proportions
    res <- gt(Y, X, subsets = my.sets)
    comparative(res)
    comparative(res, z.scores=FALSE)
}

\keyword{htest} 

\name{gt gene set testing methods}

\alias{gtGO}
\alias{gtKEGG}
\alias{gtKEGGREST}
\alias{gtBroad}
\alias{gtConcept}

\title{Gene set testing of gene set databases using Global Test}

\description{A collection of procedures for performing the Global Test on gene set databases. Three function are provided for KEGG, for Gene Ontology and for the Broad Institute's gene sets.}

\usage{
gtKEGG (response, exprs, ..., id, annotation, probe2entrez,
           multtest = c("Holm", "BH", "BY"), sort = TRUE)

gtGO (response, exprs, ..., id, annotation, probe2entrez,
           ontology = c("BP", "CC", "MF"), minsize=1, maxsize=Inf,
           multtest = c("Holm", "focuslevel", "BH", "BY"),
           focuslevel = 10, sort = TRUE)

gtConcept (response, exprs, ..., annotation, probe2entrez,
           conceptmatrix, concept2name = "conceptID2name.txt",
           entrez2concept = "entrezGeneToConceptID.txt", threshold = 1e-4,
           share = TRUE, multtest = c("Holm", "BH", "BY"),
           sort = TRUE)

gtBroad (response, exprs, ..., id, annotation, probe2entrez, collection,
           category = c("c1", "c2", "c3", "c4", "c5"),
           multtest = c("Holm", "BH", "BY"), sort = TRUE)

}

\arguments{
    \item{response}{The response variable of the regression model. This is passed on to the \code{response} argument of \code{\link{gt}}.}
    \item{exprs}{The expression measurements. May be
      \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} or
      matrix. Passed on to the \code{alternative} argument of
      \code{\link{gt}}.}

    \item{...}{Any other arguments are also passed on to \code{\link{gt}}.}
    \item{id}{The identifier(s) of gene sets to be tested (character vector). If omitted, tests all gene sets in the database.}
    \item{annotation}{The name of the probe annotation package for the microarray that was used, or the name of the genome wide annotation package for the species (e.g. org.Hs.eg.db for human). If an organism package is given, the argument \code{probe2entrez} must be supplied. If \code{annotation} is missing, the function will  attempt to retrieve the annotation information from the \code{exprs} argument.}
    \item{probe2entrez}{Use only if no probe annotation package is available. A mapping from probe identifiers to entrez gene ids. May be an environment, named list or named vector.}
    \item{multtest}{The method of multiple testing correction. Choose from: Benjamini and Hochberg FDR control (BH); Benjamini and Yekutieli FDR control (BY) or Holm familywise error fontrol (Holm). For \code{gtGO} also the focus level method is available. See \code{\link{focusLevel}}.}
    \item{sort}{If \code{TRUE}, sorts the results to increasing p-values.}
    \item{ontology}{The ontology or ontologies to be used. Default is to use all three ontologies.}
    \item{minsize}{The minimum number of probes that may be annotated to a gene set. Gene sets with fewer annotated probes are discarded.}
    \item{maxsize}{The maximum number of probes that may be annotated to a gene set. Gene sets with more annotated probes are discarded.}
    \item{focuslevel}{The focus level to be used for the focus level method. Either a vector of gene set ids, or a numerical level. In the latter case, \code{\link{findFocus}} is called with \code{maxsize} at the specified level to find a focus level.}
    \item{collection}{The Broad gene set collection, created by a call to \code{\link[GSEABase:getObjects]{getBroadSets}}.}
    \item{conceptmatrix}{The name of the file containing the importance weights, i.e. concept profile associations between Anni concepts. In the matrix contained in the file, columns correspond to testable concepts, and rows correspond to entrez-concepts. Useable files can be downloaded from \url{http://biosemantics.org/index.php/software/weighted-global-test}.}
    \item{concept2name}{The name of the file containing a mapping between Anni concepts and entrez identifiers. Useable files can be downloaded from \url{http://biosemantics.org/index.php/software/weighted-global-test}.}
    \item{entrez2concept}{The name of the file containing a mapping between Anni concept numbers and names. Useable files can be downloaded from \url{http://biosemantics.org/index.php/software/weighted-global-test}.}
    \item{threshold}{The relevance threshold for importance weights. Importance weights below the threshold are treated as zero.}
    \item{share}{If \code{TRUE}, the function divides the importance weight of a gene over all probes corresponding to the same entrez identifier. If \code{FALSE}, all probes get the full importance weight of the gene.}
    \item{category}{The subcategory of the Broad collection to be tested. The default is to test all sets.}
}

\details{These are utility functions to make it easier to do gene set testing of gene sets available in gene set databases. The functions automatically retrieve the gene sets, preprocess and select them, perform global test, do multiple testing correction, and sort the results on the basis of their p-values.

The four functions use different databases for testing. \code{gtKEGG} and \code{gtGO} use KEGG (\url{http://www.genome.jp/kegg}) and GO (\url{http://www.geneontology.org}); \code{gtConcept} uses the Anni database (\url{http://www.biosemantics.org/anni}), and \code{gtBroad} uses the MSigDB database (\url{http://www.broadinstitute.org/gsea/msigdb}). The \code{gtConcept} function differs from the other three in that it uses association weights between 0 and 1 for genes within sets, rather than having a hard cut-off for membership of a gene in a set.

All functions require that \code{annotate} and the appropriate annotation packages are installed. \code{gtKEGG} additionally requires the \code{KEGG.db} package; \code{gtGO} requires the \code{GO.db} package; \code{gtBroad} requires the user to download the XML file "msigdb_v2.5.xml"
from \\ \code{http://www.broad.mit.edu/gsea/downloads.jsp}, and to preprocess that file using the \code{\link[GSEABase:getObjects]{getBroadSets}} function. \code{gtConcept} requires files that can be downloaded from \url{http://biosemantics.org/index.php/software/weighted-global-test}.
}

\value{A \code{\link{gt.object}}.}

\references{
Goeman, Van de Geer, De Kort and Van Houwelingen (2004). A global test for groups of genes: testing association with a clinical outcome. Bioinformatics 20 (1) 93-99.

Goeman, Oosting, Cleton-Jansen, Anninga and Van Houwelingen (2005). Testing association of a pathway with survival using gene expression data. Bioinformatics 21 (9) 1950-1957.
}

\author{Jelle Goeman: \email{j.j.goeman@lumc.nl}; Jan Oosting}

\seealso{
The \code{\link{gt}} function. The \code{\link{gt.object}} and useful functions associated with that object.
}

\examples{
    # Examples in the Vignette
}

\keyword{htest}

\name{gt.object class}
\docType{class}
\alias{p.value}
\alias{gt.object}
\alias{result}
\alias{size}
\alias{subsets}
\alias{extract}
\alias{gt.object-class}
\alias{show,gt.object-method}
\alias{summary,gt.object-method}
\alias{size,gt.object-method}
\alias{[,gt.object-method}
\alias{[,gt.object,ANY,ANY,ANY-method}
\alias{[[,gt.object-method}
\alias{length,gt.object-method}
\alias{p.adjust,gt.object-method}
\alias{weights,gt.object-method}
\alias{hist,gt.object-method}
\alias{result,gt.object-method}
\alias{subsets,gt.object-method}
\alias{model.matrix,gt.object-method}
\alias{p.value,gt.object-method}
\alias{z.score}
\alias{z.score,gt.object-method}
\alias{names,gt.object-method}
\alias{names<-,gt.object-method}
\alias{alias,gt.object-method}
\alias{alias<-}
\alias{alias<-,gt.object-method}
\alias{sort,gt.object-method}
\alias{extract,gt.object-method}
\alias{sterms,gt.object-method}

\title{Class "gt.object" for storing the result of the function gt}

\description{The class gt.object is the output of a call to
\code{\link{gt}}. It stores the information needed for various diagnostic plots. }

\section{Slots}{
  These slots are not meant to be directly accessed by the user.
  \describe{
    \item{\code{result}:}{Object of class "matrix". The number of rows of this matrix is the number of tests performed. The matrix has at least the columns "p-value", "Statistic" "Expected", "Std.dev", and "#Cov".}
    \item{\code{extra}:}{Object of class "data.frame". Holds additional information that may be added later about the tests performed, such as multiplicity-adjusted p-values (see \code{\link{p.adjust}}), alias names for tests and comparative proportions (see \code{\link{comparative}}).}
    \item{\code{call}:}{The matched call to \code{\link{gt}}.}
    \item{\code{functions}:}{A "list" of various functions used by the \code{\link{covariates}} and \code{\link{subjects}} functions and the various methods.}
    \item{\code{subsets}:}{A "list" or "NULL". Stores the subsets tested, if more than one.}
    \item{\code{structure}:}{A "list" or "NULL". Stores subset and superset relationships between the sets in the "subsets" slot.}
    \item{\code{weights}:}{A "list" or "NULL". Stores the weight vectors used for testing, if more than one.}
    \item{\code{alternative}:}{If \code{\link{gt}} was called with \code{x = TRUE}, stores the design matrix of the alternative hypothesis; "NULL" otherwise.}
    \item{\code{null}:}{If \code{\link{gt}} was called with \code{x = TRUE}, stores the design matrix of the null hypothesis; "NULL" otherwise.}
    \item{\code{directional}}{Stores the \code{directional} argument of the call to \code{\link{gt}}.}
    \item{\code{legend}}{Object of class "list". Stores appropriate legends for the \code{\link{covariates}} and \code{\link{subjects}} plots.}
    \item{\code{model}}{Object of class "character". Stores the model.}
  }
}

\section{Methods}{
  \describe{
    \item{show}{(gt.object): Prints the test results: p-value, test statistic, expected value of the test statistic under the null hypothesis, standard deviation of the test statistic under the null hypothesis, and number of covariates tested.}
    \item{summary}{(gt.object): Prints the test results (as \code{show}) plus additional information on the model and the test.}
    \item{p.value}{(gt.object): Extracts the p-values.}
    \item{z.score}{(gt.object): Extracts z-score: (Test statistic - Expected value) / Standard deviation.}
    \item{result}{(gt.object): Extracts the results matrix together with the additional (e.g. multiple testing) information in the \code{extra} slot.}
    \item{extract}{(gt.object): Extracts the results matrix for the leaf nodes after a call to \code{link{covariates}}, with information on direction of association.}
    \item{sort}{(gt.object): Sorts the pathways to increasing p-values. Equal p-values are sorted on decreasing z-scores.}
    \item{"["}{(gt.object): Extracts results of one or more test results if multiple tests were performed. Identical to "[[".}
    \item{"[["}{(gt.object): Extracts results of one or more test results if multiple tests were performed. Identical to "[".}
    \item{length}{(gt.object): The number of tests performed.}
    \item{size}{(gt.object): Extracts a vector with the number of alternative covariates tested for each test.}
    \item{names}{(gt.object): Extracts the row names of the results matrix.}
    \item{names<-}{(gt.object): Changes the row names of the results matrix. Duplicate names are not allowed, but see \code{alias}.}
    \item{alias}{(gt.object): Extracts the "alias" column of the results matrix that can be used to add additional information on each test perfomed.}
    \item{alias<-}{(gt.object): Changes the "alias" column of the results matrix. Note that unlike for names, duplicate aliases are allowed.}
    \item{weights}{(gt.object): extracts the effective weights of the covariates as they are used internally by the test.}
    \item{subsets}{(gt.object): extracts the "subsets" slot.}
    \item{hist}{(gt.object): Produces a histogram to visualize the permutation test statistics. Only relevant after permutation testing.}
    \item{covariates}{(gt.object): Produces a plot to show the influence of individual covariates on the test result. See \code{\link{covariates}} for details.}
    \item{subjects}{(gt.object): Produces a plot to show the influence of individual subjects on the test result. See \code{\link{subjects}} for details.}
    \item{p.adjust}{(gt.object): Performs multiple testing correction and produces multiplicity-corrected p-values. See \code{\link{p.adjust}} for details.}
    \item{comparative}{(gt.object): Compares the p-values of tests performed on a subsets or weights with p-values of random subsets of covariates of same size or randomly distributed weights.  See \code{\link{comparative}} for details.}
    \item{sterms}{(gt.object): Prints the smooth terms specified by \code{\link{gtPS}},  \code{\link{gtKS}} or \code{\link{gtLI}}.}
    }
}

\author{Jelle Goeman: \email{j.j.goeman@lumc.nl}; Jan Oosting}

\seealso{\code{\link{gt}}, \code{\link{covariates}}, \code{\link{subjects}}.}

\keyword{methods}


\examples{
    # Simple examples with random data here
    # Real data examples in the Vignette

    # Random data: covariates A,B,C are correlated with Y
    Y <- rnorm(20)
    X <- matrix(rnorm(200), 20, 10)
    X[,1:3] <- X[,1:3] + 0.5*Y
    colnames(X) <- LETTERS[1:10]

    # Make a gt.object
    sets <- list(odd = c(1,3,5,7,9), even = c(2,4,6,8,10))
    res <- gt(Y, X, subsets=sets)

    # Show the results
    res
    summary(res)
    sort(res)
    p.value(res)
    subsets(res)

    # Names
    names(res)
    names(res) <- c("ODD", "EVEN")
    alias(res) <- c("odd covariates", "even covariates")

    # Multiple testing
    p.adjust(res, method = "holm")
    p.adjust(res, method = "BH")

    # Diagnostics
    weights(res)
    covariates(res[1])
    extract(covariates(res[1]))
    subjects(res[1])

    # Permutation testing
    res <- gt(Y, X, perm = 1e4)
    hist(res)

} 
